/*! For license information please see view-file.js.LICENSE.txt */
!function(){var e={4353:function(e,t,n){var r=n(4015),o=n(3645)(r);o.push([e.id,"\n.editor-container[data-v-aed02304] {\n  border: 1px solid #ced4da;\n}\n.editor-toolbar[data-v-aed02304] {\n  position: absolute;\n  right: 0;\n  z-index: 1;\n}\n","",{version:3,sources:["webpack://./kadi/assets/scripts/lib/components/WorkflowEditor.vue"],names:[],mappings:";AA8FA;EACA,yBAAA;AACA;AAEA;EACA,kBAAA;EACA,QAAA;EACA,UAAA;AACA",sourcesContent:['\x3c!-- Copyright 2020 Karlsruhe Institute of Technology\n   -\n   - Licensed under the Apache License, Version 2.0 (the "License");\n   - you may not use this file except in compliance with the License.\n   - You may obtain a copy of the License at\n   -\n   -     http://www.apache.org/licenses/LICENSE-2.0\n   -\n   - Unless required by applicable law or agreed to in writing, software\n   - distributed under the License is distributed on an "AS IS" BASIS,\n   - WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   - See the License for the specific language governing permissions and\n   - limitations under the License. --\x3e\n\n<template>\n  <div ref="container">\n    <div v-if="toolsEndpoint">\n      <div class="modal-backdrop show" v-if="toolDialogActive"></div>\n      <div class="modal" tabindex="-1" ref="toolDialog">\n        <div class="modal-dialog modal-dialog-centered modal-lg">\n          <div class="modal-content">\n            <div class="modal-body">\n              <dynamic-pagination placeholder="No tools."\n                                  filter-placeholder="Filter tools by filename"\n                                  :endpoint="toolsEndpoint"\n                                  :per-page="5"\n                                  :enable-filter="true">\n                <template #default="props">\n                  <div class="d-flex justify-content-between mb-4">\n                    <div>\n                      <strong>Tools</strong>\n                      <span class="badge badge-pill badge-light text-muted border border-muted">{{ props.total }}</span>\n                    </div>\n                    <button type="button" class="close" data-dismiss="modal">\n                      <i class="fas fa-xs fa-times"></i>\n                    </button>\n                  </div>\n                  <ul class="list-group" v-if="props.total > 0">\n                    <li class="list-group-item bg-light py-2">\n                      <div class="row">\n                        <div class="col-lg-5">File</div>\n                        <div class="col-lg-5">Tool</div>\n                      </div>\n                    </li>\n                    <li class="list-group-item py-2" v-for="item in props.items" :key="item.file.id">\n                      <div class="row align-items-center">\n                        <div class="col-lg-5">\n                          <strong>{{ item.file.name }}</strong>\n                          <br>\n                          @{{ item.record.identifier }}\n                        </div>\n                        <div class="col-lg-5">\n                          <strong>{{ item.tool.name }}</strong>\n                          <span v-if="item.tool.version">\n                            <br>\n                            Version {{ item.tool.version }}\n                          </span>\n                        </div>\n                        <div class="col-lg-2 d-flex justify-content-end">\n                          <div>\n                            <button class="btn btn-light btn-sm" @click="addTool(item.tool)">\n                              <i class="fas fa-plus"></i>\n                            </button>\n                          </div>\n                        </div>\n                      </div>\n                    </li>\n                  </ul>\n                </template>\n              </dynamic-pagination>\n            </div>\n          </div>\n        </div>\n      </div>\n    </div>\n    <div class="card editor-container" :class="{\'bg-light\': !editable}" ref="editorContainer">\n      <div class="editor-toolbar mt-1 mr-1" ref="editorToolbar">\n        <button title="Reset view" type="button" class="btn btn-link text-muted" @click="resetView">\n          <i class="fas fa-eye"></i>\n        </button>\n        <button title="Toggle fullscreen" type="button" class="btn btn-link text-muted" @click="toggleFullscreen">\n          <i class="fas fa-expand"></i>\n        </button>\n        <button title="Reset editor" type="button" class="btn btn-link text-muted" v-if="editable" @click="resetEditor">\n          <i class="fas fa-broom"></i>\n        </button>\n      </div>\n      <div ref="editor"></div>\n    </div>\n    <slot :editor="editor"></slot>\n  </div>\n</template>\n\n<style scoped>\n.editor-container {\n  border: 1px solid #ced4da;\n}\n\n.editor-toolbar {\n  position: absolute;\n  right: 0;\n  z-index: 1;\n}\n</style>\n\n<script>\nimport \'regenerator-runtime\';\n\nimport AreaPlugin from \'rete-area-plugin\';\nimport ConnectionPlugin from \'rete-connection-plugin\';\nimport ContextMenuPlugin from \'rete-context-menu-plugin\';\nimport VueRenderPlugin from \'rete-vue-render-plugin\';\n\nimport WorkflowEditor from \'scripts/lib/workflows/editor\';\nimport Menu from \'scripts/lib/workflows/core/Menu.vue\';\nimport controlComponents from \'scripts/lib/workflows/components/control-components\';\nimport fileIoComponents from \'scripts/lib/workflows/components/file-io-components\';\nimport sourceComponents from \'scripts/lib/workflows/components/source-components\';\nimport userInputComponents from \'scripts/lib/workflows/components/user-input-components\';\nimport userOutputComponents from \'scripts/lib/workflows/components/user-output-components\';\nimport {ToolComponent} from \'scripts/lib/workflows/components/core\';\n\nimport \'styles/workflows/workflow-editor.scss\';\n\nexport default {\n  data() {\n    return {\n      version: \'kadi@0.1.0\',\n      editor: null,\n      area: null,\n      unsavedChanges_: false,\n      toolDialogActive: false,\n      menuItems: {},\n      currX: 0,\n      currY: 0,\n      resizeHandler: null,\n      beforeunloadHandler: null,\n    };\n  },\n  props: {\n    editable: {\n      type: Boolean,\n      default: true,\n    },\n    workflowUrl: {\n      type: String,\n      default: null,\n    },\n    toolsEndpoint: {\n      type: String,\n      default: null,\n    },\n    unsavedChanges: {\n      type: Boolean,\n      default: false,\n    },\n    isRendered: {\n      type: Boolean,\n      default: true,\n    },\n    enableDebugMenu: {\n      type: Boolean,\n      default: false,\n    },\n  },\n  watch: {\n    workflowUrl() {\n      this.loadWorkflow();\n    },\n    unsavedChanges() {\n      this.unsavedChanges_ = this.unsavedChanges;\n    },\n    unsavedChanges_() {\n      this.$emit(\'unsaved-changes\', this.unsavedChanges_);\n    },\n    isRendered() {\n      this.resizeView(false);\n    },\n  },\n  methods: {\n    isFullscreen() {\n      return document.fullScreen || document.mozFullScreen || document.webkitIsFullScreen;\n    },\n    resetView() {\n      this.area.zoomAt(this.editor);\n    },\n    toggleFullscreen() {\n      if (this.isFullscreen()) {\n        document.exitFullscreen();\n      } else {\n        this.$refs.container.requestFullscreen();\n      }\n    },\n    resetEditor() {\n      if (!confirm(\'Are you sure you want to reset the editor?\')) {\n        return;\n      }\n      this.editor.clear();\n      this.unsavedChanges_ = false;\n    },\n    resizeView(resetView = true) {\n      // In case the component is not marked as rendered from the outside we do not attempt to resize it.\n      if (!this.isRendered) {\n        return;\n      }\n\n      const width = this.$refs.editorContainer.getBoundingClientRect().width;\n      if (this.isFullscreen()) {\n        this.$refs.editorContainer.style.height = \'100vh\';\n        this.$refs.editorContainer.style.borderRadius = \'0\';\n      } else {\n        this.$refs.editorContainer.style.height = `${Math.round(window.innerHeight / window.innerWidth * width)}px`;\n        this.$refs.editorContainer.style.borderRadius = \'0.25rem\';\n      }\n      this.editor.view.resize();\n\n      if (resetView) {\n        this.resetView();\n      }\n    },\n    loadWorkflow() {\n      if (!this.workflowUrl) {\n        return;\n      }\n\n      axios.get(this.workflowUrl)\n        .then((response) => {\n          // Catch errors in the custom conversion function as well.\n          try {\n            this.editor.fromFlow(response.data)\n              .then((success) => {\n                if (!success) {\n                  kadi.alert(\'Could not fully reconstruct workflow.\', {type: \'warning\'});\n                }\n              })\n              .catch((error) => {\n                console.error(error);\n                kadi.alert(\'Error parsing workflow data.\');\n              })\n              .finally(() => this.resetView());\n          } catch (error) {\n            console.error(error);\n            kadi.alert(\'Error parsing workflow data.\');\n          }\n        });\n    },\n    addTool(tool) {\n      const componentName = ToolComponent.nameFromTool(tool);\n\n      if (!this.editor.components.has(componentName)) {\n        this.editor.register(new ToolComponent(tool));\n      }\n\n      this.addNode(this.editor.components.get(componentName));\n    },\n    async addNode(component) {\n      const node = await component.createNode();\n\n      node.position[0] = this.currX;\n      node.position[1] = this.currY;\n\n      this.editor.addNode(node);\n    },\n  },\n  mounted() {\n    this.editor = new WorkflowEditor(this.version, this.$refs.editor);\n    this.area = AreaPlugin;\n\n    // Disable some events if the editor is not editable.\n    if (!this.editable) {\n      let handler = (e) => {\n        // Do not disable the toolbar.\n        if (!Array.from(this.$refs.editorToolbar.getElementsByTagName(\'*\')).includes(e.target)) {\n          e.preventDefault();\n          e.stopPropagation();\n        }\n      };\n      this.$refs.editorContainer.addEventListener(\'click\', handler, {capture: true});\n\n      handler = (e) => {\n        if (e.target !== this.$refs.editor) {\n          e.preventDefault();\n          e.stopPropagation();\n        }\n      };\n      this.$refs.editorContainer.addEventListener(\'pointerdown\', handler, {capture: true});\n      this.$refs.editorContainer.addEventListener(\'pointerup\', handler, {capture: true});\n\n      handler = (e) => {\n        e.preventDefault();\n        e.stopPropagation();\n      };\n      this.$refs.editorContainer.addEventListener(\'dblclick\', handler, {capture: true});\n      this.$refs.editorContainer.addEventListener(\'contextmenu\', handler, {capture: true});\n    }\n\n    // Register plugins.\n    this.editor.use(AreaPlugin);\n    this.editor.use(ConnectionPlugin);\n    this.editor.use(VueRenderPlugin);\n    this.editor.use(ContextMenuPlugin, {\n      vueComponent: Menu,\n      searchBar: true,\n      delay: 0,\n      items: this.menuItems,\n      allocate: () => null,\n    });\n\n    // Register components.\n    [\n      ...sourceComponents,\n      ...controlComponents,\n      ...fileIoComponents,\n      ...userInputComponents,\n      ...userOutputComponents,\n    ].forEach((c) => this.editor.register(c));\n\n    // Setup context menu.\n    if (this.toolsEndpoint) {\n      this.menuItems[\'Select Tools...\'] = () => {\n        this.toolDialogActive = true;\n        $(this.$refs.toolDialog).modal({backdrop: false});\n      };\n      $(this.$refs.toolDialog).on(\'hidden.bs.modal\', () => {\n        this.toolDialogActive = false;\n      });\n    }\n\n    for (const component of this.editor.components.values()) {\n      if (!this.menuItems[component.menu]) {\n        this.menuItems[component.menu] = {};\n      }\n      this.menuItems[component.menu][component.name] = () => this.addNode(component);\n    }\n\n    if (this.enableDebugMenu) {\n      this.menuItems.Debug = {\n        /* eslint-disable no-console */\n        \'Dump Flow\': () => console.info(this.editor.toFlow()),\n        \'Dump JSON\': () => console.info(this.editor.toJSON()),\n        /* eslint-enable no-console */\n      };\n    }\n\n    // Register custom events.\n    this.editor.on(\'click\', () => {\n      this.editor.selected.clear();\n      this.editor.nodes.map((n) => n.update());\n    });\n\n    this.editor.on(\'zoom\', ({source}) => {\n      return source !== \'dblclick\';\n    });\n\n    this.editor.bind(\'controlchanged\');\n    this.editor.on(\'controlchanged nodecreated noderemoved nodetranslated connectioncreated connectionremoved\', () => {\n      if (!this.editor.silent) {\n        this.unsavedChanges_ = true;\n      }\n    });\n\n    this.editor.on(\'showcontextmenu\', ({e}) => {\n      const area = this.editor.view.area;\n      const rect = area.el.getBoundingClientRect();\n\n      // Store the mouse position at the time the context menu was opened.\n      this.currX = (e.clientX - rect.left) / area.transform.k;\n      this.currY = (e.clientY - rect.top) / area.transform.k;\n    });\n\n    // Finish initializion.\n    this.resizeView();\n    this.loadWorkflow();\n\n    this.resizeHandler = window.addEventListener(\'resize\', this.resizeView);\n    /* eslint-disable consistent-return */\n    this.beforeunloadHandler = window.addEventListener(\'beforeunload\', (e) => {\n      if (this.unsavedChanges_) {\n        e.preventDefault();\n        (e || window.event).returnValue = \'\';\n        return \'\';\n      }\n    });\n    /* eslint-enable consistent-return */\n  },\n  beforeDestroy() {\n    if (this.resizeHandler) {\n      window.removeEventListener(\'resize\', this.resizeHandler);\n    }\n    if (this.beforeunloadHandler) {\n      window.removeEventListener(\'beforeunload\', this.beforeunloadHandler);\n    }\n  },\n};\n<\/script>\n'],sourceRoot:""}]),e.exports=o},9611:function(e,t,n){var r=n(4015),o=n(3645)(r);o.push([e.id,"\n.input[data-v-64888255] {\n  width: 60px;\n}\n","",{version:3,sources:["webpack://./kadi/assets/scripts/lib/workflows/controls/PortControl.vue"],names:[],mappings:";AAsBA;EACA,WAAA;AACA",sourcesContent:['\x3c!-- Copyright 2021 Karlsruhe Institute of Technology\n   -\n   - Licensed under the Apache License, Version 2.0 (the "License");\n   - you may not use this file except in compliance with the License.\n   - You may obtain a copy of the License at\n   -\n   -     http://www.apache.org/licenses/LICENSE-2.0\n   -\n   - Unless required by applicable law or agreed to in writing, software\n   - distributed under the License is distributed on an "AS IS" BASIS,\n   - WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   - See the License for the specific language governing permissions and\n   - limitations under the License. --\x3e\n\n<template>\n  <div>\n    <span class="mr-2">{{ title }}</span>\n    <input class="input" type="number" v-model.number="value" @pointerdown.stop>\n  </div>\n</template>\n\n<style scoped>\n.input {\n  width: 60px;\n}\n</style>\n\n<script>\nimport {InputControlMixin} from \'core\';\n\nexport default {\n  mixins: [InputControlMixin],\n  props: {\n    title: String,\n    defaultValue: Number,\n  },\n  methods: {\n    validateValue() {\n      if (isNaN(this.value)) {\n        this.value = this.defaultValue;\n      } else if (this.value > 99) {\n        this.value = 99;\n      } else if (this.value < 0) {\n        this.value = 0;\n      } else {\n        this.value = Math.floor(this.value);\n      }\n    },\n  },\n};\n<\/script>\n'],sourceRoot:""}]),e.exports=o},2975:function(e,t,n){var r=n(4015),o=n(3645)(r);o.push([e.id,".connection{overflow:visible !important;pointer-events:none;position:absolute;z-index:-1}.connection .main-path{fill:none;stroke:#c9c9c9;stroke-width:3px}.connection>*{pointer-events:all}.item{background-color:#f8f8f8;border-left:1px solid #c9c9c9;border-right:1px solid #c9c9c9;color:#2e2e2e;cursor:pointer;padding:4px;position:relative;width:175px}.item:hover{background-color:#e3e3e3}.item:first-child{border-top:1px solid #c9c9c9;border-top-left-radius:3px;border-top-right-radius:3px}.item:last-child{border-bottom:1px solid #c9c9c9;border-bottom-left-radius:3px;border-bottom-right-radius:3px}\n","",{version:3,sources:["webpack://./kadi/assets/styles/workflows/workflow-editor.scss"],names:[],mappings:"AAsBA,YACE,2BAA4B,CAC5B,mBAAoB,CACpB,iBAAkB,CAClB,UAAW,CAJb,uBAOI,SAAU,CACV,cAhB+B,CAiB/B,gBAAiB,CATrB,cAaI,kBAAmB,CACpB,MAID,wBAAyB,CACzB,6BA3BiC,CA4BjC,8BA5BiC,CA6BjC,aAzBoB,CA0BpB,cAAe,CACf,WAAY,CACZ,iBAAkB,CAClB,WA/BwB,CAuB1B,YAWI,wBAAyB,CAX7B,kBAeI,4BAxC+B,CAyC/B,0BAxCoB,CAyCpB,2BAzCoB,CAwBxB,iBAqBI,+BA9C+B,CA+C/B,6BA9CoB,CA+CpB,8BA/CoB",sourcesContent:['/* Copyright 2020 Karlsruhe Institute of Technology\n *\n * Licensed under the Apache License, Version 2.0 (the "License");\n * you may not use this file except in compliance with the License.\n * You may obtain a copy of the License at\n *\n *     http://www.apache.org/licenses/LICENSE-2.0\n *\n * Unless required by applicable law or agreed to in writing, software\n * distributed under the License is distributed on an "AS IS" BASIS,\n * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n * See the License for the specific language governing permissions and\n * limitations under the License. */\n\n$context-menu-accent-color: #c9c9c9;\n$context-menu-round: 3px;\n$context-menu-width: 175px;\n\n$socket-color: #2e2e2e;\n$socket-margin: 5px;\n$socket-size: 20px;\n\n.connection {\n  overflow: visible !important;\n  pointer-events: none;\n  position: absolute;\n  z-index: -1;\n\n  .main-path {\n    fill: none;\n    stroke: $context-menu-accent-color;\n    stroke-width: 3px;\n  }\n\n  > * {\n    pointer-events: all;\n  }\n}\n\n.item {\n  background-color: #f8f8f8;\n  border-left: 1px solid $context-menu-accent-color;\n  border-right: 1px solid $context-menu-accent-color;\n  color: $socket-color;\n  cursor: pointer;\n  padding: 4px;\n  position: relative;\n  width: $context-menu-width;\n\n  &:hover {\n    background-color: #e3e3e3;\n  }\n\n  &:first-child {\n    border-top: 1px solid $context-menu-accent-color;\n    border-top-left-radius: $context-menu-round;\n    border-top-right-radius: $context-menu-round;\n  }\n\n  &:last-child {\n    border-bottom: 1px solid $context-menu-accent-color;\n    border-bottom-left-radius: $context-menu-round;\n    border-bottom-right-radius: $context-menu-round;\n  }\n}\n'],sourceRoot:""}]),e.exports=o},3903:function(e,t,n){var r=n(4015),o=n(3645)(r);o.push([e.id,".connection[data-v-39e4b361]{overflow:visible !important;pointer-events:none;position:absolute;z-index:-1}.connection .main-path[data-v-39e4b361]{fill:none;stroke:#c9c9c9;stroke-width:3px}.connection>*[data-v-39e4b361]{pointer-events:all}.item[data-v-39e4b361],.item .subitems .subitem[data-v-39e4b361]{background-color:#f8f8f8;border-left:1px solid #c9c9c9;border-right:1px solid #c9c9c9;color:#2e2e2e;cursor:pointer;padding:4px;position:relative;width:175px}.item[data-v-39e4b361]:hover,.item .subitems .subitem[data-v-39e4b361]:hover{background-color:#e3e3e3}.item[data-v-39e4b361]:first-child,.item .subitems .subitem[data-v-39e4b361]:first-child{border-top:1px solid #c9c9c9;border-top-left-radius:3px;border-top-right-radius:3px}.item[data-v-39e4b361]:last-child,.item .subitems .subitem[data-v-39e4b361]:last-child{border-bottom:1px solid #c9c9c9;border-bottom-left-radius:3px;border-bottom-right-radius:3px}.hasSubitems.item[data-v-39e4b361]:after,.item .subitems .hasSubitems.subitem[data-v-39e4b361]:after{content:'>';opacity:0.6;position:absolute;right:5px;top:5px}.item .subitems[data-v-39e4b361],.item .subitems .subitem .subitems[data-v-39e4b361]{left:100%;position:absolute;top:0;width:120px}\n","",{version:3,sources:["webpack://./kadi/assets/styles/workflows/workflow-editor.scss","webpack://./kadi/assets/scripts/lib/workflows/core/Item.vue"],names:[],mappings:"AAsBA,6BACE,2BAA4B,CAC5B,mBAAoB,CACpB,iBAAkB,CAClB,UAAW,CAJb,wCAOI,SAAU,CACV,cAhB+B,CAiB/B,gBAAiB,CATrB,+BAaI,kBAAmB,CCGvB,iEDEE,wBAAyB,CACzB,6BA3BiC,CA4BjC,8BA5BiC,CA6BjC,aAzBoB,CA0BpB,cAAe,CACf,WAAY,CACZ,iBAAkB,CAClB,WA/BwB,CCsB1B,6EDYI,wBAAyB,CCZ7B,yFDgBI,4BAxC+B,CAyC/B,0BAxCoB,CAyCpB,2BAzCoB,CCuBxB,uFDsBI,+BA9C+B,CA+C/B,6BA9CoB,CA+CpB,8BA/CoB,CC0BtB,qGACE,WAAY,CACZ,WAAY,CACZ,iBAAkB,CAClB,SAAU,CACV,OAAQ,CARZ,qFAYI,SAAU,CACV,iBAAkB,CAClB,KAAM,CACN,WAAY",sourcesContent:['/* Copyright 2020 Karlsruhe Institute of Technology\n *\n * Licensed under the Apache License, Version 2.0 (the "License");\n * you may not use this file except in compliance with the License.\n * You may obtain a copy of the License at\n *\n *     http://www.apache.org/licenses/LICENSE-2.0\n *\n * Unless required by applicable law or agreed to in writing, software\n * distributed under the License is distributed on an "AS IS" BASIS,\n * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n * See the License for the specific language governing permissions and\n * limitations under the License. */\n\n$context-menu-accent-color: #c9c9c9;\n$context-menu-round: 3px;\n$context-menu-width: 175px;\n\n$socket-color: #2e2e2e;\n$socket-margin: 5px;\n$socket-size: 20px;\n\n.connection {\n  overflow: visible !important;\n  pointer-events: none;\n  position: absolute;\n  z-index: -1;\n\n  .main-path {\n    fill: none;\n    stroke: $context-menu-accent-color;\n    stroke-width: 3px;\n  }\n\n  > * {\n    pointer-events: all;\n  }\n}\n\n.item {\n  background-color: #f8f8f8;\n  border-left: 1px solid $context-menu-accent-color;\n  border-right: 1px solid $context-menu-accent-color;\n  color: $socket-color;\n  cursor: pointer;\n  padding: 4px;\n  position: relative;\n  width: $context-menu-width;\n\n  &:hover {\n    background-color: #e3e3e3;\n  }\n\n  &:first-child {\n    border-top: 1px solid $context-menu-accent-color;\n    border-top-left-radius: $context-menu-round;\n    border-top-right-radius: $context-menu-round;\n  }\n\n  &:last-child {\n    border-bottom: 1px solid $context-menu-accent-color;\n    border-bottom-left-radius: $context-menu-round;\n    border-bottom-right-radius: $context-menu-round;\n  }\n}\n',"\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n@import 'styles/workflows/workflow-editor.scss';\n\n.item {\n  @extend .item;\n\n  &.hasSubitems:after {\n    content: '>';\n    opacity: 0.6;\n    position: absolute;\n    right: 5px;\n    top: 5px;\n  }\n\n  .subitems {\n    left: 100%;\n    position: absolute;\n    top: 0;\n    width: 120px;\n\n    .subitem {\n      @extend .item;\n    }\n  }\n}\n"],sourceRoot:""}]),e.exports=o},8342:function(e,t,n){var r=n(4015),o=n(3645)(r);o.push([e.id,".connection[data-v-608f70a6]{overflow:visible !important;pointer-events:none;position:absolute;z-index:-1}.connection .main-path[data-v-608f70a6]{fill:none;stroke:#c9c9c9;stroke-width:3px}.connection>*[data-v-608f70a6]{pointer-events:all}.item[data-v-608f70a6],.context-menu .search[data-v-608f70a6]{background-color:#f8f8f8;border-left:1px solid #c9c9c9;border-right:1px solid #c9c9c9;color:#2e2e2e;cursor:pointer;padding:4px;position:relative;width:175px}.item[data-v-608f70a6]:hover,.context-menu .search[data-v-608f70a6]:hover{background-color:#e3e3e3}.item[data-v-608f70a6]:first-child,.context-menu .search[data-v-608f70a6]:first-child{border-top:1px solid #c9c9c9;border-top-left-radius:3px;border-top-right-radius:3px}.item[data-v-608f70a6]:last-child,.context-menu .search[data-v-608f70a6]:last-child{border-bottom:1px solid #c9c9c9;border-bottom-left-radius:3px;border-bottom-right-radius:3px}.context-menu[data-v-608f70a6]{left:0;margin-left:-87.5px;margin-top:-20px;padding:10px;position:fixed;top:0;width:175px;z-index:1000}\n","",{version:3,sources:["webpack://./kadi/assets/styles/workflows/workflow-editor.scss","webpack://./kadi/assets/scripts/lib/workflows/core/Menu.vue"],names:[],mappings:"AAsBA,6BACE,2BAA4B,CAC5B,mBAAoB,CACpB,iBAAkB,CAClB,UAAW,CAJb,wCAOI,SAAU,CACV,cAhB+B,CAiB/B,gBAAiB,CATrB,+BAaI,kBAAmB,CACpB,8DAID,wBAAyB,CACzB,6BA3BiC,CA4BjC,8BA5BiC,CA6BjC,aAzBoB,CA0BpB,cAAe,CACf,WAAY,CACZ,iBAAkB,CAClB,WA/BwB,CAuB1B,0EAWI,wBAAyB,CAX7B,sFAeI,4BAxC+B,CAyC/B,0BAxCoB,CAyCpB,2BAzCoB,CAwBxB,oFAqBI,+BA9C+B,CA+C/B,6BA9CoB,CA+CpB,8BA/CoB,CC6DxB,+BACE,MAAO,CACP,mBAAqC,CACrC,gBAAiB,CACjB,YAAa,CACb,cAAe,CACf,KAAM,CACN,WDnEwB,CCoExB,YAAa",sourcesContent:['/* Copyright 2020 Karlsruhe Institute of Technology\n *\n * Licensed under the Apache License, Version 2.0 (the "License");\n * you may not use this file except in compliance with the License.\n * You may obtain a copy of the License at\n *\n *     http://www.apache.org/licenses/LICENSE-2.0\n *\n * Unless required by applicable law or agreed to in writing, software\n * distributed under the License is distributed on an "AS IS" BASIS,\n * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n * See the License for the specific language governing permissions and\n * limitations under the License. */\n\n$context-menu-accent-color: #c9c9c9;\n$context-menu-round: 3px;\n$context-menu-width: 175px;\n\n$socket-color: #2e2e2e;\n$socket-margin: 5px;\n$socket-size: 20px;\n\n.connection {\n  overflow: visible !important;\n  pointer-events: none;\n  position: absolute;\n  z-index: -1;\n\n  .main-path {\n    fill: none;\n    stroke: $context-menu-accent-color;\n    stroke-width: 3px;\n  }\n\n  > * {\n    pointer-events: all;\n  }\n}\n\n.item {\n  background-color: #f8f8f8;\n  border-left: 1px solid $context-menu-accent-color;\n  border-right: 1px solid $context-menu-accent-color;\n  color: $socket-color;\n  cursor: pointer;\n  padding: 4px;\n  position: relative;\n  width: $context-menu-width;\n\n  &:hover {\n    background-color: #e3e3e3;\n  }\n\n  &:first-child {\n    border-top: 1px solid $context-menu-accent-color;\n    border-top-left-radius: $context-menu-round;\n    border-top-right-radius: $context-menu-round;\n  }\n\n  &:last-child {\n    border-bottom: 1px solid $context-menu-accent-color;\n    border-bottom-left-radius: $context-menu-round;\n    border-bottom-right-radius: $context-menu-round;\n  }\n}\n',"\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n@import 'styles/workflows/workflow-editor.scss';\n\n.context-menu {\n  left: 0;\n  margin-left: -$context-menu-width / 2;\n  margin-top: -20px;\n  padding: 10px;\n  position: fixed;\n  top: 0;\n  width: $context-menu-width;\n  z-index: 1000;\n\n  .search {\n    @extend .item\n  }\n}\n"],sourceRoot:""}]),e.exports=o},2449:function(e,t,n){var r=n(4015),o=n(3645)(r);o.push([e.id,".connection[data-v-36a5d6d0]{overflow:visible !important;pointer-events:none;position:absolute;z-index:-1}.connection .main-path[data-v-36a5d6d0]{fill:none;stroke:#c9c9c9;stroke-width:3px}.connection>*[data-v-36a5d6d0]{pointer-events:all}.item[data-v-36a5d6d0]{background-color:#f8f8f8;border-left:1px solid #c9c9c9;border-right:1px solid #c9c9c9;color:#2e2e2e;cursor:pointer;padding:4px;position:relative;width:175px}.item[data-v-36a5d6d0]:hover{background-color:#e3e3e3}.item[data-v-36a5d6d0]:first-child{border-top:1px solid #c9c9c9;border-top-left-radius:3px;border-top-right-radius:3px}.item[data-v-36a5d6d0]:last-child{border-bottom:1px solid #c9c9c9;border-bottom-left-radius:3px;border-bottom-right-radius:3px}.node[data-v-36a5d6d0]{background:rgba(247,247,247,0.8);border:2px solid #2e2e2e;border-radius:0.75rem;box-sizing:border-box;color:#2e2e2e;cursor:pointer;height:auto;min-width:150px;padding-bottom:10px;padding-top:10px;position:relative;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.node.tool[data-v-36a5d6d0]{background:rgba(44,62,80,0.9);color:white}.node[data-v-36a5d6d0]:hover,.node.selected[data-v-36a5d6d0]{background:rgba(227,227,227,0.8)}.node:hover.tool[data-v-36a5d6d0],.node.selected.tool[data-v-36a5d6d0]{background:rgba(34,49,64,0.9)}.node .content[data-v-36a5d6d0]{display:table;width:100%}.node .content .column[data-v-36a5d6d0]{display:table-cell;white-space:nowrap}.node .content .column[data-v-36a5d6d0]:not(:last-child){padding-right:20px}.node .control[data-v-36a5d6d0]{padding:5px 15px}.node .input[data-v-36a5d6d0]{margin-bottom:5px;margin-top:5px;text-align:left}.node .output[data-v-36a5d6d0]{margin-bottom:5px;margin-top:5px;text-align:right}\n","",{version:3,sources:["webpack://./kadi/assets/styles/workflows/workflow-editor.scss","webpack://./kadi/assets/scripts/lib/workflows/core/Node.vue"],names:[],mappings:"AAsBA,6BACE,2BAA4B,CAC5B,mBAAoB,CACpB,iBAAkB,CAClB,UAAW,CAJb,wCAOI,SAAU,CACV,cAhB+B,CAiB/B,gBAAiB,CATrB,+BAaI,kBAAmB,CACpB,uBAID,wBAAyB,CACzB,6BA3BiC,CA4BjC,8BA5BiC,CA6BjC,aAzBoB,CA0BpB,cAAe,CACf,WAAY,CACZ,iBAAkB,CAClB,WA/BwB,CAuB1B,6BAWI,wBAAyB,CAX7B,mCAeI,4BAxC+B,CAyC/B,0BAxCoB,CAyCpB,2BAzCoB,CAwBxB,kCAqBI,+BA9C+B,CA+C/B,6BA9CoB,CA+CpB,8BA/CoB,CCwDxB,uBACE,gCAAwB,CACxB,wBAAyB,CACzB,qBAAsB,CACtB,qBAAsB,CACtB,aAAc,CACd,cAAe,CACf,WAAY,CACZ,eAAgB,CAChB,mBAAoB,CACpB,gBAAiB,CACjB,iBAAkB,CAClB,wBAAa,CAAb,qBAAa,CAAb,oBAAa,CAAb,gBAAiB,CAZnB,4BAeI,6BAAwB,CACxB,WAAY,CAhBhB,6DAoBI,gCAAwB,CApB5B,uEAuBM,6BAAwB,CAvB9B,gCA4BI,aAAc,CACd,UAAW,CA7Bf,wCAgCM,kBAAmB,CACnB,kBAAmB,CAjCzB,yDAoCQ,kBAAmB,CApC3B,gCA0CI,gBAAyD,CA1C7D,8BA8CI,iBAhDW,CAiDX,cAjDW,CAkDX,eAAgB,CAhDpB,+BAoDI,iBAtDW,CAuDX,cAvDW,CAwDX,gBAAiB",sourcesContent:['/* Copyright 2020 Karlsruhe Institute of Technology\n *\n * Licensed under the Apache License, Version 2.0 (the "License");\n * you may not use this file except in compliance with the License.\n * You may obtain a copy of the License at\n *\n *     http://www.apache.org/licenses/LICENSE-2.0\n *\n * Unless required by applicable law or agreed to in writing, software\n * distributed under the License is distributed on an "AS IS" BASIS,\n * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n * See the License for the specific language governing permissions and\n * limitations under the License. */\n\n$context-menu-accent-color: #c9c9c9;\n$context-menu-round: 3px;\n$context-menu-width: 175px;\n\n$socket-color: #2e2e2e;\n$socket-margin: 5px;\n$socket-size: 20px;\n\n.connection {\n  overflow: visible !important;\n  pointer-events: none;\n  position: absolute;\n  z-index: -1;\n\n  .main-path {\n    fill: none;\n    stroke: $context-menu-accent-color;\n    stroke-width: 3px;\n  }\n\n  > * {\n    pointer-events: all;\n  }\n}\n\n.item {\n  background-color: #f8f8f8;\n  border-left: 1px solid $context-menu-accent-color;\n  border-right: 1px solid $context-menu-accent-color;\n  color: $socket-color;\n  cursor: pointer;\n  padding: 4px;\n  position: relative;\n  width: $context-menu-width;\n\n  &:hover {\n    background-color: #e3e3e3;\n  }\n\n  &:first-child {\n    border-top: 1px solid $context-menu-accent-color;\n    border-top-left-radius: $context-menu-round;\n    border-top-right-radius: $context-menu-round;\n  }\n\n  &:last-child {\n    border-bottom: 1px solid $context-menu-accent-color;\n    border-bottom-left-radius: $context-menu-round;\n    border-bottom-right-radius: $context-menu-round;\n  }\n}\n',"\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n@import 'styles/workflows/workflow-editor.scss';\n\n$io-margin: 5px;\n\n.node {\n  background: rgba(#f7f7f7, 0.8);\n  border: 2px solid #2e2e2e;\n  border-radius: 0.75rem;\n  box-sizing: border-box;\n  color: #2e2e2e;\n  cursor: pointer;\n  height: auto;\n  min-width: 150px;\n  padding-bottom: 10px;\n  padding-top: 10px;\n  position: relative;\n  user-select: none;\n\n  &.tool {\n    background: rgba(#2c3e50, 0.9);\n    color: white;\n  }\n\n  &:hover, &.selected {\n    background: rgba(#e3e3e3, 0.8);\n\n    &.tool {\n      background: rgba(#223140, 0.9);\n    }\n  }\n\n  .content {\n    display: table;\n    width: 100%;\n\n    .column {\n      display: table-cell;\n      white-space: nowrap;\n\n      &:not(:last-child) {\n        padding-right: 20px;\n      }\n    }\n  }\n\n  .control {\n    padding: $socket-margin $socket-size / 2 + $socket-margin;\n  }\n\n  .input {\n    margin-bottom: $io-margin;\n    margin-top: $io-margin;\n    text-align: left;\n  }\n\n  .output {\n    margin-bottom: $io-margin;\n    margin-top: $io-margin;\n    text-align: right;\n  }\n}\n"],sourceRoot:""}]),e.exports=o},5473:function(e,t,n){var r=n(4015),o=n(3645)(r);o.push([e.id,".connection[data-v-1e315414]{overflow:visible !important;pointer-events:none;position:absolute;z-index:-1}.connection .main-path[data-v-1e315414]{fill:none;stroke:#c9c9c9;stroke-width:3px}.connection>*[data-v-1e315414]{pointer-events:all}.item[data-v-1e315414]{background-color:#f8f8f8;border-left:1px solid #c9c9c9;border-right:1px solid #c9c9c9;color:#2e2e2e;cursor:pointer;padding:4px;position:relative;width:175px}.item[data-v-1e315414]:hover{background-color:#e3e3e3}.item[data-v-1e315414]:first-child{border-top:1px solid #c9c9c9;border-top-left-radius:3px;border-top-right-radius:3px}.item[data-v-1e315414]:last-child{border-bottom:1px solid #c9c9c9;border-bottom-left-radius:3px;border-bottom-right-radius:3px}.search input[data-v-1e315414]{background:transparent;border:1px solid #c9c9c9;border-radius:3px;box-sizing:border-box;font-size:15px;padding:1px 8px;width:100%}\n","",{version:3,sources:["webpack://./kadi/assets/styles/workflows/workflow-editor.scss","webpack://./kadi/assets/scripts/lib/workflows/core/Search.vue"],names:[],mappings:"AAsBA,6BACE,2BAA4B,CAC5B,mBAAoB,CACpB,iBAAkB,CAClB,UAAW,CAJb,wCAOI,SAAU,CACV,cAhB+B,CAiB/B,gBAAiB,CATrB,+BAaI,kBAAmB,CACpB,uBAID,wBAAyB,CACzB,6BA3BiC,CA4BjC,8BA5BiC,CA6BjC,aAzBoB,CA0BpB,cAAe,CACf,WAAY,CACZ,iBAAkB,CAClB,WA/BwB,CAuB1B,6BAWI,wBAAyB,CAX7B,mCAeI,4BAxC+B,CAyC/B,0BAxCoB,CAyCpB,2BAzCoB,CAwBxB,kCAqBI,+BA9C+B,CA+C/B,6BA9CoB,CA+CpB,8BA/CoB,CC6BxB,+BAEI,sBAAuB,CACvB,wBDjC+B,CCkC/B,iBAAkB,CAClB,qBAAsB,CACtB,cAAe,CACf,eAAgB,CAChB,UAAW",sourcesContent:['/* Copyright 2020 Karlsruhe Institute of Technology\n *\n * Licensed under the Apache License, Version 2.0 (the "License");\n * you may not use this file except in compliance with the License.\n * You may obtain a copy of the License at\n *\n *     http://www.apache.org/licenses/LICENSE-2.0\n *\n * Unless required by applicable law or agreed to in writing, software\n * distributed under the License is distributed on an "AS IS" BASIS,\n * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n * See the License for the specific language governing permissions and\n * limitations under the License. */\n\n$context-menu-accent-color: #c9c9c9;\n$context-menu-round: 3px;\n$context-menu-width: 175px;\n\n$socket-color: #2e2e2e;\n$socket-margin: 5px;\n$socket-size: 20px;\n\n.connection {\n  overflow: visible !important;\n  pointer-events: none;\n  position: absolute;\n  z-index: -1;\n\n  .main-path {\n    fill: none;\n    stroke: $context-menu-accent-color;\n    stroke-width: 3px;\n  }\n\n  > * {\n    pointer-events: all;\n  }\n}\n\n.item {\n  background-color: #f8f8f8;\n  border-left: 1px solid $context-menu-accent-color;\n  border-right: 1px solid $context-menu-accent-color;\n  color: $socket-color;\n  cursor: pointer;\n  padding: 4px;\n  position: relative;\n  width: $context-menu-width;\n\n  &:hover {\n    background-color: #e3e3e3;\n  }\n\n  &:first-child {\n    border-top: 1px solid $context-menu-accent-color;\n    border-top-left-radius: $context-menu-round;\n    border-top-right-radius: $context-menu-round;\n  }\n\n  &:last-child {\n    border-bottom: 1px solid $context-menu-accent-color;\n    border-bottom-left-radius: $context-menu-round;\n    border-bottom-right-radius: $context-menu-round;\n  }\n}\n',"\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n@import 'styles/workflows/workflow-editor.scss';\n\n.search  {\n  input {\n    background: transparent;\n    border: 1px solid $context-menu-accent-color;\n    border-radius: 3px;\n    box-sizing: border-box;\n    font-size: 15px;\n    padding: 1px 8px;\n    width: 100%;\n  }\n}\n"],sourceRoot:""}]),e.exports=o},7225:function(e,t,n){var r=n(4015),o=n(3645)(r);o.push([e.id,".connection[data-v-1d1d3241]{overflow:visible !important;pointer-events:none;position:absolute;z-index:-1}.connection .main-path[data-v-1d1d3241]{fill:none;stroke:#c9c9c9;stroke-width:3px}.connection>*[data-v-1d1d3241]{pointer-events:all}.item[data-v-1d1d3241]{background-color:#f8f8f8;border-left:1px solid #c9c9c9;border-right:1px solid #c9c9c9;color:#2e2e2e;cursor:pointer;padding:4px;position:relative;width:175px}.item[data-v-1d1d3241]:hover{background-color:#e3e3e3}.item[data-v-1d1d3241]:first-child{border-top:1px solid #c9c9c9;border-top-left-radius:3px;border-top-right-radius:3px}.item[data-v-1d1d3241]:last-child{border-bottom:1px solid #c9c9c9;border-bottom-left-radius:3px;border-bottom-right-radius:3px}.socket[data-v-1d1d3241]{background:white;border:2px solid #2e2e2e;border-radius:10px;box-sizing:border-box;cursor:pointer;display:inline-block;height:20px;margin:5px;position:relative;vertical-align:middle;width:20px;z-index:2}.socket.input[data-v-1d1d3241]{margin-left:-10px}.socket.output[data-v-1d1d3241]{margin-right:-10px}.socket.used[data-v-1d1d3241]{background:#2e2e2e;border:2px solid #c9c9c9}.socket[data-v-1d1d3241]:hover{border-width:4px}.socket.choice[data-v-1d1d3241]{background:#164aab}.socket.bool[data-v-1d1d3241]{background:#fa5a5a}.socket.dep[data-v-1d1d3241]{background:#72de6d}.socket.env[data-v-1d1d3241]{background:#636363}.socket.float[data-v-1d1d3241]{background:#77dfed}.socket.int[data-v-1d1d3241]{background:#c660fc}.socket.stdio[data-v-1d1d3241]{background:#f5f384}.socket.str[data-v-1d1d3241]{background:#6b9fff}\n","",{version:3,sources:["webpack://./kadi/assets/styles/workflows/workflow-editor.scss","webpack://./kadi/assets/scripts/lib/workflows/core/Socket.vue"],names:[],mappings:"AAsBA,6BACE,2BAA4B,CAC5B,mBAAoB,CACpB,iBAAkB,CAClB,UAAW,CAJb,wCAOI,SAAU,CACV,cAhB+B,CAiB/B,gBAAiB,CATrB,+BAaI,kBAAmB,CACpB,uBAID,wBAAyB,CACzB,6BA3BiC,CA4BjC,8BA5BiC,CA6BjC,aAzBoB,CA0BpB,cAAe,CACf,WAAY,CACZ,iBAAkB,CAClB,WA/BwB,CAuB1B,6BAWI,wBAAyB,CAX7B,mCAeI,4BAxC+B,CAyC/B,0BAxCoB,CAyCpB,2BAzCoB,CAwBxB,kCAqBI,+BA9C+B,CA+C/B,6BA9CoB,CA+CpB,8BA/CoB,CCiBxB,yBACE,gBAAiB,CACjB,wBDhBoB,CCiBpB,kBAAiC,CACjC,qBAAsB,CACtB,cAAe,CACf,oBAAqB,CACrB,WDnBgB,CCoBhB,UDrBiB,CCsBjB,iBAAkB,CAClB,qBAAsB,CACtB,UDvBgB,CCwBhB,SAAU,CAZZ,+BAeI,iBAA8B,CAflC,gCAmBI,kBAA+B,CAnBnC,8BAuBI,kBDrCkB,CCsClB,wBAAyB,CAxB7B,+BA4BI,gBAAiB,CA5BrB,gCAkCI,kBAAmB,CAlCvB,8BAsCI,kBAAmB,CAtCvB,6BA0CI,kBAAmB,CA1CvB,6BA8CI,kBAAmB,CA9CvB,+BAkDI,kBAAmB,CAlDvB,6BAsDI,kBAAmB,CAtDvB,+BA0DI,kBAAmB,CA1DvB,6BA8DI,kBAAmB",sourcesContent:['/* Copyright 2020 Karlsruhe Institute of Technology\n *\n * Licensed under the Apache License, Version 2.0 (the "License");\n * you may not use this file except in compliance with the License.\n * You may obtain a copy of the License at\n *\n *     http://www.apache.org/licenses/LICENSE-2.0\n *\n * Unless required by applicable law or agreed to in writing, software\n * distributed under the License is distributed on an "AS IS" BASIS,\n * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n * See the License for the specific language governing permissions and\n * limitations under the License. */\n\n$context-menu-accent-color: #c9c9c9;\n$context-menu-round: 3px;\n$context-menu-width: 175px;\n\n$socket-color: #2e2e2e;\n$socket-margin: 5px;\n$socket-size: 20px;\n\n.connection {\n  overflow: visible !important;\n  pointer-events: none;\n  position: absolute;\n  z-index: -1;\n\n  .main-path {\n    fill: none;\n    stroke: $context-menu-accent-color;\n    stroke-width: 3px;\n  }\n\n  > * {\n    pointer-events: all;\n  }\n}\n\n.item {\n  background-color: #f8f8f8;\n  border-left: 1px solid $context-menu-accent-color;\n  border-right: 1px solid $context-menu-accent-color;\n  color: $socket-color;\n  cursor: pointer;\n  padding: 4px;\n  position: relative;\n  width: $context-menu-width;\n\n  &:hover {\n    background-color: #e3e3e3;\n  }\n\n  &:first-child {\n    border-top: 1px solid $context-menu-accent-color;\n    border-top-left-radius: $context-menu-round;\n    border-top-right-radius: $context-menu-round;\n  }\n\n  &:last-child {\n    border-bottom: 1px solid $context-menu-accent-color;\n    border-bottom-left-radius: $context-menu-round;\n    border-bottom-right-radius: $context-menu-round;\n  }\n}\n',"\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n@import 'styles/workflows/workflow-editor.scss';\n\n.socket {\n  background: white;\n  border: 2px solid $socket-color;\n  border-radius: $socket-size / 2.0;\n  box-sizing: border-box;\n  cursor: pointer;\n  display: inline-block;\n  height: $socket-size;\n  margin: $socket-margin;\n  position: relative;\n  vertical-align: middle;\n  width: $socket-size;\n  z-index: 2;\n\n  &.input {\n    margin-left: -$socket-size / 2;\n  }\n\n  &.output {\n    margin-right: -$socket-size / 2;\n  }\n\n  &.used {\n    background: $socket-color;\n    border: 2px solid #c9c9c9;\n  }\n\n  &:hover {\n    border-width: 4px;\n  }\n\n  /* Socket types. */\n\n  &.choice {\n    background: #164aab;\n  }\n\n  &.bool {\n    background: #fa5a5a;\n  }\n\n  &.dep {\n    background: #72de6d;\n  }\n\n  &.env {\n    background: #636363;\n  }\n\n  &.float {\n    background: #77dfed;\n  }\n\n  &.int {\n    background: #c660fc;\n  }\n\n  &.stdio {\n    background: #f5f384;\n  }\n\n  &.str {\n    background: #6b9fff;\n  }\n}\n"],sourceRoot:""}]),e.exports=o},3645:function(e){"use strict";e.exports=function(e){var t=[];return t.toString=function(){return this.map((function(t){var n=e(t);return t[2]?"@media ".concat(t[2]," {").concat(n,"}"):n})).join("")},t.i=function(e,n,r){"string"==typeof e&&(e=[[null,e,""]]);var o={};if(r)for(var i=0;i<this.length;i++){var a=this[i][0];null!=a&&(o[a]=!0)}for(var s=0;s<e.length;s++){var c=[].concat(e[s]);r&&o[c[0]]||(n&&(c[2]?c[2]="".concat(n," and ").concat(c[2]):c[2]=n),t.push(c))}},t}},4015:function(e){"use strict";function t(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}e.exports=function(e){var n,r,o=(r=4,function(e){if(Array.isArray(e))return e}(n=e)||function(e,t){if("undefined"!=typeof Symbol&&Symbol.iterator in Object(e)){var n=[],r=!0,o=!1,i=void 0;try{for(var a,s=e[Symbol.iterator]();!(r=(a=s.next()).done)&&(n.push(a.value),!t||n.length!==t);r=!0);}catch(e){o=!0,i=e}finally{try{r||null==s.return||s.return()}finally{if(o)throw i}}return n}}(n,r)||function(e,n){if(e){if("string"==typeof e)return t(e,n);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?t(e,n):void 0}}(n,r)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()),i=o[1],a=o[3];if("function"==typeof btoa){var s=btoa(unescape(encodeURIComponent(JSON.stringify(a)))),c="sourceMappingURL=data:application/json;charset=utf-8;base64,".concat(s),u="/*# ".concat(c," */"),l=a.sources.map((function(e){return"/*# sourceURL=".concat(a.sourceRoot||"").concat(e," */")}));return[i].concat(l).concat([u]).join("\n")}return[i].join("\n")}},5666:function(e){var t=function(e){"use strict";var t,n=Object.prototype,r=n.hasOwnProperty,o="function"==typeof Symbol?Symbol:{},i=o.iterator||"@@iterator",a=o.asyncIterator||"@@asyncIterator",s=o.toStringTag||"@@toStringTag";function c(e,t,n){return Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}),e[t]}try{c({},"")}catch(e){c=function(e,t,n){return e[t]=n}}function u(e,t,n,r){var o=t&&t.prototype instanceof m?t:m,i=Object.create(o.prototype),a=new S(r||[]);return i._invoke=function(e,t,n){var r=d;return function(o,i){if(r===f)throw new Error("Generator is already running");if(r===h){if("throw"===o)throw i;return I()}for(n.method=o,n.arg=i;;){var a=n.delegate;if(a){var s=B(a,n);if(s){if(s===v)continue;return s}}if("next"===n.method)n.sent=n._sent=n.arg;else if("throw"===n.method){if(r===d)throw r=h,n.arg;n.dispatchException(n.arg)}else"return"===n.method&&n.abrupt("return",n.arg);r=f;var c=l(e,t,n);if("normal"===c.type){if(r=n.done?h:p,c.arg===v)continue;return{value:c.arg,done:n.done}}"throw"===c.type&&(r=h,n.method="throw",n.arg=c.arg)}}}(e,n,a),i}function l(e,t,n){try{return{type:"normal",arg:e.call(t,n)}}catch(e){return{type:"throw",arg:e}}}e.wrap=u;var d="suspendedStart",p="suspendedYield",f="executing",h="completed",v={};function m(){}function g(){}function y(){}var b={};b[i]=function(){return this};var A=Object.getPrototypeOf,w=A&&A(A(E([])));w&&w!==n&&r.call(w,i)&&(b=w);var C=y.prototype=m.prototype=Object.create(b);function x(e){["next","throw","return"].forEach((function(t){c(e,t,(function(e){return this._invoke(t,e)}))}))}function k(e,t){function n(o,i,a,s){var c=l(e[o],e,i);if("throw"!==c.type){var u=c.arg,d=u.value;return d&&"object"==typeof d&&r.call(d,"__await")?t.resolve(d.__await).then((function(e){n("next",e,a,s)}),(function(e){n("throw",e,a,s)})):t.resolve(d).then((function(e){u.value=e,a(u)}),(function(e){return n("throw",e,a,s)}))}s(c.arg)}var o;this._invoke=function(e,r){function i(){return new t((function(t,o){n(e,r,t,o)}))}return o=o?o.then(i,i):i()}}function B(e,n){var r=e.iterator[n.method];if(r===t){if(n.delegate=null,"throw"===n.method){if(e.iterator.return&&(n.method="return",n.arg=t,B(e,n),"throw"===n.method))return v;n.method="throw",n.arg=new TypeError("The iterator does not provide a 'throw' method")}return v}var o=l(r,e.iterator,n.arg);if("throw"===o.type)return n.method="throw",n.arg=o.arg,n.delegate=null,v;var i=o.arg;return i?i.done?(n[e.resultName]=i.value,n.next=e.nextLoc,"return"!==n.method&&(n.method="next",n.arg=t),n.delegate=null,v):i:(n.method="throw",n.arg=new TypeError("iterator result is not an object"),n.delegate=null,v)}function _(e){var t={tryLoc:e[0]};1 in e&&(t.catchLoc=e[1]),2 in e&&(t.finallyLoc=e[2],t.afterLoc=e[3]),this.tryEntries.push(t)}function $(e){var t=e.completion||{};t.type="normal",delete t.arg,e.completion=t}function S(e){this.tryEntries=[{tryLoc:"root"}],e.forEach(_,this),this.reset(!0)}function E(e){if(e){var n=e[i];if(n)return n.call(e);if("function"==typeof e.next)return e;if(!isNaN(e.length)){var o=-1,a=function n(){for(;++o<e.length;)if(r.call(e,o))return n.value=e[o],n.done=!1,n;return n.value=t,n.done=!0,n};return a.next=a}}return{next:I}}function I(){return{value:t,done:!0}}return g.prototype=C.constructor=y,y.constructor=g,g.displayName=c(y,s,"GeneratorFunction"),e.isGeneratorFunction=function(e){var t="function"==typeof e&&e.constructor;return!!t&&(t===g||"GeneratorFunction"===(t.displayName||t.name))},e.mark=function(e){return Object.setPrototypeOf?Object.setPrototypeOf(e,y):(e.__proto__=y,c(e,s,"GeneratorFunction")),e.prototype=Object.create(C),e},e.awrap=function(e){return{__await:e}},x(k.prototype),k.prototype[a]=function(){return this},e.AsyncIterator=k,e.async=function(t,n,r,o,i){void 0===i&&(i=Promise);var a=new k(u(t,n,r,o),i);return e.isGeneratorFunction(n)?a:a.next().then((function(e){return e.done?e.value:a.next()}))},x(C),c(C,s,"Generator"),C[i]=function(){return this},C.toString=function(){return"[object Generator]"},e.keys=function(e){var t=[];for(var n in e)t.push(n);return t.reverse(),function n(){for(;t.length;){var r=t.pop();if(r in e)return n.value=r,n.done=!1,n}return n.done=!0,n}},e.values=E,S.prototype={constructor:S,reset:function(e){if(this.prev=0,this.next=0,this.sent=this._sent=t,this.done=!1,this.delegate=null,this.method="next",this.arg=t,this.tryEntries.forEach($),!e)for(var n in this)"t"===n.charAt(0)&&r.call(this,n)&&!isNaN(+n.slice(1))&&(this[n]=t)},stop:function(){this.done=!0;var e=this.tryEntries[0].completion;if("throw"===e.type)throw e.arg;return this.rval},dispatchException:function(e){if(this.done)throw e;var n=this;function o(r,o){return s.type="throw",s.arg=e,n.next=r,o&&(n.method="next",n.arg=t),!!o}for(var i=this.tryEntries.length-1;i>=0;--i){var a=this.tryEntries[i],s=a.completion;if("root"===a.tryLoc)return o("end");if(a.tryLoc<=this.prev){var c=r.call(a,"catchLoc"),u=r.call(a,"finallyLoc");if(c&&u){if(this.prev<a.catchLoc)return o(a.catchLoc,!0);if(this.prev<a.finallyLoc)return o(a.finallyLoc)}else if(c){if(this.prev<a.catchLoc)return o(a.catchLoc,!0)}else{if(!u)throw new Error("try statement without catch or finally");if(this.prev<a.finallyLoc)return o(a.finallyLoc)}}}},abrupt:function(e,t){for(var n=this.tryEntries.length-1;n>=0;--n){var o=this.tryEntries[n];if(o.tryLoc<=this.prev&&r.call(o,"finallyLoc")&&this.prev<o.finallyLoc){var i=o;break}}i&&("break"===e||"continue"===e)&&i.tryLoc<=t&&t<=i.finallyLoc&&(i=null);var a=i?i.completion:{};return a.type=e,a.arg=t,i?(this.method="next",this.next=i.finallyLoc,v):this.complete(a)},complete:function(e,t){if("throw"===e.type)throw e.arg;return"break"===e.type||"continue"===e.type?this.next=e.arg:"return"===e.type?(this.rval=this.arg=e.arg,this.method="return",this.next="end"):"normal"===e.type&&t&&(this.next=t),v},finish:function(e){for(var t=this.tryEntries.length-1;t>=0;--t){var n=this.tryEntries[t];if(n.finallyLoc===e)return this.complete(n.completion,n.afterLoc),$(n),v}},catch:function(e){for(var t=this.tryEntries.length-1;t>=0;--t){var n=this.tryEntries[t];if(n.tryLoc===e){var r=n.completion;if("throw"===r.type){var o=r.arg;$(n)}return o}}throw new Error("illegal catch attempt")},delegateYield:function(e,n,r){return this.delegate={iterator:E(e),resultName:n,nextLoc:r},"next"===this.method&&(this.arg=t),v}},e}(e.exports);try{regeneratorRuntime=t}catch(e){Function("r","regeneratorRuntime = r")(t)}},7658:function(e,t,n){var r=n(4353);"string"==typeof r&&(r=[[e.id,r,""]]),r.locals&&(e.exports=r.locals),(0,n(5346).Z)("45f6ed4e",r,!1,{})},8962:function(e,t,n){var r=n(9611);"string"==typeof r&&(r=[[e.id,r,""]]),r.locals&&(e.exports=r.locals),(0,n(5346).Z)("fb49de6e",r,!1,{})},3227:function(e,t,n){var r=n(2975);"string"==typeof r&&(r=[[e.id,r,""]]),r.locals&&(e.exports=r.locals),(0,n(5346).Z)("26e22ed7",r,!1,{})},4771:function(e,t,n){var r=n(3903);"string"==typeof r&&(r=[[e.id,r,""]]),r.locals&&(e.exports=r.locals),(0,n(5346).Z)("14afefb8",r,!1,{})},1835:function(e,t,n){var r=n(8342);"string"==typeof r&&(r=[[e.id,r,""]]),r.locals&&(e.exports=r.locals),(0,n(5346).Z)("24042f72",r,!1,{})},6139:function(e,t,n){var r=n(2449);"string"==typeof r&&(r=[[e.id,r,""]]),r.locals&&(e.exports=r.locals),(0,n(5346).Z)("240738ae",r,!1,{})},7980:function(e,t,n){var r=n(5473);"string"==typeof r&&(r=[[e.id,r,""]]),r.locals&&(e.exports=r.locals),(0,n(5346).Z)("035696db",r,!1,{})},4540:function(e,t,n){var r=n(7225);"string"==typeof r&&(r=[[e.id,r,""]]),r.locals&&(e.exports=r.locals),(0,n(5346).Z)("7b5fb2ba",r,!1,{})},5346:function(e,t,n){"use strict";function r(e,t){for(var n=[],r={},o=0;o<t.length;o++){var i=t[o],a=i[0],s={id:e+":"+o,css:i[1],media:i[2],sourceMap:i[3]};r[a]?r[a].parts.push(s):n.push(r[a]={id:a,parts:[s]})}return n}n.d(t,{Z:function(){return h}});var o="undefined"!=typeof document;if("undefined"!=typeof DEBUG&&DEBUG&&!o)throw new Error("vue-style-loader cannot be used in a non-browser environment. Use { target: 'node' } in your Webpack config to indicate a server-rendering environment.");var i={},a=o&&(document.head||document.getElementsByTagName("head")[0]),s=null,c=0,u=!1,l=function(){},d=null,p="data-vue-ssr-id",f="undefined"!=typeof navigator&&/msie [6-9]\b/.test(navigator.userAgent.toLowerCase());function h(e,t,n,o){u=n,d=o||{};var a=r(e,t);return v(a),function(t){for(var n=[],o=0;o<a.length;o++){var s=a[o];(c=i[s.id]).refs--,n.push(c)}for(t?v(a=r(e,t)):a=[],o=0;o<n.length;o++){var c;if(0===(c=n[o]).refs){for(var u=0;u<c.parts.length;u++)c.parts[u]();delete i[c.id]}}}}function v(e){for(var t=0;t<e.length;t++){var n=e[t],r=i[n.id];if(r){r.refs++;for(var o=0;o<r.parts.length;o++)r.parts[o](n.parts[o]);for(;o<n.parts.length;o++)r.parts.push(g(n.parts[o]));r.parts.length>n.parts.length&&(r.parts.length=n.parts.length)}else{var a=[];for(o=0;o<n.parts.length;o++)a.push(g(n.parts[o]));i[n.id]={id:n.id,refs:1,parts:a}}}}function m(){var e=document.createElement("style");return e.type="text/css",a.appendChild(e),e}function g(e){var t,n,r=document.querySelector("style["+p+'~="'+e.id+'"]');if(r){if(u)return l;r.parentNode.removeChild(r)}if(f){var o=c++;r=s||(s=m()),t=A.bind(null,r,o,!1),n=A.bind(null,r,o,!0)}else r=m(),t=w.bind(null,r),n=function(){r.parentNode.removeChild(r)};return t(e),function(r){if(r){if(r.css===e.css&&r.media===e.media&&r.sourceMap===e.sourceMap)return;t(e=r)}else n()}}var y,b=(y=[],function(e,t){return y[e]=t,y.filter(Boolean).join("\n")});function A(e,t,n,r){var o=n?"":r.css;if(e.styleSheet)e.styleSheet.cssText=b(t,o);else{var i=document.createTextNode(o),a=e.childNodes;a[t]&&e.removeChild(a[t]),a.length?e.insertBefore(i,a[t]):e.appendChild(i)}}function w(e,t){var n=t.css,r=t.media,o=t.sourceMap;if(r&&e.setAttribute("media",r),d.ssrId&&e.setAttribute(p,t.id),o&&(n+="\n/*# sourceURL="+o.sources[0]+" */",n+="\n/*# sourceMappingURL=data:application/json;base64,"+btoa(unescape(encodeURIComponent(JSON.stringify(o))))+" */"),e.styleSheet)e.styleSheet.cssText=n;else{for(;e.firstChild;)e.removeChild(e.firstChild);e.appendChild(document.createTextNode(n))}}}},t={};function n(r){if(t[r])return t[r].exports;var o=t[r]={id:r,exports:{}};return e[r](o,o.exports,n),o.exports}n.d=function(e,t){for(var r in t)n.o(t,r)&&!n.o(e,r)&&Object.defineProperty(e,r,{enumerable:!0,get:t[r]})},n.g=function(){if("object"==typeof globalThis)return globalThis;try{return this||new Function("return this")()}catch(e){if("object"==typeof window)return window}}(),n.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},function(){"use strict";var e=function(){var e=this,t=e.$createElement,n=e._self._c||t;return n("div",{ref:"container"},[e.toolsEndpoint?n("div",[e.toolDialogActive?n("div",{staticClass:"modal-backdrop show"}):e._e(),e._v(" "),n("div",{ref:"toolDialog",staticClass:"modal",attrs:{tabindex:"-1"}},[n("div",{staticClass:"modal-dialog modal-dialog-centered modal-lg"},[n("div",{staticClass:"modal-content"},[n("div",{staticClass:"modal-body"},[n("dynamic-pagination",{attrs:{placeholder:"No tools.","filter-placeholder":"Filter tools by filename",endpoint:e.toolsEndpoint,"per-page":5,"enable-filter":!0},scopedSlots:e._u([{key:"default",fn:function(t){return[n("div",{staticClass:"d-flex justify-content-between mb-4"},[n("div",[n("strong",[e._v("Tools")]),e._v(" "),n("span",{staticClass:"badge badge-pill badge-light text-muted border border-muted"},[e._v(e._s(t.total))])]),e._v(" "),n("button",{staticClass:"close",attrs:{type:"button","data-dismiss":"modal"}},[n("i",{staticClass:"fas fa-xs fa-times"})])]),e._v(" "),t.total>0?n("ul",{staticClass:"list-group"},[n("li",{staticClass:"list-group-item bg-light py-2"},[n("div",{staticClass:"row"},[n("div",{staticClass:"col-lg-5"},[e._v("File")]),e._v(" "),n("div",{staticClass:"col-lg-5"},[e._v("Tool")])])]),e._v(" "),e._l(t.items,(function(t){return n("li",{key:t.file.id,staticClass:"list-group-item py-2"},[n("div",{staticClass:"row align-items-center"},[n("div",{staticClass:"col-lg-5"},[n("strong",[e._v(e._s(t.file.name))]),e._v(" "),n("br"),e._v("\n                        @"+e._s(t.record.identifier)+"\n                      ")]),e._v(" "),n("div",{staticClass:"col-lg-5"},[n("strong",[e._v(e._s(t.tool.name))]),e._v(" "),t.tool.version?n("span",[n("br"),e._v("\n                          Version "+e._s(t.tool.version)+"\n                        ")]):e._e()]),e._v(" "),n("div",{staticClass:"col-lg-2 d-flex justify-content-end"},[n("div",[n("button",{staticClass:"btn btn-light btn-sm",on:{click:function(n){return e.addTool(t.tool)}}},[n("i",{staticClass:"fas fa-plus"})])])])])])}))],2):e._e()]}}],null,!1,3687840498)})],1)])])])]):e._e(),e._v(" "),n("div",{ref:"editorContainer",staticClass:"card editor-container",class:{"bg-light":!e.editable}},[n("div",{ref:"editorToolbar",staticClass:"editor-toolbar mt-1 mr-1"},[n("button",{staticClass:"btn btn-link text-muted",attrs:{title:"Reset view",type:"button"},on:{click:e.resetView}},[n("i",{staticClass:"fas fa-eye"})]),e._v(" "),n("button",{staticClass:"btn btn-link text-muted",attrs:{title:"Toggle fullscreen",type:"button"},on:{click:e.toggleFullscreen}},[n("i",{staticClass:"fas fa-expand"})]),e._v(" "),e.editable?n("button",{staticClass:"btn btn-link text-muted",attrs:{title:"Reset editor",type:"button"},on:{click:e.resetEditor}},[n("i",{staticClass:"fas fa-broom"})]):e._e()]),e._v(" "),n("div",{ref:"editor"})]),e._v(" "),e._t("default",null,{editor:e.editor})],2)};function t(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function r(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function o(e,t,n){return t&&r(e.prototype,t),n&&r(e,n),e}function i(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=[],r=!0,o=!1,i=void 0;try{for(var a,s=e[Symbol.iterator]();!(r=(a=s.next()).done)&&(n.push(a.value),!t||n.length!==t);r=!0);}catch(e){o=!0,i=e}finally{try{r||null==s.return||s.return()}finally{if(o)throw i}}return n}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance")}()}function a(e){return function(e){if(Array.isArray(e)){for(var t=0,n=new Array(e.length);t<e.length;t++)n[t]=e[t];return n}}(e)||function(e){if(Symbol.iterator in Object(e)||"[object Arguments]"===Object.prototype.toString.call(e))return Array.from(e)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance")}()}e._withStripped=!0,n(5666),function(e){if("undefined"!=typeof window){var t=document.createElement("style");t.setAttribute("type","text/css"),t.innerHTML=e,document.head.appendChild(t)}}(".rete-background {\n  display: table;\n  z-index: -1;\n  position: absolute;\n  top: -320000px;\n  left: -320000px;\n  width: 640000px;\n  height: 640000px;\n}\n.rete-background.default {\n  background-size: 32px 32px;\n  background-image: linear-gradient(to right, #ccc 1px, transparent 1px), linear-gradient(to bottom, #ccc 1px, transparent 1px);\n}");var s=function e(n,r){if(t(this,e),r){var o=r instanceof HTMLElement?r:document.createElement("div");o.classList+=" rete-background ".concat(!0===r?"default":""),n.view.area.appendChild(o)}},c=function(){function e(n,r,o){t(this,e),this.editor=n,this.scaleExtent=r,this.translateExtent=o,r&&n.on("zoom",this.restrictZoom.bind(this)),o&&n.on("translate",this.restrictTranslate.bind(this))}return o(e,[{key:"restrictZoom",value:function(e){var t="boolean"==typeof this.scaleExtent?{min:.1,max:1}:this.scaleExtent;e.transform,e.zoom<t.min?e.zoom=t.min:e.zoom>t.max&&(e.zoom=t.max)}},{key:"restrictTranslate",value:function(e){var t="boolean"==typeof this.translateExtent?{width:5e3,height:4e3}:this.translateExtent,n=this.editor.view.container,r=e.transform.k,o=t.width*r,i=t.height*r,a=n.clientWidth/2,s=n.clientHeight/2;e.x-=a,e.y-=s,e.x>o?e.x=o:e.x<-o&&(e.x=-o),e.y>i?e.y=i:e.y<-i&&(e.y=-i),e.x+=a,e.y+=s}}]),e}(),u=function(){function e(n,r){var o=this,i=r.size,a=void 0===i?16:i,s=r.dynamic,c=void 0===s||s;t(this,e),this.editor=n,this.size=a,c?this.editor.on("nodetranslate",this.onTranslate.bind(this)):this.editor.on("rendernode",(function(e){var t=e.node,n=e.el;n.addEventListener("mouseup",o.onDrag.bind(o,t)),n.addEventListener("touchend",o.onDrag.bind(o,t)),n.addEventListener("touchcancel",o.onDrag.bind(o,t))}))}return o(e,[{key:"onTranslate",value:function(e){var t=e.x,n=e.y;e.x=this.snap(t),e.y=this.snap(n)}},{key:"onDrag",value:function(e){var t=i(e.position,2),n=t[0],r=t[1];e.position[0]=this.snap(n),e.position[1]=this.snap(r),console.log(this,n,r,e.position),this.editor.view.nodes.get(e).update(),this.editor.view.updateConnections({node:e})}},{key:"snap",value:function(e){return Math.round(e/this.size)*this.size}}]),e}(),l=function(e){return 0===e.length?0:Math.min.apply(Math,a(e))},d=function(e){return 0===e.length?0:Math.max.apply(Math,a(e))};function p(e,t){var n=l(t.map((function(e){return e.position[0]}))),r=l(t.map((function(e){return e.position[1]}))),o=d(t.map((function(t){return t.position[0]+e.view.nodes.get(t).el.clientWidth}))),i=d(t.map((function(t){return t.position[1]+e.view.nodes.get(t).el.clientHeight})));return{left:n,right:o,top:r,bottom:i,width:Math.abs(n-o),height:Math.abs(r-i),getCenter:function(){return[(n+o)/2,(r+i)/2]}}}var f={install:function(e,t){var n=t.background||!1,r=t.snap||!1,o=t.scaleExtent||!1,i=t.translateExtent||!1;n&&(this._background=new s(e,n)),(o||i)&&(this._restrictor=new c(e,o,i)),r&&(this._snap=new u(e,r))},zoomAt:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:e.nodes,n=p(e,t),r=n.getCenter(),o=i(r,2),a=o[0],s=o[1],c=[e.view.container.clientWidth,e.view.container.clientHeight],u=c[0],l=c[1],d=e.view.area,f=u/n.width,h=l/n.height,v=Math.min(.9*h,.9*f,1);d.transform.x=d.container.clientWidth/2-a*v,d.transform.y=d.container.clientHeight/2-s*v,d.zoom(v,0,0),d.update()}};function h(e,t,n,r,o,i,a){try{var s=e[i](a),c=s.value}catch(e){return void n(e)}s.done?t(c):Promise.resolve(c).then(r,o)}function v(e){return function(){var t=this,n=arguments;return new Promise((function(r,o){var i=e.apply(t,n);function a(e){h(i,r,o,a,s,"next",e)}function s(e){h(i,r,o,a,s,"throw",e)}a(void 0)}))}}function m(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function g(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function y(e,t,n){return t&&g(e.prototype,t),n&&g(e,n),e}function b(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function A(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){b(e,t,n[t])}))}return e}function w(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&x(e,t)}function C(e){return(C=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)})(e)}function x(e,t){return(x=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e})(e,t)}function k(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}function B(e,t){return!t||"object"!=typeof t&&"function"!=typeof t?k(e):t}function _(e,t,n){return(_="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(e,t,n){var r=function(e,t){for(;!Object.prototype.hasOwnProperty.call(e,t)&&null!==(e=C(e)););return e}(e,t);if(r){var o=Object.getOwnPropertyDescriptor(r,t);return o.get?o.get.call(n):o.value}})(e,t,n||e)}function S(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=[],r=!0,o=!1,i=void 0;try{for(var a,s=e[Symbol.iterator]();!(r=(a=s.next()).done)&&(n.push(a.value),!t||n.length!==t);r=!0);}catch(e){o=!0,i=e}finally{try{r||null==s.return||s.return()}finally{if(o)throw i}}return n}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance")}()}function E(e){return function(e){if(Array.isArray(e)){for(var t=0,n=new Array(e.length);t<e.length;t++)n[t]=e[t];return n}}(e)||function(e){if(Symbol.iterator in Object(e)||"[object Arguments]"===Object.prototype.toString.call(e))return Array.from(e)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance")}()}var I=function e(t){m(this,e),b(this,"name",void 0),b(this,"data",{}),b(this,"engine",null),this.name=t},O=function(){function e(t){m(this,e),b(this,"name",void 0),b(this,"id",void 0),b(this,"position",[0,0]),b(this,"inputs",new Map),b(this,"outputs",new Map),b(this,"controls",new Map),b(this,"data",{}),b(this,"meta",{}),this.name=t,this.id=e.incrementId()}return y(e,[{key:"_add",value:function(e,t,n){if(e.has(t.key))throw new Error("Item with key '".concat(t.key,"' already been added to the node"));if(null!==t[n])throw new Error("Item has already been added to some node");t[n]=this,e.set(t.key,t)}},{key:"addControl",value:function(e){return this._add(this.controls,e,"parent"),this}},{key:"removeControl",value:function(e){e.parent=null,this.controls.delete(e.key)}},{key:"addInput",value:function(e){return this._add(this.inputs,e,"node"),this}},{key:"removeInput",value:function(e){e.removeConnections(),e.node=null,this.inputs.delete(e.key)}},{key:"addOutput",value:function(e){return this._add(this.outputs,e,"node"),this}},{key:"removeOutput",value:function(e){e.removeConnections(),e.node=null,this.outputs.delete(e.key)}},{key:"getConnections",value:function(){return[].concat(E(this.inputs.values()),E(this.outputs.values())).reduce((function(e,t){return[].concat(E(e),E(t.connections))}),[])}},{key:"update",value:function(){}},{key:"toJSON",value:function(){var e=function(e){return Array.from(e).reduce((function(e,t){var n=S(t,2),r=n[0],o=n[1];return e[r]=o.toJSON(),e}),{})};return{id:this.id,data:this.data,inputs:e(this.inputs),outputs:e(this.outputs),position:this.position,name:this.name}}}],[{key:"incrementId",value:function(){return this.latestId?this.latestId++:this.latestId=1,this.latestId}},{key:"resetId",value:function(){this.latestId=0}},{key:"fromJSON",value:function(t){var n=new e(t.name),r=S(t.position,2),o=r[0],i=r[1];return n.id=t.id,n.data=t.data,n.position=[o,i],n.name=t.name,e.latestId=Math.max(n.id,e.latestId),n}}]),e}();b(O,"latestId",0);var N=function(e){function t(e){var n;return m(this,t),b(k(n=B(this,C(t).call(this,e))),"editor",null),b(k(n),"data",{}),n}var n;return w(t,e),y(t,[{key:"build",value:(n=v(regeneratorRuntime.mark((function e(t){return regeneratorRuntime.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:return e.next=2,this.builder(t);case 2:return e.abrupt("return",t);case 3:case"end":return e.stop()}}),e,this)}))),function(e){return n.apply(this,arguments)})},{key:"createNode",value:function(){var e=v(regeneratorRuntime.mark((function e(){var t,n,r=arguments;return regeneratorRuntime.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:return t=r.length>0&&void 0!==r[0]?r[0]:{},(n=new O(this.name)).data=t,e.next=5,this.build(n);case 5:return e.abrupt("return",n);case 6:case"end":return e.stop()}}),e,this)})));return function(){return e.apply(this,arguments)}}()}]),t}(I),T=function(){function e(t,n){m(this,e),b(this,"output",void 0),b(this,"input",void 0),b(this,"data",{}),this.output=t,this.input=n,this.data={},this.input.addConnection(this)}return y(e,[{key:"remove",value:function(){this.input.removeConnection(this),this.output.removeConnection(this)}}]),e}(),L=function(){function e(t){if(m(this,e),b(this,"key",void 0),b(this,"data",{}),b(this,"parent",null),this.constructor===e)throw new TypeError("Can not construct abstract class");if(!t)throw new Error("The key parameter is missing in super() of Control ");this.key=t}return y(e,[{key:"getNode",value:function(){if(null===this.parent)throw new Error("Control isn't added to Node/Input");if(this.parent instanceof O)return this.parent;if(!this.parent.node)throw new Error("Control hasn't be added to Input or Node");return this.parent.node}},{key:"getData",value:function(e){return this.getNode().data[e]}},{key:"putData",value:function(e,t){this.getNode().data[e]=t}}]),e}(),D=function(){function e(t){m(this,e),b(this,"events",{}),b(this,"silent",!1),this.events=t instanceof e?t.events:t.handlers}return y(e,[{key:"on",value:function(e,t){var n=this;return(e instanceof Array?e:e.split(" ")).forEach((function(e){if(!n.events[e])throw new Error("The event ".concat(e," does not exist"));n.events[e].push(t)})),this}},{key:"trigger",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(!(e in this.events))throw new Error("The event ".concat(e," cannot be triggered"));return this.events[e].reduce((function(e,n){return!1!==n(t)&&e}),!0)}},{key:"bind",value:function(e){if(this.events[e])throw new Error("The event ".concat(e," is already bound"));this.events[e]=[]}},{key:"exist",value:function(e){return Array.isArray(this.events[e])}}]),e}(),j=function(){function e(t,n,r,o){m(this,e),b(this,"node",null),b(this,"multipleConnections",void 0),b(this,"connections",[]),b(this,"key",void 0),b(this,"name",void 0),b(this,"socket",void 0),this.node=null,this.multipleConnections=o,this.connections=[],this.key=t,this.name=n,this.socket=r}return y(e,[{key:"removeConnection",value:function(e){this.connections.splice(this.connections.indexOf(e),1)}},{key:"removeConnections",value:function(){var e=this;this.connections.forEach((function(t){return e.removeConnection(t)}))}}]),e}(),R=function(e){function t(e,n,r){var o,i=arguments.length>3&&void 0!==arguments[3]&&arguments[3];return m(this,t),b(k(o=B(this,C(t).call(this,e,n,r,i))),"control",null),o}return w(t,e),y(t,[{key:"hasConnection",value:function(){return this.connections.length>0}},{key:"addConnection",value:function(e){if(!this.multipleConnections&&this.hasConnection())throw new Error("Multiple connections not allowed");this.connections.push(e)}},{key:"addControl",value:function(e){this.control=e,e.parent=this}},{key:"showControl",value:function(){return!this.hasConnection()&&null!==this.control}},{key:"toJSON",value:function(){return{connections:this.connections.map((function(e){if(!e.output.node)throw new Error("Node not added to Output");return{node:e.output.node.id,output:e.output.key,data:e.data}}))}}}]),t}(j),P=function(){function e(){m(this,e)}return y(e,null,[{key:"isValidData",value:function(e){return"string"==typeof e.id&&this.isValidId(e.id)&&e.nodes instanceof Object&&!(e.nodes instanceof Array)}},{key:"isValidId",value:function(e){return/^[\w-]{3,}@[0-9]+\.[0-9]+\.[0-9]+$/.test(e)}},{key:"validate",value:function(e,t){var n=e.split("@"),r=t.id.split("@"),o=[];return this.isValidData(t)||o.push("Data is not suitable"),e!==t.id&&o.push("IDs not equal"),n[0]!==r[0]&&o.push("Names don't match"),n[1]!==r[1]&&o.push("Versions don't match"),{success:Boolean(!o.length),msg:o.join(". ")}}}]),e}(),F=function(e){function t(e,n){var r;if(m(this,t),b(k(r=B(this,C(t).call(this,n))),"id",void 0),b(k(r),"plugins",void 0),b(k(r),"components",void 0),!P.isValidId(e))throw new Error("ID should be valid to name@0.1.0 format");return r.id=e,r.plugins=new Map,r.components=new Map,r}return w(t,e),y(t,[{key:"use",value:function(e,t){if(e.name&&this.plugins.has(e.name))throw new Error("Plugin ".concat(e.name," already in use"));e.install(this,t||{}),this.plugins.set(e.name,t)}},{key:"register",value:function(e){if(this.components.has(e.name))throw new Error("Component ".concat(e.name," already registered"));this.components.set(e.name,e),this.trigger("componentregister",e)}},{key:"destroy",value:function(){this.trigger("destroy")}}]),t}(D);function z(e,t){return window.addEventListener(e,t),function(){window.removeEventListener(e,t)}}var M=function(){function e(t){var n=arguments.length>1&&void 0!==arguments[1]?arguments[1]:function(e,t,n){},r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:function(e){},o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:function(e){};m(this,e),this.onTranslate=n,this.onStart=r,this.onDrag=o,b(this,"pointerStart",void 0),b(this,"el",void 0),b(this,"destroy",void 0),this.pointerStart=null,this.el=t,this.el.style.touchAction="none",this.el.addEventListener("pointerdown",this.down.bind(this));var i=z("pointermove",this.move.bind(this)),a=z("pointerup",this.up.bind(this));this.destroy=function(){i(),a()}}return y(e,[{key:"down",value:function(e){"mouse"===e.pointerType&&0!==e.button||(e.stopPropagation(),this.pointerStart=[e.pageX,e.pageY],this.onStart(e))}},{key:"move",value:function(e){if(this.pointerStart){e.preventDefault();var t=[e.pageX,e.pageY],n=t[1],r=[t[0]-this.pointerStart[0],n-this.pointerStart[1]],o=this.el.getBoundingClientRect().width/this.el.offsetWidth;this.onTranslate(r[0]/o,r[1]/o,e)}}},{key:"up",value:function(e){this.pointerStart&&(this.pointerStart=null,this.onDrag(e))}}]),e}(),U=function(){function e(t,n,r,o){m(this,e),b(this,"el",void 0),b(this,"intensity",void 0),b(this,"onzoom",void 0),b(this,"previous",null),b(this,"pointers",[]),b(this,"destroy",void 0),this.el=n,this.intensity=r,this.onzoom=o,t.addEventListener("wheel",this.wheel.bind(this)),t.addEventListener("pointerdown",this.down.bind(this)),t.addEventListener("dblclick",this.dblclick.bind(this));var i=z("pointermove",this.move.bind(this)),a=z("pointerup",this.end.bind(this)),s=z("pointercancel",this.end.bind(this));this.destroy=function(){i(),a(),s()}}return y(e,[{key:"wheel",value:function(e){e.preventDefault();var t=this.el.getBoundingClientRect(),n=e.wheelDelta,r=(n?n/120:-e.deltaY/3)*this.intensity,o=(t.left-e.clientX)*r,i=(t.top-e.clientY)*r;this.onzoom(r,o,i,"wheel")}},{key:"touches",value:function(){var e={touches:this.pointers},t=[e.touches[0].clientX,e.touches[0].clientY],n=t[0],r=t[1],o=[e.touches[1].clientX,e.touches[1].clientY],i=o[0],a=o[1];return{cx:(n+i)/2,cy:(r+a)/2,distance:Math.sqrt(Math.pow(n-i,2)+Math.pow(r-a,2))}}},{key:"down",value:function(e){this.pointers.push(e)}},{key:"move",value:function(e){if(this.pointers=this.pointers.map((function(t){return t.pointerId===e.pointerId?e:t})),this.translating){var t=this.el.getBoundingClientRect(),n=this.touches(),r=n.cx,o=n.cy,i=n.distance;if(null!==this.previous){var a=i/this.previous.distance-1,s=(t.left-r)*a,c=(t.top-o)*a;this.onzoom(a,s-(this.previous.cx-r),c-(this.previous.cy-o),"touch")}this.previous={cx:r,cy:o,distance:i}}}},{key:"end",value:function(e){this.previous=null,this.pointers=this.pointers.filter((function(t){return t.pointerId!==e.pointerId}))}},{key:"dblclick",value:function(e){e.preventDefault();var t=this.el.getBoundingClientRect(),n=4*this.intensity,r=(t.left-e.clientX)*n,o=(t.top-e.clientY)*n;this.onzoom(n,r,o,"dblclick")}},{key:"translating",get:function(){return this.pointers.length>=2}}]),e}(),V=function(e){function t(e,n){var r;m(this,t),b(k(r=B(this,C(t).call(this,n))),"el",void 0),b(k(r),"container",void 0),b(k(r),"transform",{k:1,x:0,y:0}),b(k(r),"mouse",{x:0,y:0}),b(k(r),"_startPosition",null),b(k(r),"_zoom",void 0),b(k(r),"_drag",void 0);var o=r.el=document.createElement("div");return r.container=e,o.style.transformOrigin="0 0",r._zoom=new U(e,o,.1,r.onZoom.bind(k(r))),r._drag=new M(e,r.onTranslate.bind(k(r)),r.onStart.bind(k(r))),n.on("destroy",(function(){r._zoom.destroy(),r._drag.destroy()})),r.container.addEventListener("pointermove",r.pointermove.bind(k(r))),r.update(),r}return w(t,e),y(t,[{key:"update",value:function(){var e=this.transform;this.el.style.transform="translate(".concat(e.x,"px, ").concat(e.y,"px) scale(").concat(e.k,")")}},{key:"pointermove",value:function(e){var t=e.clientX,n=e.clientY,r=this.el.getBoundingClientRect(),o=t-r.left,i=n-r.top,a=this.transform.k;this.mouse={x:o/a,y:i/a},this.trigger("mousemove",A({},this.mouse))}},{key:"onStart",value:function(){this._startPosition=A({},this.transform)}},{key:"onTranslate",value:function(e,t){this._zoom.translating||this._startPosition&&this.translate(this._startPosition.x+e,this._startPosition.y+t)}},{key:"onZoom",value:function(e,t,n,r){this.zoom(this.transform.k*(1+e),t,n,r),this.update()}},{key:"translate",value:function(e,t){var n={transform:this.transform,x:e,y:t};this.trigger("translate",n)&&(this.transform.x=n.x,this.transform.y=n.y,this.update(),this.trigger("translated"))}},{key:"zoom",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:0,r=arguments.length>3?arguments[3]:void 0,o=this.transform.k,i={transform:this.transform,zoom:e,source:r};if(this.trigger("zoom",i)){var a=(o-i.zoom)/(o-e||1);this.transform.k=i.zoom||1,this.transform.x+=t*a,this.transform.y+=n*a,this.update(),this.trigger("zoomed",{source:r})}}},{key:"appendChild",value:function(e){this.el.appendChild(e)}},{key:"removeChild",value:function(e){this.el.removeChild(e)}}]),t}(D),W=function(e){function t(e,n,r,o){var i;return m(this,t),b(k(i=B(this,C(t).call(this,o))),"connection",void 0),b(k(i),"inputNode",void 0),b(k(i),"outputNode",void 0),b(k(i),"el",void 0),i.connection=e,i.inputNode=n,i.outputNode=r,i.el=document.createElement("div"),i.el.style.position="absolute",i.el.style.zIndex="-1",i.trigger("renderconnection",{el:i.el,connection:i.connection,points:i.getPoints()}),i}return w(t,e),y(t,[{key:"getPoints",value:function(){var e=S(this.outputNode.getSocketPosition(this.connection.output),2),t=e[0],n=e[1],r=S(this.inputNode.getSocketPosition(this.connection.input),2);return[t,n,r[0],r[1]]}},{key:"update",value:function(){this.trigger("updateconnection",{el:this.el,connection:this.connection,points:this.getPoints()})}}]),t}(D),H=function(e){function t(e,n,r){var o;return m(this,t),(o=B(this,C(t).call(this,r))).trigger("rendercontrol",{el:e,control:n}),o}return w(t,e),t}(D),Y=function(e){function t(e,n,r,o,i){var a,s;return m(this,t),b(k(s=B(this,C(t).call(this,i))),"el",void 0),b(k(s),"type",void 0),b(k(s),"io",void 0),b(k(s),"node",void 0),s.el=e,s.type=n,s.io=r,s.node=o,s.trigger("rendersocket",(b(a={el:e},n,s.io),b(a,"socket",r.socket),a)),s}return w(t,e),y(t,[{key:"getPosition",value:function(e){var t=e.position,n=this.el;return[t[0]+n.offsetLeft+n.offsetWidth/2,t[1]+n.offsetTop+n.offsetHeight/2]}}]),t}(D),q=function(e){function t(e,n,r){var o;return m(this,t),b(k(o=B(this,C(t).call(this,r))),"node",void 0),b(k(o),"component",void 0),b(k(o),"sockets",new Map),b(k(o),"controls",new Map),b(k(o),"el",void 0),b(k(o),"_startPosition",[]),b(k(o),"_drag",void 0),o.node=e,o.component=n,o.el=document.createElement("div"),o.el.style.position="absolute",o.el.addEventListener("contextmenu",(function(e){return o.trigger("contextmenu",{e:e,node:o.node})})),o._drag=new M(o.el,o.onTranslate.bind(k(o)),o.onSelect.bind(k(o)),(function(){o.trigger("nodedraged",e),o.trigger("nodedragged",e)})),o.trigger("rendernode",{el:o.el,node:e,component:n.data,bindSocket:o.bindSocket.bind(k(o)),bindControl:o.bindControl.bind(k(o))}),o.update(),o}return w(t,e),y(t,[{key:"clearSockets",value:function(){var e=this,t=[].concat(E(this.node.inputs.values()),E(this.node.outputs.values()));this.sockets.forEach((function(n){t.includes(n.io)||e.sockets.delete(n.io)}))}},{key:"bindSocket",value:function(e,t,n){this.clearSockets(),this.sockets.set(n,new Y(e,t,n,this.node,this))}},{key:"bindControl",value:function(e,t){this.controls.set(t,new H(e,t,this))}},{key:"getSocketPosition",value:function(e){var t=this.sockets.get(e);if(!t)throw new Error("Socket not found for ".concat(e.name," with key ").concat(e.key));return t.getPosition(this.node)}},{key:"onSelect",value:function(e){var t={node:this.node,accumulate:e.ctrlKey,e:e};this.onStart(),this.trigger("multiselectnode",t),this.trigger("selectnode",t)}},{key:"onStart",value:function(){this._startPosition=E(this.node.position)}},{key:"onTranslate",value:function(e,t){this.trigger("translatenode",{node:this.node,dx:e,dy:t})}},{key:"onDrag",value:function(e,t){var n=this._startPosition[0]+e,r=this._startPosition[1]+t;this.translate(n,r)}},{key:"translate",value:function(e,t){var n=this.node,r={node:n,x:e,y:t};if(this.trigger("nodetranslate",r)){var o=S(n.position,2),i=[o[0],o[1]];n.position[0]=r.x,n.position[1]=r.y,this.update(),this.trigger("nodetranslated",{node:n,prev:i})}}},{key:"update",value:function(){var e=S(this.node.position,2),t=e[0],n=e[1];this.el.style.transform="translate(".concat(t,"px, ").concat(n,"px)")}},{key:"remove",value:function(){}},{key:"destroy",value:function(){this._drag.destroy()}}]),t}(D),K=function(e){function t(e,n,r){var o;return m(this,t),b(k(o=B(this,C(t).call(this,r))),"container",void 0),b(k(o),"components",void 0),b(k(o),"nodes",new Map),b(k(o),"connections",new Map),b(k(o),"area",void 0),o.container=e,o.components=n,o.container.style.overflow="hidden",o.container.addEventListener("click",o.click.bind(k(o))),o.container.addEventListener("contextmenu",(function(e){return o.trigger("contextmenu",{e:e,view:k(o)})})),r.on("destroy",z("resize",o.resize.bind(k(o)))),r.on("destroy",(function(){return o.nodes.forEach((function(e){return e.destroy()}))})),o.on("nodetranslated",o.updateConnections.bind(k(o))),o.area=new V(e,k(o)),o.container.appendChild(o.area.el),o}return w(t,e),y(t,[{key:"addNode",value:function(e){var t=this.components.get(e.name);if(!t)throw new Error("Component ".concat(e.name," not found"));var n=new q(e,t,this);this.nodes.set(e,n),this.area.appendChild(n.el)}},{key:"removeNode",value:function(e){var t=this.nodes.get(e);this.nodes.delete(e),t&&(this.area.removeChild(t.el),t.destroy())}},{key:"addConnection",value:function(e){if(!e.input.node||!e.output.node)throw new Error("Connection input or output not added to node");var t=this.nodes.get(e.input.node),n=this.nodes.get(e.output.node);if(!t||!n)throw new Error("View node not found for input or output");var r=new W(e,t,n,this);this.connections.set(e,r),this.area.appendChild(r.el)}},{key:"removeConnection",value:function(e){var t=this.connections.get(e);this.connections.delete(e),t&&this.area.removeChild(t.el)}},{key:"updateConnections",value:function(e){var t=this;e.node.getConnections().forEach((function(e){var n=t.connections.get(e);if(!n)throw new Error("Connection view not found");n.update()}))}},{key:"resize",value:function(){var e=this.container;if(!e.parentElement)throw new Error("Container doesn't have parent element");var t=e.parentElement.clientWidth,n=e.parentElement.clientHeight;e.style.width=t+"px",e.style.height=n+"px"}},{key:"click",value:function(e){var t=this.container;t===e.target&&this.trigger("click",{e:e,container:t})}}]),t}(D),J=function(){function e(){m(this,e),b(this,"list",[])}return y(e,[{key:"add",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];t?this.contains(e)||this.list.push(e):this.list=[e]}},{key:"clear",value:function(){this.list=[]}},{key:"remove",value:function(e){this.list.splice(this.list.indexOf(e),1)}},{key:"contains",value:function(e){return-1!==this.list.indexOf(e)}},{key:"each",value:function(e){this.list.forEach(e)}}]),e}(),Z=function e(t){m(this,e),b(this,"handlers",void 0),this.handlers=A({warn:[console.warn],error:[console.error],componentregister:[],destroy:[]},t)},X=function(e){function t(){return m(this,t),B(this,C(t).call(this,{nodecreate:[],nodecreated:[],noderemove:[],noderemoved:[],connectioncreate:[],connectioncreated:[],connectionremove:[],connectionremoved:[],translatenode:[],nodetranslate:[],nodetranslated:[],nodedraged:[],nodedragged:[],selectnode:[],multiselectnode:[],nodeselect:[],nodeselected:[],rendernode:[],rendersocket:[],rendercontrol:[],renderconnection:[],updateconnection:[],keydown:[],keyup:[],translate:[],translated:[],zoom:[],zoomed:[],click:[],mousemove:[],contextmenu:[],import:[],export:[],process:[],clear:[]}))}return w(t,e),t}(Z),G=function(e){function t(e,n){var r;return m(this,t),b(k(r=B(this,C(t).call(this,e,new X))),"nodes",[]),b(k(r),"selected",new J),b(k(r),"view",void 0),r.view=new K(n,r.components,k(r)),r.on("destroy",z("keydown",(function(e){return r.trigger("keydown",e)}))),r.on("destroy",z("keyup",(function(e){return r.trigger("keyup",e)}))),r.on("selectnode",(function(e){var t=e.node,n=e.accumulate;return r.selectNode(t,n)})),r.on("nodeselected",(function(){return r.selected.each((function(e){var t=r.view.nodes.get(e);t&&t.onStart()}))})),r.on("translatenode",(function(e){var t=e.dx,n=e.dy;return r.selected.each((function(e){var o=r.view.nodes.get(e);o&&o.onDrag(t,n)}))})),r}var n;return w(t,e),y(t,[{key:"addNode",value:function(e){this.trigger("nodecreate",e)&&(this.nodes.push(e),this.view.addNode(e),this.trigger("nodecreated",e))}},{key:"removeNode",value:function(e){var t=this;this.trigger("noderemove",e)&&(e.getConnections().forEach((function(e){return t.removeConnection(e)})),this.nodes.splice(this.nodes.indexOf(e),1),this.view.removeNode(e),this.trigger("noderemoved",e))}},{key:"connect",value:function(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};if(this.trigger("connectioncreate",{output:e,input:t}))try{var r=e.connectTo(t);r.data=n,this.view.addConnection(r),this.trigger("connectioncreated",r)}catch(e){this.trigger("warn",e)}}},{key:"removeConnection",value:function(e){this.trigger("connectionremove",e)&&(this.view.removeConnection(e),e.remove(),this.trigger("connectionremoved",e))}},{key:"selectNode",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if(-1===this.nodes.indexOf(e))throw new Error("Node not exist in list");this.trigger("nodeselect",e)&&(this.selected.add(e,t),this.trigger("nodeselected",e))}},{key:"getComponent",value:function(e){var t=this.components.get(e);if(!t)throw"Component ".concat(e," not found");return t}},{key:"register",value:function(e){_(C(t.prototype),"register",this).call(this,e),e.editor=this}},{key:"clear",value:function(){var e=this;E(this.nodes).forEach((function(t){return e.removeNode(t)})),this.trigger("clear")}},{key:"toJSON",value:function(){var e={id:this.id,nodes:{}};return this.nodes.forEach((function(t){return e.nodes[t.id]=t.toJSON()})),this.trigger("export",e),e}},{key:"beforeImport",value:function(e){var t=P.validate(this.id,e);return t.success?(this.silent=!0,this.clear(),this.trigger("import",e),!0):(this.trigger("warn",t.msg),!1)}},{key:"afterImport",value:function(){return this.silent=!1,!0}},{key:"fromJSON",value:(n=v(regeneratorRuntime.mark((function e(t){var n,r=this;return regeneratorRuntime.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:if(this.beforeImport(t)){e.next=2;break}return e.abrupt("return",!1);case 2:return n={},e.prev=3,e.next=6,Promise.all(Object.keys(t.nodes).map(function(){var e=v(regeneratorRuntime.mark((function e(o){var i,a;return regeneratorRuntime.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:return i=t.nodes[o],a=r.getComponent(i.name),e.next=4,a.build(O.fromJSON(i));case 4:n[o]=e.sent,r.addNode(n[o]);case 6:case"end":return e.stop()}}),e)})));return function(t){return e.apply(this,arguments)}}()));case 6:Object.keys(t.nodes).forEach((function(e){var o=t.nodes[e],i=n[e];Object.keys(o.outputs).forEach((function(e){o.outputs[e].connections.forEach((function(t){var o=t.node,a=t.data,s=i.outputs.get(e),c=n[o].inputs.get(t.input);if(!s||!c)return r.trigger("error","IO not found for node ".concat(i.id));r.connect(s,c,a)}))}))})),e.next=13;break;case 9:return e.prev=9,e.t0=e.catch(3),this.trigger("warn",e.t0),e.abrupt("return",!this.afterImport());case 13:return e.abrupt("return",this.afterImport());case 14:case"end":return e.stop()}}),e,this,[[3,9]])}))),function(e){return n.apply(this,arguments)})}]),t}(F),Q=function(e){function t(e,n,r){var o=!(arguments.length>3&&void 0!==arguments[3])||arguments[3];return m(this,t),B(this,C(t).call(this,e,n,r,o))}return w(t,e),y(t,[{key:"hasConnection",value:function(){return this.connections.length>0}},{key:"connectTo",value:function(e){if(!this.socket.compatibleWith(e.socket))throw new Error("Sockets not compatible");if(!e.multipleConnections&&e.hasConnection())throw new Error("Input already has one connection");if(!this.multipleConnections&&this.hasConnection())throw new Error("Output already has one connection");var t=new T(this,e);return this.connections.push(t),t}},{key:"connectedTo",value:function(e){return this.connections.some((function(t){return t.input===e}))}},{key:"toJSON",value:function(){return{connections:this.connections.map((function(e){if(!e.input.node)throw new Error("Node not added to Input");return{node:e.input.node.id,input:e.input.key,data:e.data}}))}}}]),t}(j),ee=function(){function e(t){var n=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};m(this,e),b(this,"name",void 0),b(this,"data",void 0),b(this,"compatible",[]),this.name=t,this.data=n,this.compatible=[]}return y(e,[{key:"combineWith",value:function(e){this.compatible.push(e)}},{key:"compatibleWith",value:function(e){return this===e||this.compatible.includes(e)}}]),e}(),te=function(){function e(t){m(this,e),b(this,"nodes",void 0),this.nodes=t}return y(e,[{key:"extractInputNodes",value:function(e){var t=this;return Object.keys(e.inputs).reduce((function(n,r){var o=(e.inputs[r].connections||[]).reduce((function(e,n){return[].concat(E(e),[t.nodes[n.node]])}),[]);return[].concat(E(n),E(o))}),[])}},{key:"findSelf",value:function(e,t){var n,r=(n=t,e.filter((function(e){return-1!==n.indexOf(e)})));if(r.length)return r[0];var o=!0,i=!1,a=void 0;try{for(var s,c=t[Symbol.iterator]();!(o=(s=c.next()).done);o=!0){var u=s.value,l=[u].concat(E(e)),d=this.findSelf(l,this.extractInputNodes(u));if(d)return d}}catch(e){i=!0,a=e}finally{try{o||null==c.return||c.return()}finally{if(i)throw a}}return null}},{key:"detect",value:function(){var e=this,t=Object.keys(this.nodes).map((function(t){return e.nodes[t]})),n=!0,r=!1,o=void 0;try{for(var i,a=t[Symbol.iterator]();!(n=(i=a.next()).done);n=!0){var s=i.value,c=this.findSelf([s],this.extractInputNodes(s));if(c)return c}}catch(e){r=!0,o=e}finally{try{n||null==a.return||a.return()}finally{if(r)throw o}}return null}}]),e}(),ne=function(e){function t(){return m(this,t),B(this,C(t).call(this,{}))}return w(t,e),t}(Z),re={Engine:function(e){function t(e){var n;return m(this,t),b(k(n=B(this,C(t).call(this,e,new ne))),"args",[]),b(k(n),"data",null),b(k(n),"state",0),b(k(n),"onAbort",(function(){})),n}var n,r,o,i,a,s,c,u,l,d,p;return w(t,e),y(t,[{key:"clone",value:function(){var e=new t(this.id);return this.components.forEach((function(t){return e.register(t)})),e}},{key:"throwError",value:(p=v(regeneratorRuntime.mark((function e(t){var n,r=arguments;return regeneratorRuntime.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:return n=r.length>1&&void 0!==r[1]?r[1]:null,e.next=3,this.abort();case 3:return this.trigger("error",{message:t,data:n}),this.processDone(),e.abrupt("return","error");case 6:case"end":return e.stop()}}),e,this)}))),function(e){return p.apply(this,arguments)})},{key:"processStart",value:function(){return 0===this.state?(this.state=1,!0):(2===this.state||console.warn("The process is busy and has not been restarted.\n                Use abort() to force it to complete"),!1)}},{key:"processDone",value:function(){var e=2!==this.state;return this.state=0,e||(this.onAbort(),this.onAbort=function(){}),e}},{key:"abort",value:(d=v(regeneratorRuntime.mark((function e(){var t=this;return regeneratorRuntime.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:return e.abrupt("return",new Promise((function(e){1===t.state?(t.state=2,t.onAbort=e):2===t.state?(t.onAbort(),t.onAbort=e):e()})));case 1:case"end":return e.stop()}}),e)}))),function(){return d.apply(this,arguments)})},{key:"lock",value:(l=v(regeneratorRuntime.mark((function e(t){return regeneratorRuntime.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:return e.abrupt("return",new Promise((function(e){t.unlockPool=t.unlockPool||[],t.busy&&!t.outputData?t.unlockPool.push(e):e(),t.busy=!0})));case 1:case"end":return e.stop()}}),e)}))),function(e){return l.apply(this,arguments)})},{key:"unlock",value:function(e){e.unlockPool.forEach((function(e){return e()})),e.unlockPool=[],e.busy=!1}},{key:"extractInputData",value:(u=v(regeneratorRuntime.mark((function e(t){var n,r,o,i,a,s,c,u=this;return regeneratorRuntime.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:n={},r=0,o=Object.keys(t.inputs);case 2:if(!(r<o.length)){e.next=13;break}return i=o[r],a=t.inputs[i],s=a.connections,e.next=8,Promise.all(s.map(function(){var e=v(regeneratorRuntime.mark((function e(t){var n,r;return regeneratorRuntime.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:return n=u.data.nodes[t.node],e.next=3,u.processNode(n);case 3:if(r=e.sent){e.next=8;break}u.abort(),e.next=9;break;case 8:return e.abrupt("return",r[t.output]);case 9:case"end":return e.stop()}}),e)})));return function(t){return e.apply(this,arguments)}}()));case 8:c=e.sent,n[i]=c;case 10:r++,e.next=2;break;case 13:return e.abrupt("return",n);case 14:case"end":return e.stop()}}),e)}))),function(e){return u.apply(this,arguments)})},{key:"processWorker",value:(c=v(regeneratorRuntime.mark((function e(t){var n,r,o;return regeneratorRuntime.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:return e.next=2,this.extractInputData(t);case 2:return n=e.sent,r=this.components.get(t.name),o={},e.prev=5,e.next=8,r.worker.apply(r,[t,n,o].concat(E(this.args)));case 8:e.next=14;break;case 10:e.prev=10,e.t0=e.catch(5),this.abort(),this.trigger("warn",e.t0);case 14:return e.abrupt("return",o);case 15:case"end":return e.stop()}}),e,this,[[5,10]])}))),function(e){return c.apply(this,arguments)})},{key:"processNode",value:(s=v(regeneratorRuntime.mark((function e(t){return regeneratorRuntime.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:if(2!==this.state&&t){e.next=2;break}return e.abrupt("return",null);case 2:return e.next=4,this.lock(t);case 4:if(t.outputData){e.next=8;break}return e.next=7,this.processWorker(t);case 7:t.outputData=e.sent;case 8:return this.unlock(t),e.abrupt("return",t.outputData);case 10:case"end":return e.stop()}}),e,this)}))),function(e){return s.apply(this,arguments)})},{key:"forwardProcess",value:(a=v(regeneratorRuntime.mark((function e(t){var n=this;return regeneratorRuntime.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:if(2!==this.state){e.next=2;break}return e.abrupt("return",null);case 2:return e.next=4,Promise.all(Object.keys(t.outputs).map(function(){var e=v(regeneratorRuntime.mark((function e(r){var o;return regeneratorRuntime.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:return o=t.outputs[r],e.next=3,Promise.all(o.connections.map(function(){var e=v(regeneratorRuntime.mark((function e(t){var r;return regeneratorRuntime.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:return r=n.data.nodes[t.node],e.next=3,n.processNode(r);case 3:return e.next=5,n.forwardProcess(r);case 5:case"end":return e.stop()}}),e)})));return function(t){return e.apply(this,arguments)}}()));case 3:return e.abrupt("return",e.sent);case 4:case"end":return e.stop()}}),e)})));return function(t){return e.apply(this,arguments)}}()));case 4:return e.abrupt("return",e.sent);case 5:case"end":return e.stop()}}),e,this)}))),function(e){return a.apply(this,arguments)})},{key:"copy",value:function(e){return(e=Object.assign({},e)).nodes=Object.assign({},e.nodes),Object.keys(e.nodes).forEach((function(t){e.nodes[t]=Object.assign({},e.nodes[t])})),e}},{key:"validate",value:(i=v(regeneratorRuntime.mark((function e(t){var n,r,o;return regeneratorRuntime.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:if(n=P.validate(this.id,t),r=new te(t.nodes),n.success){e.next=6;break}return e.next=5,this.throwError(n.msg);case 5:return e.abrupt("return",e.sent);case 6:if(!(o=r.detect())){e.next=11;break}return e.next=10,this.throwError("Recursion detected",o);case 10:return e.abrupt("return",e.sent);case 11:return e.abrupt("return",!0);case 12:case"end":return e.stop()}}),e,this)}))),function(e){return i.apply(this,arguments)})},{key:"processStartNode",value:(o=v(regeneratorRuntime.mark((function e(t){var n;return regeneratorRuntime.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:if(t){e.next=2;break}return e.abrupt("return");case 2:if(n=this.data.nodes[t]){e.next=7;break}return e.next=6,this.throwError("Node with such id not found");case 6:return e.abrupt("return",e.sent);case 7:return e.next=9,this.processNode(n);case 9:return e.next=11,this.forwardProcess(n);case 11:case"end":return e.stop()}}),e,this)}))),function(e){return o.apply(this,arguments)})},{key:"processUnreachable",value:(r=v(regeneratorRuntime.mark((function e(){var t,n,r;return regeneratorRuntime.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:t=this.data,e.t0=regeneratorRuntime.keys(t.nodes);case 2:if((e.t1=e.t0()).done){e.next=12;break}if(n=e.t1.value,void 0!==(r=t.nodes[n]).outputData){e.next=10;break}return e.next=8,this.processNode(r);case 8:return e.next=10,this.forwardProcess(r);case 10:e.next=2;break;case 12:case"end":return e.stop()}}),e,this)}))),function(){return r.apply(this,arguments)})},{key:"process",value:(n=v(regeneratorRuntime.mark((function e(t){var n,r,o,i,a=arguments;return regeneratorRuntime.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:if(n=a.length>1&&void 0!==a[1]?a[1]:null,this.processStart()){e.next=3;break}return e.abrupt("return");case 3:if(this.validate(t)){e.next=5;break}return e.abrupt("return");case 5:for(this.data=this.copy(t),r=a.length,o=new Array(r>2?r-2:0),i=2;i<r;i++)o[i-2]=a[i];return this.args=o,e.next=10,this.processStartNode(n);case 10:return e.next=12,this.processUnreachable();case 12:return e.abrupt("return",this.processDone()?"success":"aborted");case 13:case"end":return e.stop()}}),e,this)}))),function(e){return n.apply(this,arguments)})}]),t}(F),Recursion:te,Component:N,Control:L,Connection:T,Emitter:D,Input:R,IO:j,Node:O,NodeEditor:G,Output:Q,Socket:ee};function oe(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function ie(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function ae(e,t,n){return t&&ie(e.prototype,t),n&&ie(e,n),e}function se(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function ce(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=[],r=!0,o=!1,i=void 0;try{for(var a,s=e[Symbol.iterator]();!(r=(a=s.next()).done)&&(n.push(a.value),!t||n.length!==t);r=!0);}catch(e){o=!0,i=e}finally{try{r||null==s.return||s.return()}finally{if(o)throw i}}return n}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance")}()}function ue(e){return e.toLowerCase().replace(/ /g,"-")}function le(e,t){return e.get(t)||(t.parentElement?le(e,t.parentElement):null)}function de(e,t,n){var r={points:t,connection:n,d:""};return e.trigger("connectionpath",r),r.d||function(e,t){var n=ce(e,4),r=n[0],o=n[1],i=n[2],a=n[3],s=r+.4*Math.abs(i-r),c=i-.4*Math.abs(i-r);return"M ".concat(r," ").concat(o," C ").concat(s," ").concat(o," ").concat(c," ").concat(a," ").concat(i," ").concat(a)}(t)}function pe(e){var t=e.el,n=e.d,r=t.querySelector(".connection path");if(!r)throw new Error("Path of connection was broken");r.setAttribute("d",n)}function fe(e){var t,n=e.el,r=e.d,o=e.connection,i=o?["input-"+ue(o.input.name),"output-"+ue(o.output.name),"socket-input-"+ue(o.input.socket.name),"socket-output-"+ue(o.output.socket.name)]:[],a=document.createElementNS("http://www.w3.org/2000/svg","svg"),s=document.createElementNS("http://www.w3.org/2000/svg","path");(t=a.classList).add.apply(t,["connection"].concat(i)),s.classList.add("main-path"),s.setAttribute("d",r),a.appendChild(s),n.appendChild(a),pe({el:n,d:r})}var he=function(){function e(t,n){oe(this,e),this.emitter=t,this.editorView=n,se(this,"el",void 0),this.el=document.createElement("div"),this.el.style.position="absolute",this.editorView.area.appendChild(this.el)}return ae(e,[{key:"updatePseudoConnection",value:function(e){null!==e?this.renderConnection(e):this.el.parentElement&&(this.el.innerHTML="")}},{key:"getPoints",value:function(e){var t=this.editorView.area.mouse;if(!e.node)throw new Error("Node in output/input not found");var n=this.editorView.nodes.get(e.node);if(!n)throw new Error("Node view not found");var r=ce(n.getSocketPosition(e),2),o=r[0],i=r[1];return e instanceof Q?[o,i,t.x,t.y]:[t.x,t.y,o,i]}},{key:"updateConnection",value:function(e){var t=de(this.emitter,this.getPoints(e));pe({el:this.el,d:t})}},{key:"renderConnection",value:function(e){var t=de(this.emitter,this.getPoints(e));fe({el:this.el,d:t})}}]),e}(),ve=function(){function e(t){var n=this;oe(this,e),se(this,"editor",void 0),se(this,"_io",null),se(this,"view",void 0),this.editor=t,this.view=new he(t,t.view),t.on("mousemove",(function(){return n.io&&n.view.updateConnection(n.io)}))}return ae(e,[{key:"reset",value:function(){this.io=null}},{key:"pickOutput",value:function(e){if(this.editor.trigger("connectionpick",e)){if(this.io instanceof R)return!e.multipleConnections&&e.hasConnection()&&this.editor.removeConnection(e.connections[0]),this.editor.connect(e,this.io),void this.reset();this.io&&this.reset(),this.io=e}}},{key:"pickInput",value:function(e){var t=this;if(this.editor.trigger("connectionpick",e)){if(null===this.io)return e.hasConnection()?(this.io=e.connections[0].output,this.editor.removeConnection(e.connections[0])):this.io=e,!0;if(!e.multipleConnections&&e.hasConnection()&&this.editor.removeConnection(e.connections[0]),!this.io.multipleConnections&&this.io.hasConnection()&&this.editor.removeConnection(this.io.connections[0]),this.io instanceof Q&&this.io.connectedTo(e)){var n=e.connections.find((function(e){return e.output===t.io}));n&&this.editor.removeConnection(n)}this.io instanceof Q&&(this.editor.connect(this.io,e),this.reset())}}},{key:"pickConnection",value:function(e){var t=e.output;this.editor.removeConnection(e),this.io=t}},{key:"io",get:function(){return this._io},set:function(e){this._io=e,this.view.updatePseudoConnection(e)}}]),e}(),me=function(){function e(t){oe(this,e),se(this,"picker",void 0),se(this,"target",void 0),this.picker=t,this.target=null}return ae(e,[{key:"act",value:function(e){var t=e.input,n=e.output;this.unlock(t||n)||(t?this.picker.pickInput(t):n?this.picker.pickOutput(n):this.picker.reset())}},{key:"start",value:function(e,t){this.act(e),this.target=t}},{key:"complete",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};this.act(e)}},{key:"hasTarget",value:function(){return Boolean(this.target)}},{key:"unlock",value:function(e){var t=this.target;return this.target=null,t&&t===e}}]),e}();!function(e){if("undefined"!=typeof window){var t=document.createElement("style");t.setAttribute("type","text/css"),t.innerHTML=e,document.head.appendChild(t)}}(".connection {\n  overflow: visible !important;\n  position: absolute;\n  z-index: -1;\n  pointer-events: none; }\n  .connection > * {\n    pointer-events: all; }\n  .connection .main-path {\n    fill: none;\n    stroke-width: 5px;\n    stroke: steelblue; }\n");var ge={name:"connection",install:function(e){e.bind("connectionpath"),e.bind("connectiondrop"),e.bind("connectionpick"),e.bind("resetconnection");var t=new ve(e),n=new me(t),r=new WeakMap;function o(t){var o=r.get(this);if(o){var i=o.input,a=o.output;e.view.container.dispatchEvent(new PointerEvent("pointermove",t)),t.preventDefault(),t.stopPropagation(),n.start({input:i,output:a},i||a)}}function i(o){var i=document.elementFromPoint(o.clientX,o.clientY);t.io&&e.trigger("connectiondrop",t.io),i&&n.complete(le(r,i)||{})}e.on("resetconnection",(function(){return n.complete()})),e.on("rendersocket",(function(e){var t=e.el,n=e.input,i=e.output;r.set(t,{input:n,output:i}),t.removeEventListener("pointerdown",o),t.addEventListener("pointerdown",o)})),window.addEventListener("pointerup",i),e.on("renderconnection",(function(t){var n=t.el,r=t.connection,o=t.points;fe({el:n,d:de(e,o,r),connection:r})})),e.on("updateconnection",(function(t){var n=t.el,r=t.connection,o=t.points;pe({el:n,d:de(e,o,r)})})),e.on("destroy",(function(){window.removeEventListener("pointerup",i)}))}},ye=function(e){var t=typeof e;return null!=e&&("object"==t||"function"==t)},be="object"==typeof n.g&&n.g&&n.g.Object===Object&&n.g,Ae="object"==typeof self&&self&&self.Object===Object&&self,we=be||Ae||Function("return this")(),Ce=function(){return we.Date.now()},xe=we.Symbol,ke=Object.prototype,Be=ke.hasOwnProperty,_e=ke.toString,$e=xe?xe.toStringTag:void 0,Se=Object.prototype.toString,Ee=xe?xe.toStringTag:void 0,Ie=function(e){return null==e?void 0===e?"[object Undefined]":"[object Null]":Ee&&Ee in Object(e)?function(e){var t=Be.call(e,$e),n=e[$e];try{e[$e]=void 0;var r=!0}catch(e){}var o=_e.call(e);return r&&(t?e[$e]=n:delete e[$e]),o}(e):function(e){return Se.call(e)}(e)},Oe=/^\s+|\s+$/g,Ne=/^[-+]0x[0-9a-f]+$/i,Te=/^0b[01]+$/i,Le=/^0o[0-7]+$/i,De=parseInt,je=function(e){if("number"==typeof e)return e;if(function(e){return"symbol"==typeof e||function(e){return null!=e&&"object"==typeof e}(e)&&"[object Symbol]"==Ie(e)}(e))return NaN;if(ye(e)){var t="function"==typeof e.valueOf?e.valueOf():e;e=ye(t)?t+"":t}if("string"!=typeof e)return 0===e?e:+e;e=e.replace(Oe,"");var n=Te.test(e);return n||Le.test(e)?De(e.slice(2),n?2:8):Ne.test(e)?NaN:+e},Re=Math.max,Pe=Math.min,Fe=Object.freeze({});function ze(e){return null==e}function Me(e){return null!=e}function Ue(e){return!0===e}function Ve(e){return"string"==typeof e||"number"==typeof e||"symbol"==typeof e||"boolean"==typeof e}function We(e){return null!==e&&"object"==typeof e}var He=Object.prototype.toString;function Ye(e){return"[object Object]"===He.call(e)}function qe(e){var t=parseFloat(String(e));return t>=0&&Math.floor(t)===t&&isFinite(e)}function Ke(e){return Me(e)&&"function"==typeof e.then&&"function"==typeof e.catch}function Je(e){return null==e?"":Array.isArray(e)||Ye(e)&&e.toString===He?JSON.stringify(e,null,2):String(e)}function Ze(e){var t=parseFloat(e);return isNaN(t)?e:t}function Xe(e,t){for(var n=Object.create(null),r=e.split(","),o=0;o<r.length;o++)n[r[o]]=!0;return t?function(e){return n[e.toLowerCase()]}:function(e){return n[e]}}var Ge=Xe("slot,component",!0),Qe=Xe("key,ref,slot,slot-scope,is");function et(e,t){if(e.length){var n=e.indexOf(t);if(n>-1)return e.splice(n,1)}}var tt=Object.prototype.hasOwnProperty;function nt(e,t){return tt.call(e,t)}function rt(e){var t=Object.create(null);return function(n){return t[n]||(t[n]=e(n))}}var ot=/-(\w)/g,it=rt((function(e){return e.replace(ot,(function(e,t){return t?t.toUpperCase():""}))})),at=rt((function(e){return e.charAt(0).toUpperCase()+e.slice(1)})),st=/\B([A-Z])/g,ct=rt((function(e){return e.replace(st,"-$1").toLowerCase()})),ut=Function.prototype.bind?function(e,t){return e.bind(t)}:function(e,t){function n(n){var r=arguments.length;return r?r>1?e.apply(t,arguments):e.call(t,n):e.call(t)}return n._length=e.length,n};function lt(e,t){t=t||0;for(var n=e.length-t,r=new Array(n);n--;)r[n]=e[n+t];return r}function dt(e,t){for(var n in t)e[n]=t[n];return e}function pt(e){for(var t={},n=0;n<e.length;n++)e[n]&&dt(t,e[n]);return t}function ft(e,t,n){}var ht=function(e,t,n){return!1},vt=function(e){return e};function mt(e,t){if(e===t)return!0;var n=We(e),r=We(t);if(!n||!r)return!n&&!r&&String(e)===String(t);try{var o=Array.isArray(e),i=Array.isArray(t);if(o&&i)return e.length===t.length&&e.every((function(e,n){return mt(e,t[n])}));if(e instanceof Date&&t instanceof Date)return e.getTime()===t.getTime();if(o||i)return!1;var a=Object.keys(e),s=Object.keys(t);return a.length===s.length&&a.every((function(n){return mt(e[n],t[n])}))}catch(e){return!1}}function gt(e,t){for(var n=0;n<e.length;n++)if(mt(e[n],t))return n;return-1}function yt(e){var t=!1;return function(){t||(t=!0,e.apply(this,arguments))}}var bt="data-server-rendered",At=["component","directive","filter"],wt=["beforeCreate","created","beforeMount","mounted","beforeUpdate","updated","beforeDestroy","destroyed","activated","deactivated","errorCaptured","serverPrefetch"],Ct={optionMergeStrategies:Object.create(null),silent:!1,productionTip:!1,devtools:!1,performance:!1,errorHandler:null,warnHandler:null,ignoredElements:[],keyCodes:Object.create(null),isReservedTag:ht,isReservedAttr:ht,isUnknownElement:ht,getTagNamespace:ft,parsePlatformTagName:vt,mustUseProp:ht,async:!0,_lifecycleHooks:wt},xt=/a-zA-Z\u00B7\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u037D\u037F-\u1FFF\u200C-\u200D\u203F-\u2040\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD/;function kt(e){var t=(e+"").charCodeAt(0);return 36===t||95===t}function Bt(e,t,n,r){Object.defineProperty(e,t,{value:n,enumerable:!!r,writable:!0,configurable:!0})}var _t,$t=new RegExp("[^"+xt.source+".$_\\d]"),St="__proto__"in{},Et="undefined"!=typeof window,It="undefined"!=typeof WXEnvironment&&!!WXEnvironment.platform,Ot=It&&WXEnvironment.platform.toLowerCase(),Nt=Et&&window.navigator.userAgent.toLowerCase(),Tt=Nt&&/msie|trident/.test(Nt),Lt=Nt&&Nt.indexOf("msie 9.0")>0,Dt=Nt&&Nt.indexOf("edge/")>0,jt=(Nt&&Nt.indexOf("android"),Nt&&/iphone|ipad|ipod|ios/.test(Nt)||"ios"===Ot),Rt=(Nt&&/chrome\/\d+/.test(Nt),Nt&&/phantomjs/.test(Nt),Nt&&Nt.match(/firefox\/(\d+)/)),Pt={}.watch,Ft=!1;if(Et)try{var zt={};Object.defineProperty(zt,"passive",{get:function(){Ft=!0}}),window.addEventListener("test-passive",null,zt)}catch(e){}var Mt=function(){return void 0===_t&&(_t=!Et&&!It&&void 0!==n.g&&n.g.process&&"server"===n.g.process.env.VUE_ENV),_t},Ut=Et&&window.__VUE_DEVTOOLS_GLOBAL_HOOK__;function Vt(e){return"function"==typeof e&&/native code/.test(e.toString())}var Wt,Ht="undefined"!=typeof Symbol&&Vt(Symbol)&&"undefined"!=typeof Reflect&&Vt(Reflect.ownKeys);Wt="undefined"!=typeof Set&&Vt(Set)?Set:function(){function e(){this.set=Object.create(null)}return e.prototype.has=function(e){return!0===this.set[e]},e.prototype.add=function(e){this.set[e]=!0},e.prototype.clear=function(){this.set=Object.create(null)},e}();var Yt=ft,qt=0,Kt=function(){this.id=qt++,this.subs=[]};Kt.prototype.addSub=function(e){this.subs.push(e)},Kt.prototype.removeSub=function(e){et(this.subs,e)},Kt.prototype.depend=function(){Kt.target&&Kt.target.addDep(this)},Kt.prototype.notify=function(){for(var e=this.subs.slice(),t=0,n=e.length;t<n;t++)e[t].update()},Kt.target=null;var Jt=[];function Zt(e){Jt.push(e),Kt.target=e}function Xt(){Jt.pop(),Kt.target=Jt[Jt.length-1]}var Gt=function(e,t,n,r,o,i,a,s){this.tag=e,this.data=t,this.children=n,this.text=r,this.elm=o,this.ns=void 0,this.context=i,this.fnContext=void 0,this.fnOptions=void 0,this.fnScopeId=void 0,this.key=t&&t.key,this.componentOptions=a,this.componentInstance=void 0,this.parent=void 0,this.raw=!1,this.isStatic=!1,this.isRootInsert=!0,this.isComment=!1,this.isCloned=!1,this.isOnce=!1,this.asyncFactory=s,this.asyncMeta=void 0,this.isAsyncPlaceholder=!1},Qt={child:{configurable:!0}};Qt.child.get=function(){return this.componentInstance},Object.defineProperties(Gt.prototype,Qt);var en=function(e){void 0===e&&(e="");var t=new Gt;return t.text=e,t.isComment=!0,t};function tn(e){return new Gt(void 0,void 0,void 0,String(e))}function nn(e){var t=new Gt(e.tag,e.data,e.children&&e.children.slice(),e.text,e.elm,e.context,e.componentOptions,e.asyncFactory);return t.ns=e.ns,t.isStatic=e.isStatic,t.key=e.key,t.isComment=e.isComment,t.fnContext=e.fnContext,t.fnOptions=e.fnOptions,t.fnScopeId=e.fnScopeId,t.asyncMeta=e.asyncMeta,t.isCloned=!0,t}var rn=Array.prototype,on=Object.create(rn);["push","pop","shift","unshift","splice","sort","reverse"].forEach((function(e){var t=rn[e];Bt(on,e,(function(){for(var n=[],r=arguments.length;r--;)n[r]=arguments[r];var o,i=t.apply(this,n),a=this.__ob__;switch(e){case"push":case"unshift":o=n;break;case"splice":o=n.slice(2)}return o&&a.observeArray(o),a.dep.notify(),i}))}));var an=Object.getOwnPropertyNames(on),sn=!0;function cn(e){sn=e}var un=function(e){this.value=e,this.dep=new Kt,this.vmCount=0,Bt(e,"__ob__",this),Array.isArray(e)?(St?function(e,t){e.__proto__=t}(e,on):function(e,t,n){for(var r=0,o=n.length;r<o;r++){var i=n[r];Bt(e,i,t[i])}}(e,on,an),this.observeArray(e)):this.walk(e)};function ln(e,t){var n;if(We(e)&&!(e instanceof Gt))return nt(e,"__ob__")&&e.__ob__ instanceof un?n=e.__ob__:sn&&!Mt()&&(Array.isArray(e)||Ye(e))&&Object.isExtensible(e)&&!e._isVue&&(n=new un(e)),t&&n&&n.vmCount++,n}function dn(e,t,n,r,o){var i=new Kt,a=Object.getOwnPropertyDescriptor(e,t);if(!a||!1!==a.configurable){var s=a&&a.get,c=a&&a.set;s&&!c||2!==arguments.length||(n=e[t]);var u=!o&&ln(n);Object.defineProperty(e,t,{enumerable:!0,configurable:!0,get:function(){var t=s?s.call(e):n;return Kt.target&&(i.depend(),u&&(u.dep.depend(),Array.isArray(t)&&hn(t))),t},set:function(t){var r=s?s.call(e):n;t===r||t!=t&&r!=r||s&&!c||(c?c.call(e,t):n=t,u=!o&&ln(t),i.notify())}})}}function pn(e,t,n){if(Array.isArray(e)&&qe(t))return e.length=Math.max(e.length,t),e.splice(t,1,n),n;if(t in e&&!(t in Object.prototype))return e[t]=n,n;var r=e.__ob__;return e._isVue||r&&r.vmCount?n:r?(dn(r.value,t,n),r.dep.notify(),n):(e[t]=n,n)}function fn(e,t){if(Array.isArray(e)&&qe(t))e.splice(t,1);else{var n=e.__ob__;e._isVue||n&&n.vmCount||nt(e,t)&&(delete e[t],n&&n.dep.notify())}}function hn(e){for(var t=void 0,n=0,r=e.length;n<r;n++)(t=e[n])&&t.__ob__&&t.__ob__.dep.depend(),Array.isArray(t)&&hn(t)}un.prototype.walk=function(e){for(var t=Object.keys(e),n=0;n<t.length;n++)dn(e,t[n])},un.prototype.observeArray=function(e){for(var t=0,n=e.length;t<n;t++)ln(e[t])};var vn=Ct.optionMergeStrategies;function mn(e,t){if(!t)return e;for(var n,r,o,i=Ht?Reflect.ownKeys(t):Object.keys(t),a=0;a<i.length;a++)"__ob__"!==(n=i[a])&&(r=e[n],o=t[n],nt(e,n)?r!==o&&Ye(r)&&Ye(o)&&mn(r,o):pn(e,n,o));return e}function gn(e,t,n){return n?function(){var r="function"==typeof t?t.call(n,n):t,o="function"==typeof e?e.call(n,n):e;return r?mn(r,o):o}:t?e?function(){return mn("function"==typeof t?t.call(this,this):t,"function"==typeof e?e.call(this,this):e)}:t:e}function yn(e,t){var n=t?e?e.concat(t):Array.isArray(t)?t:[t]:e;return n?function(e){for(var t=[],n=0;n<e.length;n++)-1===t.indexOf(e[n])&&t.push(e[n]);return t}(n):n}function bn(e,t,n,r){var o=Object.create(e||null);return t?dt(o,t):o}vn.data=function(e,t,n){return n?gn(e,t,n):t&&"function"!=typeof t?e:gn(e,t)},wt.forEach((function(e){vn[e]=yn})),At.forEach((function(e){vn[e+"s"]=bn})),vn.watch=function(e,t,n,r){if(e===Pt&&(e=void 0),t===Pt&&(t=void 0),!t)return Object.create(e||null);if(!e)return t;var o={};for(var i in dt(o,e),t){var a=o[i],s=t[i];a&&!Array.isArray(a)&&(a=[a]),o[i]=a?a.concat(s):Array.isArray(s)?s:[s]}return o},vn.props=vn.methods=vn.inject=vn.computed=function(e,t,n,r){if(!e)return t;var o=Object.create(null);return dt(o,e),t&&dt(o,t),o},vn.provide=gn;var An=function(e,t){return void 0===t?e:t};function wn(e,t,n){if("function"==typeof t&&(t=t.options),function(e,t){var n=e.props;if(n){var r,o,i={};if(Array.isArray(n))for(r=n.length;r--;)"string"==typeof(o=n[r])&&(i[it(o)]={type:null});else if(Ye(n))for(var a in n)o=n[a],i[it(a)]=Ye(o)?o:{type:o};e.props=i}}(t),function(e,t){var n=e.inject;if(n){var r=e.inject={};if(Array.isArray(n))for(var o=0;o<n.length;o++)r[n[o]]={from:n[o]};else if(Ye(n))for(var i in n){var a=n[i];r[i]=Ye(a)?dt({from:i},a):{from:a}}}}(t),function(e){var t=e.directives;if(t)for(var n in t){var r=t[n];"function"==typeof r&&(t[n]={bind:r,update:r})}}(t),!t._base&&(t.extends&&(e=wn(e,t.extends,n)),t.mixins))for(var r=0,o=t.mixins.length;r<o;r++)e=wn(e,t.mixins[r],n);var i,a={};for(i in e)s(i);for(i in t)nt(e,i)||s(i);function s(r){var o=vn[r]||An;a[r]=o(e[r],t[r],n,r)}return a}function Cn(e,t,n,r){if("string"==typeof n){var o=e[t];if(nt(o,n))return o[n];var i=it(n);if(nt(o,i))return o[i];var a=at(i);return nt(o,a)?o[a]:o[n]||o[i]||o[a]}}function xn(e,t,n,r){var o=t[e],i=!nt(n,e),a=n[e],s=_n(Boolean,o.type);if(s>-1)if(i&&!nt(o,"default"))a=!1;else if(""===a||a===ct(e)){var c=_n(String,o.type);(c<0||s<c)&&(a=!0)}if(void 0===a){a=function(e,t,n){if(nt(t,"default")){var r=t.default;return e&&e.$options.propsData&&void 0===e.$options.propsData[n]&&void 0!==e._props[n]?e._props[n]:"function"==typeof r&&"Function"!==kn(t.type)?r.call(e):r}}(r,o,e);var u=sn;cn(!0),ln(a),cn(u)}return a}function kn(e){var t=e&&e.toString().match(/^\s*function (\w+)/);return t?t[1]:""}function Bn(e,t){return kn(e)===kn(t)}function _n(e,t){if(!Array.isArray(t))return Bn(t,e)?0:-1;for(var n=0,r=t.length;n<r;n++)if(Bn(t[n],e))return n;return-1}function $n(e,t,n){Zt();try{if(t)for(var r=t;r=r.$parent;){var o=r.$options.errorCaptured;if(o)for(var i=0;i<o.length;i++)try{if(!1===o[i].call(r,e,t,n))return}catch(e){En(e,r,"errorCaptured hook")}}En(e,t,n)}finally{Xt()}}function Sn(e,t,n,r,o){var i;try{(i=n?e.apply(t,n):e.call(t))&&!i._isVue&&Ke(i)&&!i._handled&&(i.catch((function(e){return $n(e,r,o+" (Promise/async)")})),i._handled=!0)}catch(e){$n(e,r,o)}return i}function En(e,t,n){if(Ct.errorHandler)try{return Ct.errorHandler.call(null,e,t,n)}catch(t){t!==e&&In(t)}In(e)}function In(e,t,n){if(!Et&&!It||"undefined"==typeof console)throw e;console.error(e)}var On,Nn=!1,Tn=[],Ln=!1;function Dn(){Ln=!1;var e=Tn.slice(0);Tn.length=0;for(var t=0;t<e.length;t++)e[t]()}if("undefined"!=typeof Promise&&Vt(Promise)){var jn=Promise.resolve();On=function(){jn.then(Dn),jt&&setTimeout(ft)},Nn=!0}else if(Tt||"undefined"==typeof MutationObserver||!Vt(MutationObserver)&&"[object MutationObserverConstructor]"!==MutationObserver.toString())On="undefined"!=typeof setImmediate&&Vt(setImmediate)?function(){setImmediate(Dn)}:function(){setTimeout(Dn,0)};else{var Rn=1,Pn=new MutationObserver(Dn),Fn=document.createTextNode(String(Rn));Pn.observe(Fn,{characterData:!0}),On=function(){Rn=(Rn+1)%2,Fn.data=String(Rn)},Nn=!0}function zn(e,t){var n;if(Tn.push((function(){if(e)try{e.call(t)}catch(e){$n(e,t,"nextTick")}else n&&n(t)})),Ln||(Ln=!0,On()),!e&&"undefined"!=typeof Promise)return new Promise((function(e){n=e}))}var Mn=new Wt;function Un(e){Vn(e,Mn),Mn.clear()}function Vn(e,t){var n,r,o=Array.isArray(e);if(!(!o&&!We(e)||Object.isFrozen(e)||e instanceof Gt)){if(e.__ob__){var i=e.__ob__.dep.id;if(t.has(i))return;t.add(i)}if(o)for(n=e.length;n--;)Vn(e[n],t);else for(n=(r=Object.keys(e)).length;n--;)Vn(e[r[n]],t)}}var Wn=rt((function(e){var t="&"===e.charAt(0),n="~"===(e=t?e.slice(1):e).charAt(0),r="!"===(e=n?e.slice(1):e).charAt(0);return{name:e=r?e.slice(1):e,once:n,capture:r,passive:t}}));function Hn(e,t){function n(){var e=arguments,r=n.fns;if(!Array.isArray(r))return Sn(r,null,arguments,t,"v-on handler");for(var o=r.slice(),i=0;i<o.length;i++)Sn(o[i],null,e,t,"v-on handler")}return n.fns=e,n}function Yn(e,t,n,r,o,i){var a,s,c,u;for(a in e)s=e[a],c=t[a],u=Wn(a),ze(s)||(ze(c)?(ze(s.fns)&&(s=e[a]=Hn(s,i)),Ue(u.once)&&(s=e[a]=o(u.name,s,u.capture)),n(u.name,s,u.capture,u.passive,u.params)):s!==c&&(c.fns=s,e[a]=c));for(a in t)ze(e[a])&&r((u=Wn(a)).name,t[a],u.capture)}function qn(e,t,n){var r;e instanceof Gt&&(e=e.data.hook||(e.data.hook={}));var o=e[t];function i(){n.apply(this,arguments),et(r.fns,i)}ze(o)?r=Hn([i]):Me(o.fns)&&Ue(o.merged)?(r=o).fns.push(i):r=Hn([o,i]),r.merged=!0,e[t]=r}function Kn(e,t,n,r,o){if(Me(t)){if(nt(t,n))return e[n]=t[n],o||delete t[n],!0;if(nt(t,r))return e[n]=t[r],o||delete t[r],!0}return!1}function Jn(e){return Ve(e)?[tn(e)]:Array.isArray(e)?Xn(e):void 0}function Zn(e){return Me(e)&&Me(e.text)&&!1===e.isComment}function Xn(e,t){var n,r,o,i,a=[];for(n=0;n<e.length;n++)ze(r=e[n])||"boolean"==typeof r||(i=a[o=a.length-1],Array.isArray(r)?r.length>0&&(Zn((r=Xn(r,(t||"")+"_"+n))[0])&&Zn(i)&&(a[o]=tn(i.text+r[0].text),r.shift()),a.push.apply(a,r)):Ve(r)?Zn(i)?a[o]=tn(i.text+r):""!==r&&a.push(tn(r)):Zn(r)&&Zn(i)?a[o]=tn(i.text+r.text):(Ue(e._isVList)&&Me(r.tag)&&ze(r.key)&&Me(t)&&(r.key="__vlist"+t+"_"+n+"__"),a.push(r)));return a}function Gn(e,t){if(e){for(var n=Object.create(null),r=Ht?Reflect.ownKeys(e):Object.keys(e),o=0;o<r.length;o++){var i=r[o];if("__ob__"!==i){for(var a=e[i].from,s=t;s;){if(s._provided&&nt(s._provided,a)){n[i]=s._provided[a];break}s=s.$parent}if(!s&&"default"in e[i]){var c=e[i].default;n[i]="function"==typeof c?c.call(t):c}}}return n}}function Qn(e,t){if(!e||!e.length)return{};for(var n={},r=0,o=e.length;r<o;r++){var i=e[r],a=i.data;if(a&&a.attrs&&a.attrs.slot&&delete a.attrs.slot,i.context!==t&&i.fnContext!==t||!a||null==a.slot)(n.default||(n.default=[])).push(i);else{var s=a.slot,c=n[s]||(n[s]=[]);"template"===i.tag?c.push.apply(c,i.children||[]):c.push(i)}}for(var u in n)n[u].every(er)&&delete n[u];return n}function er(e){return e.isComment&&!e.asyncFactory||" "===e.text}function tr(e,t,n){var r,o=Object.keys(t).length>0,i=e?!!e.$stable:!o,a=e&&e.$key;if(e){if(e._normalized)return e._normalized;if(i&&n&&n!==Fe&&a===n.$key&&!o&&!n.$hasNormal)return n;for(var s in r={},e)e[s]&&"$"!==s[0]&&(r[s]=nr(t,s,e[s]))}else r={};for(var c in t)c in r||(r[c]=rr(t,c));return e&&Object.isExtensible(e)&&(e._normalized=r),Bt(r,"$stable",i),Bt(r,"$key",a),Bt(r,"$hasNormal",o),r}function nr(e,t,n){var r=function(){var e=arguments.length?n.apply(null,arguments):n({});return(e=e&&"object"==typeof e&&!Array.isArray(e)?[e]:Jn(e))&&(0===e.length||1===e.length&&e[0].isComment)?void 0:e};return n.proxy&&Object.defineProperty(e,t,{get:r,enumerable:!0,configurable:!0}),r}function rr(e,t){return function(){return e[t]}}function or(e,t){var n,r,o,i,a;if(Array.isArray(e)||"string"==typeof e)for(n=new Array(e.length),r=0,o=e.length;r<o;r++)n[r]=t(e[r],r);else if("number"==typeof e)for(n=new Array(e),r=0;r<e;r++)n[r]=t(r+1,r);else if(We(e))if(Ht&&e[Symbol.iterator]){n=[];for(var s=e[Symbol.iterator](),c=s.next();!c.done;)n.push(t(c.value,n.length)),c=s.next()}else for(i=Object.keys(e),n=new Array(i.length),r=0,o=i.length;r<o;r++)a=i[r],n[r]=t(e[a],a,r);return Me(n)||(n=[]),n._isVList=!0,n}function ir(e,t,n,r){var o,i=this.$scopedSlots[e];i?(n=n||{},r&&(n=dt(dt({},r),n)),o=i(n)||t):o=this.$slots[e]||t;var a=n&&n.slot;return a?this.$createElement("template",{slot:a},o):o}function ar(e){return Cn(this.$options,"filters",e)||vt}function sr(e,t){return Array.isArray(e)?-1===e.indexOf(t):e!==t}function cr(e,t,n,r,o){var i=Ct.keyCodes[t]||n;return o&&r&&!Ct.keyCodes[t]?sr(o,r):i?sr(i,e):r?ct(r)!==t:void 0}function ur(e,t,n,r,o){if(n&&We(n)){var i;Array.isArray(n)&&(n=pt(n));var a=function(a){if("class"===a||"style"===a||Qe(a))i=e;else{var s=e.attrs&&e.attrs.type;i=r||Ct.mustUseProp(t,s,a)?e.domProps||(e.domProps={}):e.attrs||(e.attrs={})}var c=it(a),u=ct(a);c in i||u in i||(i[a]=n[a],o&&((e.on||(e.on={}))["update:"+a]=function(e){n[a]=e}))};for(var s in n)a(s)}return e}function lr(e,t){var n=this._staticTrees||(this._staticTrees=[]),r=n[e];return r&&!t||pr(r=n[e]=this.$options.staticRenderFns[e].call(this._renderProxy,null,this),"__static__"+e,!1),r}function dr(e,t,n){return pr(e,"__once__"+t+(n?"_"+n:""),!0),e}function pr(e,t,n){if(Array.isArray(e))for(var r=0;r<e.length;r++)e[r]&&"string"!=typeof e[r]&&fr(e[r],t+"_"+r,n);else fr(e,t,n)}function fr(e,t,n){e.isStatic=!0,e.key=t,e.isOnce=n}function hr(e,t){if(t&&Ye(t)){var n=e.on=e.on?dt({},e.on):{};for(var r in t){var o=n[r],i=t[r];n[r]=o?[].concat(o,i):i}}return e}function vr(e,t,n,r){t=t||{$stable:!n};for(var o=0;o<e.length;o++){var i=e[o];Array.isArray(i)?vr(i,t,n):i&&(i.proxy&&(i.fn.proxy=!0),t[i.key]=i.fn)}return r&&(t.$key=r),t}function mr(e,t){for(var n=0;n<t.length;n+=2){var r=t[n];"string"==typeof r&&r&&(e[t[n]]=t[n+1])}return e}function gr(e,t){return"string"==typeof e?t+e:e}function yr(e){e._o=dr,e._n=Ze,e._s=Je,e._l=or,e._t=ir,e._q=mt,e._i=gt,e._m=lr,e._f=ar,e._k=cr,e._b=ur,e._v=tn,e._e=en,e._u=vr,e._g=hr,e._d=mr,e._p=gr}function br(e,t,n,r,o){var i,a=this,s=o.options;nt(r,"_uid")?(i=Object.create(r))._original=r:(i=r,r=r._original);var c=Ue(s._compiled),u=!c;this.data=e,this.props=t,this.children=n,this.parent=r,this.listeners=e.on||Fe,this.injections=Gn(s.inject,r),this.slots=function(){return a.$slots||tr(e.scopedSlots,a.$slots=Qn(n,r)),a.$slots},Object.defineProperty(this,"scopedSlots",{enumerable:!0,get:function(){return tr(e.scopedSlots,this.slots())}}),c&&(this.$options=s,this.$slots=this.slots(),this.$scopedSlots=tr(e.scopedSlots,this.$slots)),s._scopeId?this._c=function(e,t,n,o){var a=_r(i,e,t,n,o,u);return a&&!Array.isArray(a)&&(a.fnScopeId=s._scopeId,a.fnContext=r),a}:this._c=function(e,t,n,r){return _r(i,e,t,n,r,u)}}function Ar(e,t,n,r,o){var i=nn(e);return i.fnContext=n,i.fnOptions=r,t.slot&&((i.data||(i.data={})).slot=t.slot),i}function wr(e,t){for(var n in t)e[it(n)]=t[n]}yr(br.prototype);var Cr={init:function(e,t){if(e.componentInstance&&!e.componentInstance._isDestroyed&&e.data.keepAlive){var n=e;Cr.prepatch(n,n)}else(e.componentInstance=function(e,t){var n={_isComponent:!0,_parentVnode:e,parent:t},r=e.data.inlineTemplate;return Me(r)&&(n.render=r.render,n.staticRenderFns=r.staticRenderFns),new e.componentOptions.Ctor(n)}(e,Rr)).$mount(t?e.elm:void 0,t)},prepatch:function(e,t){var n=t.componentOptions;!function(e,t,n,r,o){var i=r.data.scopedSlots,a=e.$scopedSlots,s=!!(i&&!i.$stable||a!==Fe&&!a.$stable||i&&e.$scopedSlots.$key!==i.$key),c=!!(o||e.$options._renderChildren||s);if(e.$options._parentVnode=r,e.$vnode=r,e._vnode&&(e._vnode.parent=r),e.$options._renderChildren=o,e.$attrs=r.data.attrs||Fe,e.$listeners=n||Fe,t&&e.$options.props){cn(!1);for(var u=e._props,l=e.$options._propKeys||[],d=0;d<l.length;d++){var p=l[d],f=e.$options.props;u[p]=xn(p,f,t,e)}cn(!0),e.$options.propsData=t}n=n||Fe;var h=e.$options._parentListeners;e.$options._parentListeners=n,jr(e,n,h),c&&(e.$slots=Qn(o,r.context),e.$forceUpdate())}(t.componentInstance=e.componentInstance,n.propsData,n.listeners,t,n.children)},insert:function(e){var t,n=e.context,r=e.componentInstance;r._isMounted||(r._isMounted=!0,Ur(r,"mounted")),e.data.keepAlive&&(n._isMounted?((t=r)._inactive=!1,Wr.push(t)):zr(r,!0))},destroy:function(e){var t=e.componentInstance;t._isDestroyed||(e.data.keepAlive?Mr(t,!0):t.$destroy())}},xr=Object.keys(Cr);function kr(e,t,n,r,o){if(!ze(e)){var i=n.$options._base;if(We(e)&&(e=i.extend(e)),"function"==typeof e){var a;if(ze(e.cid)&&void 0===(e=function(e,t){if(Ue(e.error)&&Me(e.errorComp))return e.errorComp;if(Me(e.resolved))return e.resolved;var n=Er;if(n&&Me(e.owners)&&-1===e.owners.indexOf(n)&&e.owners.push(n),Ue(e.loading)&&Me(e.loadingComp))return e.loadingComp;if(n&&!Me(e.owners)){var r=e.owners=[n],o=!0,i=null,a=null;n.$on("hook:destroyed",(function(){return et(r,n)}));var s=function(e){for(var t=0,n=r.length;t<n;t++)r[t].$forceUpdate();e&&(r.length=0,null!==i&&(clearTimeout(i),i=null),null!==a&&(clearTimeout(a),a=null))},c=yt((function(n){e.resolved=Ir(n,t),o?r.length=0:s(!0)})),u=yt((function(t){Me(e.errorComp)&&(e.error=!0,s(!0))})),l=e(c,u);return We(l)&&(Ke(l)?ze(e.resolved)&&l.then(c,u):Ke(l.component)&&(l.component.then(c,u),Me(l.error)&&(e.errorComp=Ir(l.error,t)),Me(l.loading)&&(e.loadingComp=Ir(l.loading,t),0===l.delay?e.loading=!0:i=setTimeout((function(){i=null,ze(e.resolved)&&ze(e.error)&&(e.loading=!0,s(!1))}),l.delay||200)),Me(l.timeout)&&(a=setTimeout((function(){a=null,ze(e.resolved)&&u(null)}),l.timeout)))),o=!1,e.loading?e.loadingComp:e.resolved}}(a=e,i)))return function(e,t,n,r,o){var i=en();return i.asyncFactory=e,i.asyncMeta={data:t,context:n,children:r,tag:o},i}(a,t,n,r,o);t=t||{},uo(e),Me(t.model)&&function(e,t){var n=e.model&&e.model.prop||"value",r=e.model&&e.model.event||"input";(t.attrs||(t.attrs={}))[n]=t.model.value;var o=t.on||(t.on={}),i=o[r],a=t.model.callback;Me(i)?(Array.isArray(i)?-1===i.indexOf(a):i!==a)&&(o[r]=[a].concat(i)):o[r]=a}(e.options,t);var s=function(e,t,n){var r=t.options.props;if(!ze(r)){var o={},i=e.attrs,a=e.props;if(Me(i)||Me(a))for(var s in r){var c=ct(s);Kn(o,a,s,c,!0)||Kn(o,i,s,c,!1)}return o}}(t,e);if(Ue(e.options.functional))return function(e,t,n,r,o){var i=e.options,a={},s=i.props;if(Me(s))for(var c in s)a[c]=xn(c,s,t||Fe);else Me(n.attrs)&&wr(a,n.attrs),Me(n.props)&&wr(a,n.props);var u=new br(n,a,o,r,e),l=i.render.call(null,u._c,u);if(l instanceof Gt)return Ar(l,n,u.parent,i);if(Array.isArray(l)){for(var d=Jn(l)||[],p=new Array(d.length),f=0;f<d.length;f++)p[f]=Ar(d[f],n,u.parent,i);return p}}(e,s,t,n,r);var c=t.on;if(t.on=t.nativeOn,Ue(e.options.abstract)){var u=t.slot;t={},u&&(t.slot=u)}!function(e){for(var t=e.hook||(e.hook={}),n=0;n<xr.length;n++){var r=xr[n],o=t[r],i=Cr[r];o===i||o&&o._merged||(t[r]=o?Br(i,o):i)}}(t);var l=e.options.name||o;return new Gt("vue-component-"+e.cid+(l?"-"+l:""),t,void 0,void 0,void 0,n,{Ctor:e,propsData:s,listeners:c,tag:o,children:r},a)}}}function Br(e,t){var n=function(n,r){e(n,r),t(n,r)};return n._merged=!0,n}function _r(e,t,n,r,o,i){return(Array.isArray(n)||Ve(n))&&(o=r,r=n,n=void 0),Ue(i)&&(o=2),function(e,t,n,r,o){if(Me(n)&&Me(n.__ob__))return en();if(Me(n)&&Me(n.is)&&(t=n.is),!t)return en();var i,a,s;(Array.isArray(r)&&"function"==typeof r[0]&&((n=n||{}).scopedSlots={default:r[0]},r.length=0),2===o?r=Jn(r):1===o&&(r=function(e){for(var t=0;t<e.length;t++)if(Array.isArray(e[t]))return Array.prototype.concat.apply([],e);return e}(r)),"string"==typeof t)?(a=e.$vnode&&e.$vnode.ns||Ct.getTagNamespace(t),i=Ct.isReservedTag(t)?new Gt(Ct.parsePlatformTagName(t),n,r,void 0,void 0,e):n&&n.pre||!Me(s=Cn(e.$options,"components",t))?new Gt(t,n,r,void 0,void 0,e):kr(s,n,e,r,t)):i=kr(t,n,e,r);return Array.isArray(i)?i:Me(i)?(Me(a)&&$r(i,a),Me(n)&&function(e){We(e.style)&&Un(e.style),We(e.class)&&Un(e.class)}(n),i):en()}(e,t,n,r,o)}function $r(e,t,n){if(e.ns=t,"foreignObject"===e.tag&&(t=void 0,n=!0),Me(e.children))for(var r=0,o=e.children.length;r<o;r++){var i=e.children[r];Me(i.tag)&&(ze(i.ns)||Ue(n)&&"svg"!==i.tag)&&$r(i,t,n)}}var Sr,Er=null;function Ir(e,t){return(e.__esModule||Ht&&"Module"===e[Symbol.toStringTag])&&(e=e.default),We(e)?t.extend(e):e}function Or(e){return e.isComment&&e.asyncFactory}function Nr(e){if(Array.isArray(e))for(var t=0;t<e.length;t++){var n=e[t];if(Me(n)&&(Me(n.componentOptions)||Or(n)))return n}}function Tr(e,t){Sr.$on(e,t)}function Lr(e,t){Sr.$off(e,t)}function Dr(e,t){var n=Sr;return function r(){var o=t.apply(null,arguments);null!==o&&n.$off(e,r)}}function jr(e,t,n){Sr=e,Yn(t,n||{},Tr,Lr,Dr,e),Sr=void 0}var Rr=null;function Pr(e){var t=Rr;return Rr=e,function(){Rr=t}}function Fr(e){for(;e&&(e=e.$parent);)if(e._inactive)return!0;return!1}function zr(e,t){if(t){if(e._directInactive=!1,Fr(e))return}else if(e._directInactive)return;if(e._inactive||null===e._inactive){e._inactive=!1;for(var n=0;n<e.$children.length;n++)zr(e.$children[n]);Ur(e,"activated")}}function Mr(e,t){if(!(t&&(e._directInactive=!0,Fr(e))||e._inactive)){e._inactive=!0;for(var n=0;n<e.$children.length;n++)Mr(e.$children[n]);Ur(e,"deactivated")}}function Ur(e,t){Zt();var n=e.$options[t],r=t+" hook";if(n)for(var o=0,i=n.length;o<i;o++)Sn(n[o],e,null,e,r);e._hasHookEvent&&e.$emit("hook:"+t),Xt()}var Vr=[],Wr=[],Hr={},Yr=!1,qr=!1,Kr=0,Jr=0,Zr=Date.now;if(Et&&!Tt){var Xr=window.performance;Xr&&"function"==typeof Xr.now&&Zr()>document.createEvent("Event").timeStamp&&(Zr=function(){return Xr.now()})}function Gr(){var e,t;for(Jr=Zr(),qr=!0,Vr.sort((function(e,t){return e.id-t.id})),Kr=0;Kr<Vr.length;Kr++)(e=Vr[Kr]).before&&e.before(),t=e.id,Hr[t]=null,e.run();var n=Wr.slice(),r=Vr.slice();Kr=Vr.length=Wr.length=0,Hr={},Yr=qr=!1,function(e){for(var t=0;t<e.length;t++)e[t]._inactive=!0,zr(e[t],!0)}(n),function(e){for(var t=e.length;t--;){var n=e[t],r=n.vm;r._watcher===n&&r._isMounted&&!r._isDestroyed&&Ur(r,"updated")}}(r),Ut&&Ct.devtools&&Ut.emit("flush")}var Qr=0,eo=function(e,t,n,r,o){this.vm=e,o&&(e._watcher=this),e._watchers.push(this),r?(this.deep=!!r.deep,this.user=!!r.user,this.lazy=!!r.lazy,this.sync=!!r.sync,this.before=r.before):this.deep=this.user=this.lazy=this.sync=!1,this.cb=n,this.id=++Qr,this.active=!0,this.dirty=this.lazy,this.deps=[],this.newDeps=[],this.depIds=new Wt,this.newDepIds=new Wt,this.expression="","function"==typeof t?this.getter=t:(this.getter=function(e){if(!$t.test(e)){var t=e.split(".");return function(e){for(var n=0;n<t.length;n++){if(!e)return;e=e[t[n]]}return e}}}(t),this.getter||(this.getter=ft)),this.value=this.lazy?void 0:this.get()};eo.prototype.get=function(){var e;Zt(this);var t=this.vm;try{e=this.getter.call(t,t)}catch(e){if(!this.user)throw e;$n(e,t,'getter for watcher "'+this.expression+'"')}finally{this.deep&&Un(e),Xt(),this.cleanupDeps()}return e},eo.prototype.addDep=function(e){var t=e.id;this.newDepIds.has(t)||(this.newDepIds.add(t),this.newDeps.push(e),this.depIds.has(t)||e.addSub(this))},eo.prototype.cleanupDeps=function(){for(var e=this.deps.length;e--;){var t=this.deps[e];this.newDepIds.has(t.id)||t.removeSub(this)}var n=this.depIds;this.depIds=this.newDepIds,this.newDepIds=n,this.newDepIds.clear(),n=this.deps,this.deps=this.newDeps,this.newDeps=n,this.newDeps.length=0},eo.prototype.update=function(){this.lazy?this.dirty=!0:this.sync?this.run():function(e){var t=e.id;if(null==Hr[t]){if(Hr[t]=!0,qr){for(var n=Vr.length-1;n>Kr&&Vr[n].id>e.id;)n--;Vr.splice(n+1,0,e)}else Vr.push(e);Yr||(Yr=!0,zn(Gr))}}(this)},eo.prototype.run=function(){if(this.active){var e=this.get();if(e!==this.value||We(e)||this.deep){var t=this.value;if(this.value=e,this.user)try{this.cb.call(this.vm,e,t)}catch(e){$n(e,this.vm,'callback for watcher "'+this.expression+'"')}else this.cb.call(this.vm,e,t)}}},eo.prototype.evaluate=function(){this.value=this.get(),this.dirty=!1},eo.prototype.depend=function(){for(var e=this.deps.length;e--;)this.deps[e].depend()},eo.prototype.teardown=function(){if(this.active){this.vm._isBeingDestroyed||et(this.vm._watchers,this);for(var e=this.deps.length;e--;)this.deps[e].removeSub(this);this.active=!1}};var to={enumerable:!0,configurable:!0,get:ft,set:ft};function no(e,t,n){to.get=function(){return this[t][n]},to.set=function(e){this[t][n]=e},Object.defineProperty(e,n,to)}var ro={lazy:!0};function oo(e,t,n){var r=!Mt();"function"==typeof n?(to.get=r?io(t):ao(n),to.set=ft):(to.get=n.get?r&&!1!==n.cache?io(t):ao(n.get):ft,to.set=n.set||ft),Object.defineProperty(e,t,to)}function io(e){return function(){var t=this._computedWatchers&&this._computedWatchers[e];if(t)return t.dirty&&t.evaluate(),Kt.target&&t.depend(),t.value}}function ao(e){return function(){return e.call(this,this)}}function so(e,t,n,r){return Ye(n)&&(r=n,n=n.handler),"string"==typeof n&&(n=e[n]),e.$watch(t,n,r)}var co=0;function uo(e){var t=e.options;if(e.super){var n=uo(e.super);if(n!==e.superOptions){e.superOptions=n;var r=function(e){var t,n=e.options,r=e.sealedOptions;for(var o in n)n[o]!==r[o]&&(t||(t={}),t[o]=n[o]);return t}(e);r&&dt(e.extendOptions,r),(t=e.options=wn(n,e.extendOptions)).name&&(t.components[t.name]=e)}}return t}function lo(e){this._init(e)}function po(e){return e&&(e.Ctor.options.name||e.tag)}function fo(e,t){return Array.isArray(e)?e.indexOf(t)>-1:"string"==typeof e?e.split(",").indexOf(t)>-1:(n=e,!("[object RegExp]"!==He.call(n))&&e.test(t));var n}function ho(e,t){var n=e.cache,r=e.keys,o=e._vnode;for(var i in n){var a=n[i];if(a){var s=po(a.componentOptions);s&&!t(s)&&vo(n,i,r,o)}}}function vo(e,t,n,r){var o=e[t];!o||r&&o.tag===r.tag||o.componentInstance.$destroy(),e[t]=null,et(n,t)}!function(e){e.prototype._init=function(e){var t=this;t._uid=co++,t._isVue=!0,e&&e._isComponent?function(e,t){var n=e.$options=Object.create(e.constructor.options),r=t._parentVnode;n.parent=t.parent,n._parentVnode=r;var o=r.componentOptions;n.propsData=o.propsData,n._parentListeners=o.listeners,n._renderChildren=o.children,n._componentTag=o.tag,t.render&&(n.render=t.render,n.staticRenderFns=t.staticRenderFns)}(t,e):t.$options=wn(uo(t.constructor),e||{},t),t._renderProxy=t,t._self=t,function(e){var t=e.$options,n=t.parent;if(n&&!t.abstract){for(;n.$options.abstract&&n.$parent;)n=n.$parent;n.$children.push(e)}e.$parent=n,e.$root=n?n.$root:e,e.$children=[],e.$refs={},e._watcher=null,e._inactive=null,e._directInactive=!1,e._isMounted=!1,e._isDestroyed=!1,e._isBeingDestroyed=!1}(t),function(e){e._events=Object.create(null),e._hasHookEvent=!1;var t=e.$options._parentListeners;t&&jr(e,t)}(t),function(e){e._vnode=null,e._staticTrees=null;var t=e.$options,n=e.$vnode=t._parentVnode,r=n&&n.context;e.$slots=Qn(t._renderChildren,r),e.$scopedSlots=Fe,e._c=function(t,n,r,o){return _r(e,t,n,r,o,!1)},e.$createElement=function(t,n,r,o){return _r(e,t,n,r,o,!0)};var o=n&&n.data;dn(e,"$attrs",o&&o.attrs||Fe,null,!0),dn(e,"$listeners",t._parentListeners||Fe,null,!0)}(t),Ur(t,"beforeCreate"),function(e){var t=Gn(e.$options.inject,e);t&&(cn(!1),Object.keys(t).forEach((function(n){dn(e,n,t[n])})),cn(!0))}(t),function(e){e._watchers=[];var t=e.$options;t.props&&function(e,t){var n=e.$options.propsData||{},r=e._props={},o=e.$options._propKeys=[];e.$parent&&cn(!1);var i=function(i){o.push(i);var a=xn(i,t,n,e);dn(r,i,a),i in e||no(e,"_props",i)};for(var a in t)i(a);cn(!0)}(e,t.props),t.methods&&function(e,t){for(var n in e.$options.props,t)e[n]="function"!=typeof t[n]?ft:ut(t[n],e)}(e,t.methods),t.data?function(e){var t=e.$options.data;Ye(t=e._data="function"==typeof t?function(e,t){Zt();try{return e.call(t,t)}catch(e){return $n(e,t,"data()"),{}}finally{Xt()}}(t,e):t||{})||(t={});for(var n=Object.keys(t),r=e.$options.props,o=(e.$options.methods,n.length);o--;){var i=n[o];r&&nt(r,i)||kt(i)||no(e,"_data",i)}ln(t,!0)}(e):ln(e._data={},!0),t.computed&&function(e,t){var n=e._computedWatchers=Object.create(null),r=Mt();for(var o in t){var i=t[o],a="function"==typeof i?i:i.get;r||(n[o]=new eo(e,a||ft,ft,ro)),o in e||oo(e,o,i)}}(e,t.computed),t.watch&&t.watch!==Pt&&function(e,t){for(var n in t){var r=t[n];if(Array.isArray(r))for(var o=0;o<r.length;o++)so(e,n,r[o]);else so(e,n,r)}}(e,t.watch)}(t),function(e){var t=e.$options.provide;t&&(e._provided="function"==typeof t?t.call(e):t)}(t),Ur(t,"created"),t.$options.el&&t.$mount(t.$options.el)}}(lo),function(e){Object.defineProperty(e.prototype,"$data",{get:function(){return this._data}}),Object.defineProperty(e.prototype,"$props",{get:function(){return this._props}}),e.prototype.$set=pn,e.prototype.$delete=fn,e.prototype.$watch=function(e,t,n){var r=this;if(Ye(t))return so(r,e,t,n);(n=n||{}).user=!0;var o=new eo(r,e,t,n);if(n.immediate)try{t.call(r,o.value)}catch(e){$n(e,r,'callback for immediate watcher "'+o.expression+'"')}return function(){o.teardown()}}}(lo),function(e){var t=/^hook:/;e.prototype.$on=function(e,n){var r=this;if(Array.isArray(e))for(var o=0,i=e.length;o<i;o++)r.$on(e[o],n);else(r._events[e]||(r._events[e]=[])).push(n),t.test(e)&&(r._hasHookEvent=!0);return r},e.prototype.$once=function(e,t){var n=this;function r(){n.$off(e,r),t.apply(n,arguments)}return r.fn=t,n.$on(e,r),n},e.prototype.$off=function(e,t){var n=this;if(!arguments.length)return n._events=Object.create(null),n;if(Array.isArray(e)){for(var r=0,o=e.length;r<o;r++)n.$off(e[r],t);return n}var i,a=n._events[e];if(!a)return n;if(!t)return n._events[e]=null,n;for(var s=a.length;s--;)if((i=a[s])===t||i.fn===t){a.splice(s,1);break}return n},e.prototype.$emit=function(e){var t=this,n=t._events[e];if(n){n=n.length>1?lt(n):n;for(var r=lt(arguments,1),o='event handler for "'+e+'"',i=0,a=n.length;i<a;i++)Sn(n[i],t,r,t,o)}return t}}(lo),function(e){e.prototype._update=function(e,t){var n=this,r=n.$el,o=n._vnode,i=Pr(n);n._vnode=e,n.$el=o?n.__patch__(o,e):n.__patch__(n.$el,e,t,!1),i(),r&&(r.__vue__=null),n.$el&&(n.$el.__vue__=n),n.$vnode&&n.$parent&&n.$vnode===n.$parent._vnode&&(n.$parent.$el=n.$el)},e.prototype.$forceUpdate=function(){this._watcher&&this._watcher.update()},e.prototype.$destroy=function(){var e=this;if(!e._isBeingDestroyed){Ur(e,"beforeDestroy"),e._isBeingDestroyed=!0;var t=e.$parent;!t||t._isBeingDestroyed||e.$options.abstract||et(t.$children,e),e._watcher&&e._watcher.teardown();for(var n=e._watchers.length;n--;)e._watchers[n].teardown();e._data.__ob__&&e._data.__ob__.vmCount--,e._isDestroyed=!0,e.__patch__(e._vnode,null),Ur(e,"destroyed"),e.$off(),e.$el&&(e.$el.__vue__=null),e.$vnode&&(e.$vnode.parent=null)}}}(lo),function(e){yr(e.prototype),e.prototype.$nextTick=function(e){return zn(e,this)},e.prototype._render=function(){var e,t=this,n=t.$options,r=n.render,o=n._parentVnode;o&&(t.$scopedSlots=tr(o.data.scopedSlots,t.$slots,t.$scopedSlots)),t.$vnode=o;try{Er=t,e=r.call(t._renderProxy,t.$createElement)}catch(n){$n(n,t,"render"),e=t._vnode}finally{Er=null}return Array.isArray(e)&&1===e.length&&(e=e[0]),e instanceof Gt||(e=en()),e.parent=o,e}}(lo);var mo=[String,RegExp,Array],go={KeepAlive:{name:"keep-alive",abstract:!0,props:{include:mo,exclude:mo,max:[String,Number]},created:function(){this.cache=Object.create(null),this.keys=[]},destroyed:function(){for(var e in this.cache)vo(this.cache,e,this.keys)},mounted:function(){var e=this;this.$watch("include",(function(t){ho(e,(function(e){return fo(t,e)}))})),this.$watch("exclude",(function(t){ho(e,(function(e){return!fo(t,e)}))}))},render:function(){var e=this.$slots.default,t=Nr(e),n=t&&t.componentOptions;if(n){var r=po(n),o=this.include,i=this.exclude;if(o&&(!r||!fo(o,r))||i&&r&&fo(i,r))return t;var a=this.cache,s=this.keys,c=null==t.key?n.Ctor.cid+(n.tag?"::"+n.tag:""):t.key;a[c]?(t.componentInstance=a[c].componentInstance,et(s,c),s.push(c)):(a[c]=t,s.push(c),this.max&&s.length>parseInt(this.max)&&vo(a,s[0],s,this._vnode)),t.data.keepAlive=!0}return t||e&&e[0]}}};!function(e){var t={get:function(){return Ct}};Object.defineProperty(e,"config",t),e.util={warn:Yt,extend:dt,mergeOptions:wn,defineReactive:dn},e.set=pn,e.delete=fn,e.nextTick=zn,e.observable=function(e){return ln(e),e},e.options=Object.create(null),At.forEach((function(t){e.options[t+"s"]=Object.create(null)})),e.options._base=e,dt(e.options.components,go),function(e){e.use=function(e){var t=this._installedPlugins||(this._installedPlugins=[]);if(t.indexOf(e)>-1)return this;var n=lt(arguments,1);return n.unshift(this),"function"==typeof e.install?e.install.apply(e,n):"function"==typeof e&&e.apply(null,n),t.push(e),this}}(e),function(e){e.mixin=function(e){return this.options=wn(this.options,e),this}}(e),function(e){e.cid=0;var t=1;e.extend=function(e){e=e||{};var n=this,r=n.cid,o=e._Ctor||(e._Ctor={});if(o[r])return o[r];var i=e.name||n.options.name,a=function(e){this._init(e)};return(a.prototype=Object.create(n.prototype)).constructor=a,a.cid=t++,a.options=wn(n.options,e),a.super=n,a.options.props&&function(e){var t=e.options.props;for(var n in t)no(e.prototype,"_props",n)}(a),a.options.computed&&function(e){var t=e.options.computed;for(var n in t)oo(e.prototype,n,t[n])}(a),a.extend=n.extend,a.mixin=n.mixin,a.use=n.use,At.forEach((function(e){a[e]=n[e]})),i&&(a.options.components[i]=a),a.superOptions=n.options,a.extendOptions=e,a.sealedOptions=dt({},a.options),o[r]=a,a}}(e),function(e){At.forEach((function(t){e[t]=function(e,n){return n?("component"===t&&Ye(n)&&(n.name=n.name||e,n=this.options._base.extend(n)),"directive"===t&&"function"==typeof n&&(n={bind:n,update:n}),this.options[t+"s"][e]=n,n):this.options[t+"s"][e]}}))}(e)}(lo),Object.defineProperty(lo.prototype,"$isServer",{get:Mt}),Object.defineProperty(lo.prototype,"$ssrContext",{get:function(){return this.$vnode&&this.$vnode.ssrContext}}),Object.defineProperty(lo,"FunctionalRenderContext",{value:br}),lo.version="2.6.12";var yo=Xe("style,class"),bo=Xe("input,textarea,option,select,progress"),Ao=function(e,t,n){return"value"===n&&bo(e)&&"button"!==t||"selected"===n&&"option"===e||"checked"===n&&"input"===e||"muted"===n&&"video"===e},wo=Xe("contenteditable,draggable,spellcheck"),Co=Xe("events,caret,typing,plaintext-only"),xo=Xe("allowfullscreen,async,autofocus,autoplay,checked,compact,controls,declare,default,defaultchecked,defaultmuted,defaultselected,defer,disabled,enabled,formnovalidate,hidden,indeterminate,inert,ismap,itemscope,loop,multiple,muted,nohref,noresize,noshade,novalidate,nowrap,open,pauseonexit,readonly,required,reversed,scoped,seamless,selected,sortable,translate,truespeed,typemustmatch,visible"),ko="http://www.w3.org/1999/xlink",Bo=function(e){return":"===e.charAt(5)&&"xlink"===e.slice(0,5)},_o=function(e){return Bo(e)?e.slice(6,e.length):""},$o=function(e){return null==e||!1===e};function So(e,t){return{staticClass:Eo(e.staticClass,t.staticClass),class:Me(e.class)?[e.class,t.class]:t.class}}function Eo(e,t){return e?t?e+" "+t:e:t||""}function Io(e){return Array.isArray(e)?function(e){for(var t,n="",r=0,o=e.length;r<o;r++)Me(t=Io(e[r]))&&""!==t&&(n&&(n+=" "),n+=t);return n}(e):We(e)?function(e){var t="";for(var n in e)e[n]&&(t&&(t+=" "),t+=n);return t}(e):"string"==typeof e?e:""}var Oo={svg:"http://www.w3.org/2000/svg",math:"http://www.w3.org/1998/Math/MathML"},No=Xe("html,body,base,head,link,meta,style,title,address,article,aside,footer,header,h1,h2,h3,h4,h5,h6,hgroup,nav,section,div,dd,dl,dt,figcaption,figure,picture,hr,img,li,main,ol,p,pre,ul,a,b,abbr,bdi,bdo,br,cite,code,data,dfn,em,i,kbd,mark,q,rp,rt,rtc,ruby,s,samp,small,span,strong,sub,sup,time,u,var,wbr,area,audio,map,track,video,embed,object,param,source,canvas,script,noscript,del,ins,caption,col,colgroup,table,thead,tbody,td,th,tr,button,datalist,fieldset,form,input,label,legend,meter,optgroup,option,output,progress,select,textarea,details,dialog,menu,menuitem,summary,content,element,shadow,template,blockquote,iframe,tfoot"),To=Xe("svg,animate,circle,clippath,cursor,defs,desc,ellipse,filter,font-face,foreignObject,g,glyph,image,line,marker,mask,missing-glyph,path,pattern,polygon,polyline,rect,switch,symbol,text,textpath,tspan,use,view",!0),Lo=function(e){return No(e)||To(e)};function Do(e){return To(e)?"svg":"math"===e?"math":void 0}var jo=Object.create(null),Ro=Xe("text,number,password,search,email,tel,url");function Po(e){return"string"==typeof e?document.querySelector(e)||document.createElement("div"):e}var Fo=Object.freeze({createElement:function(e,t){var n=document.createElement(e);return"select"!==e||t.data&&t.data.attrs&&void 0!==t.data.attrs.multiple&&n.setAttribute("multiple","multiple"),n},createElementNS:function(e,t){return document.createElementNS(Oo[e],t)},createTextNode:function(e){return document.createTextNode(e)},createComment:function(e){return document.createComment(e)},insertBefore:function(e,t,n){e.insertBefore(t,n)},removeChild:function(e,t){e.removeChild(t)},appendChild:function(e,t){e.appendChild(t)},parentNode:function(e){return e.parentNode},nextSibling:function(e){return e.nextSibling},tagName:function(e){return e.tagName},setTextContent:function(e,t){e.textContent=t},setStyleScope:function(e,t){e.setAttribute(t,"")}}),zo={create:function(e,t){Mo(t)},update:function(e,t){e.data.ref!==t.data.ref&&(Mo(e,!0),Mo(t))},destroy:function(e){Mo(e,!0)}};function Mo(e,t){var n=e.data.ref;if(Me(n)){var r=e.context,o=e.componentInstance||e.elm,i=r.$refs;t?Array.isArray(i[n])?et(i[n],o):i[n]===o&&(i[n]=void 0):e.data.refInFor?Array.isArray(i[n])?i[n].indexOf(o)<0&&i[n].push(o):i[n]=[o]:i[n]=o}}var Uo=new Gt("",{},[]),Vo=["create","activate","update","remove","destroy"];function Wo(e,t){return e.key===t.key&&(e.tag===t.tag&&e.isComment===t.isComment&&Me(e.data)===Me(t.data)&&function(e,t){if("input"!==e.tag)return!0;var n,r=Me(n=e.data)&&Me(n=n.attrs)&&n.type,o=Me(n=t.data)&&Me(n=n.attrs)&&n.type;return r===o||Ro(r)&&Ro(o)}(e,t)||Ue(e.isAsyncPlaceholder)&&e.asyncFactory===t.asyncFactory&&ze(t.asyncFactory.error))}function Ho(e,t,n){var r,o,i={};for(r=t;r<=n;++r)Me(o=e[r].key)&&(i[o]=r);return i}var Yo={create:qo,update:qo,destroy:function(e){qo(e,Uo)}};function qo(e,t){(e.data.directives||t.data.directives)&&function(e,t){var n,r,o,i=e===Uo,a=t===Uo,s=Jo(e.data.directives,e.context),c=Jo(t.data.directives,t.context),u=[],l=[];for(n in c)r=s[n],o=c[n],r?(o.oldValue=r.value,o.oldArg=r.arg,Xo(o,"update",t,e),o.def&&o.def.componentUpdated&&l.push(o)):(Xo(o,"bind",t,e),o.def&&o.def.inserted&&u.push(o));if(u.length){var d=function(){for(var n=0;n<u.length;n++)Xo(u[n],"inserted",t,e)};i?qn(t,"insert",d):d()}if(l.length&&qn(t,"postpatch",(function(){for(var n=0;n<l.length;n++)Xo(l[n],"componentUpdated",t,e)})),!i)for(n in s)c[n]||Xo(s[n],"unbind",e,e,a)}(e,t)}var Ko=Object.create(null);function Jo(e,t){var n,r,o=Object.create(null);if(!e)return o;for(n=0;n<e.length;n++)(r=e[n]).modifiers||(r.modifiers=Ko),o[Zo(r)]=r,r.def=Cn(t.$options,"directives",r.name);return o}function Zo(e){return e.rawName||e.name+"."+Object.keys(e.modifiers||{}).join(".")}function Xo(e,t,n,r,o){var i=e.def&&e.def[t];if(i)try{i(n.elm,e,n,r,o)}catch(r){$n(r,n.context,"directive "+e.name+" "+t+" hook")}}var Go=[zo,Yo];function Qo(e,t){var n=t.componentOptions;if(!(Me(n)&&!1===n.Ctor.options.inheritAttrs||ze(e.data.attrs)&&ze(t.data.attrs))){var r,o,i=t.elm,a=e.data.attrs||{},s=t.data.attrs||{};for(r in Me(s.__ob__)&&(s=t.data.attrs=dt({},s)),s)o=s[r],a[r]!==o&&ei(i,r,o);for(r in(Tt||Dt)&&s.value!==a.value&&ei(i,"value",s.value),a)ze(s[r])&&(Bo(r)?i.removeAttributeNS(ko,_o(r)):wo(r)||i.removeAttribute(r))}}function ei(e,t,n){e.tagName.indexOf("-")>-1?ti(e,t,n):xo(t)?$o(n)?e.removeAttribute(t):(n="allowfullscreen"===t&&"EMBED"===e.tagName?"true":t,e.setAttribute(t,n)):wo(t)?e.setAttribute(t,function(e,t){return $o(t)||"false"===t?"false":"contenteditable"===e&&Co(t)?t:"true"}(t,n)):Bo(t)?$o(n)?e.removeAttributeNS(ko,_o(t)):e.setAttributeNS(ko,t,n):ti(e,t,n)}function ti(e,t,n){if($o(n))e.removeAttribute(t);else{if(Tt&&!Lt&&"TEXTAREA"===e.tagName&&"placeholder"===t&&""!==n&&!e.__ieph){var r=function(t){t.stopImmediatePropagation(),e.removeEventListener("input",r)};e.addEventListener("input",r),e.__ieph=!0}e.setAttribute(t,n)}}var ni={create:Qo,update:Qo};function ri(e,t){var n=t.elm,r=t.data,o=e.data;if(!(ze(r.staticClass)&&ze(r.class)&&(ze(o)||ze(o.staticClass)&&ze(o.class)))){var i=function(e){for(var t=e.data,n=e,r=e;Me(r.componentInstance);)(r=r.componentInstance._vnode)&&r.data&&(t=So(r.data,t));for(;Me(n=n.parent);)n&&n.data&&(t=So(t,n.data));return o=t.staticClass,i=t.class,Me(o)||Me(i)?Eo(o,Io(i)):"";var o,i}(t),a=n._transitionClasses;Me(a)&&(i=Eo(i,Io(a))),i!==n._prevClass&&(n.setAttribute("class",i),n._prevClass=i)}}var oi,ii,ai,si,ci,ui,li={create:ri,update:ri},di=/[\w).+\-_$\]]/;function pi(e){var t,n,r,o,i,a=!1,s=!1,c=!1,u=!1,l=0,d=0,p=0,f=0;for(r=0;r<e.length;r++)if(n=t,t=e.charCodeAt(r),a)39===t&&92!==n&&(a=!1);else if(s)34===t&&92!==n&&(s=!1);else if(c)96===t&&92!==n&&(c=!1);else if(u)47===t&&92!==n&&(u=!1);else if(124!==t||124===e.charCodeAt(r+1)||124===e.charCodeAt(r-1)||l||d||p){switch(t){case 34:s=!0;break;case 39:a=!0;break;case 96:c=!0;break;case 40:p++;break;case 41:p--;break;case 91:d++;break;case 93:d--;break;case 123:l++;break;case 125:l--}if(47===t){for(var h=r-1,v=void 0;h>=0&&" "===(v=e.charAt(h));h--);v&&di.test(v)||(u=!0)}}else void 0===o?(f=r+1,o=e.slice(0,r).trim()):m();function m(){(i||(i=[])).push(e.slice(f,r).trim()),f=r+1}if(void 0===o?o=e.slice(0,r).trim():0!==f&&m(),i)for(r=0;r<i.length;r++)o=fi(o,i[r]);return o}function fi(e,t){var n=t.indexOf("(");if(n<0)return'_f("'+t+'")('+e+")";var r=t.slice(0,n),o=t.slice(n+1);return'_f("'+r+'")('+e+(")"!==o?","+o:o)}function hi(e,t){console.error("[Vue compiler]: "+e)}function vi(e,t){return e?e.map((function(e){return e[t]})).filter((function(e){return e})):[]}function mi(e,t,n,r,o){(e.props||(e.props=[])).push(Bi({name:t,value:n,dynamic:o},r)),e.plain=!1}function gi(e,t,n,r,o){(o?e.dynamicAttrs||(e.dynamicAttrs=[]):e.attrs||(e.attrs=[])).push(Bi({name:t,value:n,dynamic:o},r)),e.plain=!1}function yi(e,t,n,r){e.attrsMap[t]=n,e.attrsList.push(Bi({name:t,value:n},r))}function bi(e,t,n,r,o,i,a,s){(e.directives||(e.directives=[])).push(Bi({name:t,rawName:n,value:r,arg:o,isDynamicArg:i,modifiers:a},s)),e.plain=!1}function Ai(e,t,n){return n?"_p("+t+',"'+e+'")':e+t}function wi(e,t,n,r,o,i,a,s){var c;(r=r||Fe).right?s?t="("+t+")==='click'?'contextmenu':("+t+")":"click"===t&&(t="contextmenu",delete r.right):r.middle&&(s?t="("+t+")==='click'?'mouseup':("+t+")":"click"===t&&(t="mouseup")),r.capture&&(delete r.capture,t=Ai("!",t,s)),r.once&&(delete r.once,t=Ai("~",t,s)),r.passive&&(delete r.passive,t=Ai("&",t,s)),r.native?(delete r.native,c=e.nativeEvents||(e.nativeEvents={})):c=e.events||(e.events={});var u=Bi({value:n.trim(),dynamic:s},a);r!==Fe&&(u.modifiers=r);var l=c[t];Array.isArray(l)?o?l.unshift(u):l.push(u):c[t]=l?o?[u,l]:[l,u]:u,e.plain=!1}function Ci(e,t,n){var r=xi(e,":"+t)||xi(e,"v-bind:"+t);if(null!=r)return pi(r);if(!1!==n){var o=xi(e,t);if(null!=o)return JSON.stringify(o)}}function xi(e,t,n){var r;if(null!=(r=e.attrsMap[t]))for(var o=e.attrsList,i=0,a=o.length;i<a;i++)if(o[i].name===t){o.splice(i,1);break}return n&&delete e.attrsMap[t],r}function ki(e,t){for(var n=e.attrsList,r=0,o=n.length;r<o;r++){var i=n[r];if(t.test(i.name))return n.splice(r,1),i}}function Bi(e,t){return t&&(null!=t.start&&(e.start=t.start),null!=t.end&&(e.end=t.end)),e}function _i(e,t,n){var r=n||{},o=r.number,i="$$v";r.trim&&(i="(typeof $$v === 'string'? $$v.trim(): $$v)"),o&&(i="_n("+i+")");var a=$i(t,i);e.model={value:"("+t+")",expression:JSON.stringify(t),callback:"function ($$v) {"+a+"}"}}function $i(e,t){var n=function(e){if(e=e.trim(),oi=e.length,e.indexOf("[")<0||e.lastIndexOf("]")<oi-1)return(si=e.lastIndexOf("."))>-1?{exp:e.slice(0,si),key:'"'+e.slice(si+1)+'"'}:{exp:e,key:null};for(ii=e,si=ci=ui=0;!Ei();)Ii(ai=Si())?Ni(ai):91===ai&&Oi(ai);return{exp:e.slice(0,ci),key:e.slice(ci+1,ui)}}(e);return null===n.key?e+"="+t:"$set("+n.exp+", "+n.key+", "+t+")"}function Si(){return ii.charCodeAt(++si)}function Ei(){return si>=oi}function Ii(e){return 34===e||39===e}function Oi(e){var t=1;for(ci=si;!Ei();)if(Ii(e=Si()))Ni(e);else if(91===e&&t++,93===e&&t--,0===t){ui=si;break}}function Ni(e){for(var t=e;!Ei()&&(e=Si())!==t;);}var Ti;function Li(e,t,n){var r=Ti;return function o(){var i=t.apply(null,arguments);null!==i&&Ri(e,o,n,r)}}var Di=Nn&&!(Rt&&Number(Rt[1])<=53);function ji(e,t,n,r){if(Di){var o=Jr,i=t;t=i._wrapper=function(e){if(e.target===e.currentTarget||e.timeStamp>=o||e.timeStamp<=0||e.target.ownerDocument!==document)return i.apply(this,arguments)}}Ti.addEventListener(e,t,Ft?{capture:n,passive:r}:n)}function Ri(e,t,n,r){(r||Ti).removeEventListener(e,t._wrapper||t,n)}function Pi(e,t){if(!ze(e.data.on)||!ze(t.data.on)){var n=t.data.on||{},r=e.data.on||{};Ti=t.elm,function(e){if(Me(e.__r)){var t=Tt?"change":"input";e[t]=[].concat(e.__r,e[t]||[]),delete e.__r}Me(e.__c)&&(e.change=[].concat(e.__c,e.change||[]),delete e.__c)}(n),Yn(n,r,ji,Ri,Li,t.context),Ti=void 0}}var Fi,zi={create:Pi,update:Pi};function Mi(e,t){if(!ze(e.data.domProps)||!ze(t.data.domProps)){var n,r,o=t.elm,i=e.data.domProps||{},a=t.data.domProps||{};for(n in Me(a.__ob__)&&(a=t.data.domProps=dt({},a)),i)n in a||(o[n]="");for(n in a){if(r=a[n],"textContent"===n||"innerHTML"===n){if(t.children&&(t.children.length=0),r===i[n])continue;1===o.childNodes.length&&o.removeChild(o.childNodes[0])}if("value"===n&&"PROGRESS"!==o.tagName){o._value=r;var s=ze(r)?"":String(r);Ui(o,s)&&(o.value=s)}else if("innerHTML"===n&&To(o.tagName)&&ze(o.innerHTML)){(Fi=Fi||document.createElement("div")).innerHTML="<svg>"+r+"</svg>";for(var c=Fi.firstChild;o.firstChild;)o.removeChild(o.firstChild);for(;c.firstChild;)o.appendChild(c.firstChild)}else if(r!==i[n])try{o[n]=r}catch(e){}}}}function Ui(e,t){return!e.composing&&("OPTION"===e.tagName||function(e,t){var n=!0;try{n=document.activeElement!==e}catch(e){}return n&&e.value!==t}(e,t)||function(e,t){var n=e.value,r=e._vModifiers;if(Me(r)){if(r.number)return Ze(n)!==Ze(t);if(r.trim)return n.trim()!==t.trim()}return n!==t}(e,t))}var Vi={create:Mi,update:Mi},Wi=rt((function(e){var t={},n=/:(.+)/;return e.split(/;(?![^(]*\))/g).forEach((function(e){if(e){var r=e.split(n);r.length>1&&(t[r[0].trim()]=r[1].trim())}})),t}));function Hi(e){var t=Yi(e.style);return e.staticStyle?dt(e.staticStyle,t):t}function Yi(e){return Array.isArray(e)?pt(e):"string"==typeof e?Wi(e):e}var qi,Ki=/^--/,Ji=/\s*!important$/,Zi=function(e,t,n){if(Ki.test(t))e.style.setProperty(t,n);else if(Ji.test(n))e.style.setProperty(ct(t),n.replace(Ji,""),"important");else{var r=Gi(t);if(Array.isArray(n))for(var o=0,i=n.length;o<i;o++)e.style[r]=n[o];else e.style[r]=n}},Xi=["Webkit","Moz","ms"],Gi=rt((function(e){if(qi=qi||document.createElement("div").style,"filter"!==(e=it(e))&&e in qi)return e;for(var t=e.charAt(0).toUpperCase()+e.slice(1),n=0;n<Xi.length;n++){var r=Xi[n]+t;if(r in qi)return r}}));function Qi(e,t){var n=t.data,r=e.data;if(!(ze(n.staticStyle)&&ze(n.style)&&ze(r.staticStyle)&&ze(r.style))){var o,i,a=t.elm,s=r.staticStyle,c=r.normalizedStyle||r.style||{},u=s||c,l=Yi(t.data.style)||{};t.data.normalizedStyle=Me(l.__ob__)?dt({},l):l;var d=function(e,t){for(var n,r={},o=e;o.componentInstance;)(o=o.componentInstance._vnode)&&o.data&&(n=Hi(o.data))&&dt(r,n);(n=Hi(e.data))&&dt(r,n);for(var i=e;i=i.parent;)i.data&&(n=Hi(i.data))&&dt(r,n);return r}(t);for(i in u)ze(d[i])&&Zi(a,i,"");for(i in d)(o=d[i])!==u[i]&&Zi(a,i,null==o?"":o)}}var ea={create:Qi,update:Qi},ta=/\s+/;function na(e,t){if(t&&(t=t.trim()))if(e.classList)t.indexOf(" ")>-1?t.split(ta).forEach((function(t){return e.classList.add(t)})):e.classList.add(t);else{var n=" "+(e.getAttribute("class")||"")+" ";n.indexOf(" "+t+" ")<0&&e.setAttribute("class",(n+t).trim())}}function ra(e,t){if(t&&(t=t.trim()))if(e.classList)t.indexOf(" ")>-1?t.split(ta).forEach((function(t){return e.classList.remove(t)})):e.classList.remove(t),e.classList.length||e.removeAttribute("class");else{for(var n=" "+(e.getAttribute("class")||"")+" ",r=" "+t+" ";n.indexOf(r)>=0;)n=n.replace(r," ");(n=n.trim())?e.setAttribute("class",n):e.removeAttribute("class")}}function oa(e){if(e){if("object"==typeof e){var t={};return!1!==e.css&&dt(t,ia(e.name||"v")),dt(t,e),t}return"string"==typeof e?ia(e):void 0}}var ia=rt((function(e){return{enterClass:e+"-enter",enterToClass:e+"-enter-to",enterActiveClass:e+"-enter-active",leaveClass:e+"-leave",leaveToClass:e+"-leave-to",leaveActiveClass:e+"-leave-active"}})),aa=Et&&!Lt,sa="transition",ca="animation",ua="transition",la="transitionend",da="animation",pa="animationend";aa&&(void 0===window.ontransitionend&&void 0!==window.onwebkittransitionend&&(ua="WebkitTransition",la="webkitTransitionEnd"),void 0===window.onanimationend&&void 0!==window.onwebkitanimationend&&(da="WebkitAnimation",pa="webkitAnimationEnd"));var fa=Et?window.requestAnimationFrame?window.requestAnimationFrame.bind(window):setTimeout:function(e){return e()};function ha(e){fa((function(){fa(e)}))}function va(e,t){var n=e._transitionClasses||(e._transitionClasses=[]);n.indexOf(t)<0&&(n.push(t),na(e,t))}function ma(e,t){e._transitionClasses&&et(e._transitionClasses,t),ra(e,t)}function ga(e,t,n){var r=ba(e,t),o=r.type,i=r.timeout,a=r.propCount;if(!o)return n();var s=o===sa?la:pa,c=0,u=function(){e.removeEventListener(s,l),n()},l=function(t){t.target===e&&++c>=a&&u()};setTimeout((function(){c<a&&u()}),i+1),e.addEventListener(s,l)}var ya=/\b(transform|all)(,|$)/;function ba(e,t){var n,r=window.getComputedStyle(e),o=(r[ua+"Delay"]||"").split(", "),i=(r[ua+"Duration"]||"").split(", "),a=Aa(o,i),s=(r[da+"Delay"]||"").split(", "),c=(r[da+"Duration"]||"").split(", "),u=Aa(s,c),l=0,d=0;return t===sa?a>0&&(n=sa,l=a,d=i.length):t===ca?u>0&&(n=ca,l=u,d=c.length):d=(n=(l=Math.max(a,u))>0?a>u?sa:ca:null)?n===sa?i.length:c.length:0,{type:n,timeout:l,propCount:d,hasTransform:n===sa&&ya.test(r[ua+"Property"])}}function Aa(e,t){for(;e.length<t.length;)e=e.concat(e);return Math.max.apply(null,t.map((function(t,n){return wa(t)+wa(e[n])})))}function wa(e){return 1e3*Number(e.slice(0,-1).replace(",","."))}function Ca(e,t){var n=e.elm;Me(n._leaveCb)&&(n._leaveCb.cancelled=!0,n._leaveCb());var r=oa(e.data.transition);if(!ze(r)&&!Me(n._enterCb)&&1===n.nodeType){for(var o=r.css,i=r.type,a=r.enterClass,s=r.enterToClass,c=r.enterActiveClass,u=r.appearClass,l=r.appearToClass,d=r.appearActiveClass,p=r.beforeEnter,f=r.enter,h=r.afterEnter,v=r.enterCancelled,m=r.beforeAppear,g=r.appear,y=r.afterAppear,b=r.appearCancelled,A=r.duration,w=Rr,C=Rr.$vnode;C&&C.parent;)w=C.context,C=C.parent;var x=!w._isMounted||!e.isRootInsert;if(!x||g||""===g){var k=x&&u?u:a,B=x&&d?d:c,_=x&&l?l:s,$=x&&m||p,S=x&&"function"==typeof g?g:f,E=x&&y||h,I=x&&b||v,O=Ze(We(A)?A.enter:A),N=!1!==o&&!Lt,T=Ba(S),L=n._enterCb=yt((function(){N&&(ma(n,_),ma(n,B)),L.cancelled?(N&&ma(n,k),I&&I(n)):E&&E(n),n._enterCb=null}));e.data.show||qn(e,"insert",(function(){var t=n.parentNode,r=t&&t._pending&&t._pending[e.key];r&&r.tag===e.tag&&r.elm._leaveCb&&r.elm._leaveCb(),S&&S(n,L)})),$&&$(n),N&&(va(n,k),va(n,B),ha((function(){ma(n,k),L.cancelled||(va(n,_),T||(ka(O)?setTimeout(L,O):ga(n,i,L)))}))),e.data.show&&(t&&t(),S&&S(n,L)),N||T||L()}}}function xa(e,t){var n=e.elm;Me(n._enterCb)&&(n._enterCb.cancelled=!0,n._enterCb());var r=oa(e.data.transition);if(ze(r)||1!==n.nodeType)return t();if(!Me(n._leaveCb)){var o=r.css,i=r.type,a=r.leaveClass,s=r.leaveToClass,c=r.leaveActiveClass,u=r.beforeLeave,l=r.leave,d=r.afterLeave,p=r.leaveCancelled,f=r.delayLeave,h=r.duration,v=!1!==o&&!Lt,m=Ba(l),g=Ze(We(h)?h.leave:h),y=n._leaveCb=yt((function(){n.parentNode&&n.parentNode._pending&&(n.parentNode._pending[e.key]=null),v&&(ma(n,s),ma(n,c)),y.cancelled?(v&&ma(n,a),p&&p(n)):(t(),d&&d(n)),n._leaveCb=null}));f?f(b):b()}function b(){y.cancelled||(!e.data.show&&n.parentNode&&((n.parentNode._pending||(n.parentNode._pending={}))[e.key]=e),u&&u(n),v&&(va(n,a),va(n,c),ha((function(){ma(n,a),y.cancelled||(va(n,s),m||(ka(g)?setTimeout(y,g):ga(n,i,y)))}))),l&&l(n,y),v||m||y())}}function ka(e){return"number"==typeof e&&!isNaN(e)}function Ba(e){if(ze(e))return!1;var t=e.fns;return Me(t)?Ba(Array.isArray(t)?t[0]:t):(e._length||e.length)>1}function _a(e,t){!0!==t.data.show&&Ca(t)}var $a=function(e){var t,n,r={},o=e.modules,i=e.nodeOps;for(t=0;t<Vo.length;++t)for(r[Vo[t]]=[],n=0;n<o.length;++n)Me(o[n][Vo[t]])&&r[Vo[t]].push(o[n][Vo[t]]);function a(e){var t=i.parentNode(e);Me(t)&&i.removeChild(t,e)}function s(e,t,n,o,a,s,d){if(Me(e.elm)&&Me(s)&&(e=s[d]=nn(e)),e.isRootInsert=!a,!function(e,t,n,o){var i=e.data;if(Me(i)){var a=Me(e.componentInstance)&&i.keepAlive;if(Me(i=i.hook)&&Me(i=i.init)&&i(e,!1),Me(e.componentInstance))return c(e,t),u(n,e.elm,o),Ue(a)&&function(e,t,n,o){for(var i,a=e;a.componentInstance;)if(Me(i=(a=a.componentInstance._vnode).data)&&Me(i=i.transition)){for(i=0;i<r.activate.length;++i)r.activate[i](Uo,a);t.push(a);break}u(n,e.elm,o)}(e,t,n,o),!0}}(e,t,n,o)){var h=e.data,v=e.children,m=e.tag;Me(m)?(e.elm=e.ns?i.createElementNS(e.ns,m):i.createElement(m,e),f(e),l(e,v,t),Me(h)&&p(e,t),u(n,e.elm,o)):Ue(e.isComment)?(e.elm=i.createComment(e.text),u(n,e.elm,o)):(e.elm=i.createTextNode(e.text),u(n,e.elm,o))}}function c(e,t){Me(e.data.pendingInsert)&&(t.push.apply(t,e.data.pendingInsert),e.data.pendingInsert=null),e.elm=e.componentInstance.$el,d(e)?(p(e,t),f(e)):(Mo(e),t.push(e))}function u(e,t,n){Me(e)&&(Me(n)?i.parentNode(n)===e&&i.insertBefore(e,t,n):i.appendChild(e,t))}function l(e,t,n){if(Array.isArray(t))for(var r=0;r<t.length;++r)s(t[r],n,e.elm,null,!0,t,r);else Ve(e.text)&&i.appendChild(e.elm,i.createTextNode(String(e.text)))}function d(e){for(;e.componentInstance;)e=e.componentInstance._vnode;return Me(e.tag)}function p(e,n){for(var o=0;o<r.create.length;++o)r.create[o](Uo,e);Me(t=e.data.hook)&&(Me(t.create)&&t.create(Uo,e),Me(t.insert)&&n.push(e))}function f(e){var t;if(Me(t=e.fnScopeId))i.setStyleScope(e.elm,t);else for(var n=e;n;)Me(t=n.context)&&Me(t=t.$options._scopeId)&&i.setStyleScope(e.elm,t),n=n.parent;Me(t=Rr)&&t!==e.context&&t!==e.fnContext&&Me(t=t.$options._scopeId)&&i.setStyleScope(e.elm,t)}function h(e,t,n,r,o,i){for(;r<=o;++r)s(n[r],i,e,t,!1,n,r)}function v(e){var t,n,o=e.data;if(Me(o))for(Me(t=o.hook)&&Me(t=t.destroy)&&t(e),t=0;t<r.destroy.length;++t)r.destroy[t](e);if(Me(t=e.children))for(n=0;n<e.children.length;++n)v(e.children[n])}function m(e,t,n){for(;t<=n;++t){var r=e[t];Me(r)&&(Me(r.tag)?(g(r),v(r)):a(r.elm))}}function g(e,t){if(Me(t)||Me(e.data)){var n,o=r.remove.length+1;for(Me(t)?t.listeners+=o:t=function(e,t){function n(){0==--n.listeners&&a(e)}return n.listeners=t,n}(e.elm,o),Me(n=e.componentInstance)&&Me(n=n._vnode)&&Me(n.data)&&g(n,t),n=0;n<r.remove.length;++n)r.remove[n](e,t);Me(n=e.data.hook)&&Me(n=n.remove)?n(e,t):t()}else a(e.elm)}function y(e,t,n,r){for(var o=n;o<r;o++){var i=t[o];if(Me(i)&&Wo(e,i))return o}}function b(e,t,n,o,a,c){if(e!==t){Me(t.elm)&&Me(o)&&(t=o[a]=nn(t));var u=t.elm=e.elm;if(Ue(e.isAsyncPlaceholder))Me(t.asyncFactory.resolved)?C(e.elm,t,n):t.isAsyncPlaceholder=!0;else if(Ue(t.isStatic)&&Ue(e.isStatic)&&t.key===e.key&&(Ue(t.isCloned)||Ue(t.isOnce)))t.componentInstance=e.componentInstance;else{var l,p=t.data;Me(p)&&Me(l=p.hook)&&Me(l=l.prepatch)&&l(e,t);var f=e.children,v=t.children;if(Me(p)&&d(t)){for(l=0;l<r.update.length;++l)r.update[l](e,t);Me(l=p.hook)&&Me(l=l.update)&&l(e,t)}ze(t.text)?Me(f)&&Me(v)?f!==v&&function(e,t,n,r,o){for(var a,c,u,l=0,d=0,p=t.length-1,f=t[0],v=t[p],g=n.length-1,A=n[0],w=n[g],C=!o;l<=p&&d<=g;)ze(f)?f=t[++l]:ze(v)?v=t[--p]:Wo(f,A)?(b(f,A,r,n,d),f=t[++l],A=n[++d]):Wo(v,w)?(b(v,w,r,n,g),v=t[--p],w=n[--g]):Wo(f,w)?(b(f,w,r,n,g),C&&i.insertBefore(e,f.elm,i.nextSibling(v.elm)),f=t[++l],w=n[--g]):Wo(v,A)?(b(v,A,r,n,d),C&&i.insertBefore(e,v.elm,f.elm),v=t[--p],A=n[++d]):(ze(a)&&(a=Ho(t,l,p)),ze(c=Me(A.key)?a[A.key]:y(A,t,l,p))?s(A,r,e,f.elm,!1,n,d):Wo(u=t[c],A)?(b(u,A,r,n,d),t[c]=void 0,C&&i.insertBefore(e,u.elm,f.elm)):s(A,r,e,f.elm,!1,n,d),A=n[++d]);l>p?h(e,ze(n[g+1])?null:n[g+1].elm,n,d,g,r):d>g&&m(t,l,p)}(u,f,v,n,c):Me(v)?(Me(e.text)&&i.setTextContent(u,""),h(u,null,v,0,v.length-1,n)):Me(f)?m(f,0,f.length-1):Me(e.text)&&i.setTextContent(u,""):e.text!==t.text&&i.setTextContent(u,t.text),Me(p)&&Me(l=p.hook)&&Me(l=l.postpatch)&&l(e,t)}}}function A(e,t,n){if(Ue(n)&&Me(e.parent))e.parent.data.pendingInsert=t;else for(var r=0;r<t.length;++r)t[r].data.hook.insert(t[r])}var w=Xe("attrs,class,staticClass,staticStyle,key");function C(e,t,n,r){var o,i=t.tag,a=t.data,s=t.children;if(r=r||a&&a.pre,t.elm=e,Ue(t.isComment)&&Me(t.asyncFactory))return t.isAsyncPlaceholder=!0,!0;if(Me(a)&&(Me(o=a.hook)&&Me(o=o.init)&&o(t,!0),Me(o=t.componentInstance)))return c(t,n),!0;if(Me(i)){if(Me(s))if(e.hasChildNodes())if(Me(o=a)&&Me(o=o.domProps)&&Me(o=o.innerHTML)){if(o!==e.innerHTML)return!1}else{for(var u=!0,d=e.firstChild,f=0;f<s.length;f++){if(!d||!C(d,s[f],n,r)){u=!1;break}d=d.nextSibling}if(!u||d)return!1}else l(t,s,n);if(Me(a)){var h=!1;for(var v in a)if(!w(v)){h=!0,p(t,n);break}!h&&a.class&&Un(a.class)}}else e.data!==t.text&&(e.data=t.text);return!0}return function(e,t,n,o){if(!ze(t)){var a,c=!1,u=[];if(ze(e))c=!0,s(t,u);else{var l=Me(e.nodeType);if(!l&&Wo(e,t))b(e,t,u,null,null,o);else{if(l){if(1===e.nodeType&&e.hasAttribute(bt)&&(e.removeAttribute(bt),n=!0),Ue(n)&&C(e,t,u))return A(t,u,!0),e;a=e,e=new Gt(i.tagName(a).toLowerCase(),{},[],void 0,a)}var p=e.elm,f=i.parentNode(p);if(s(t,u,p._leaveCb?null:f,i.nextSibling(p)),Me(t.parent))for(var h=t.parent,g=d(t);h;){for(var y=0;y<r.destroy.length;++y)r.destroy[y](h);if(h.elm=t.elm,g){for(var w=0;w<r.create.length;++w)r.create[w](Uo,h);var x=h.data.hook.insert;if(x.merged)for(var k=1;k<x.fns.length;k++)x.fns[k]()}else Mo(h);h=h.parent}Me(f)?m([e],0,0):Me(e.tag)&&v(e)}}return A(t,u,c),t.elm}Me(e)&&v(e)}}({nodeOps:Fo,modules:[ni,li,zi,Vi,ea,Et?{create:_a,activate:_a,remove:function(e,t){!0!==e.data.show?xa(e,t):t()}}:{}].concat(Go)});Lt&&document.addEventListener("selectionchange",(function(){var e=document.activeElement;e&&e.vmodel&&Da(e,"input")}));var Sa={inserted:function(e,t,n,r){"select"===n.tag?(r.elm&&!r.elm._vOptions?qn(n,"postpatch",(function(){Sa.componentUpdated(e,t,n)})):Ea(e,t,n.context),e._vOptions=[].map.call(e.options,Na)):("textarea"===n.tag||Ro(e.type))&&(e._vModifiers=t.modifiers,t.modifiers.lazy||(e.addEventListener("compositionstart",Ta),e.addEventListener("compositionend",La),e.addEventListener("change",La),Lt&&(e.vmodel=!0)))},componentUpdated:function(e,t,n){if("select"===n.tag){Ea(e,t,n.context);var r=e._vOptions,o=e._vOptions=[].map.call(e.options,Na);o.some((function(e,t){return!mt(e,r[t])}))&&(e.multiple?t.value.some((function(e){return Oa(e,o)})):t.value!==t.oldValue&&Oa(t.value,o))&&Da(e,"change")}}};function Ea(e,t,n){Ia(e,t),(Tt||Dt)&&setTimeout((function(){Ia(e,t)}),0)}function Ia(e,t,n){var r=t.value,o=e.multiple;if(!o||Array.isArray(r)){for(var i,a,s=0,c=e.options.length;s<c;s++)if(a=e.options[s],o)i=gt(r,Na(a))>-1,a.selected!==i&&(a.selected=i);else if(mt(Na(a),r))return void(e.selectedIndex!==s&&(e.selectedIndex=s));o||(e.selectedIndex=-1)}}function Oa(e,t){return t.every((function(t){return!mt(t,e)}))}function Na(e){return"_value"in e?e._value:e.value}function Ta(e){e.target.composing=!0}function La(e){e.target.composing&&(e.target.composing=!1,Da(e.target,"input"))}function Da(e,t){var n=document.createEvent("HTMLEvents");n.initEvent(t,!0,!0),e.dispatchEvent(n)}function ja(e){return!e.componentInstance||e.data&&e.data.transition?e:ja(e.componentInstance._vnode)}var Ra={model:Sa,show:{bind:function(e,t,n){var r=t.value,o=(n=ja(n)).data&&n.data.transition,i=e.__vOriginalDisplay="none"===e.style.display?"":e.style.display;r&&o?(n.data.show=!0,Ca(n,(function(){e.style.display=i}))):e.style.display=r?i:"none"},update:function(e,t,n){var r=t.value;!r!=!t.oldValue&&((n=ja(n)).data&&n.data.transition?(n.data.show=!0,r?Ca(n,(function(){e.style.display=e.__vOriginalDisplay})):xa(n,(function(){e.style.display="none"}))):e.style.display=r?e.__vOriginalDisplay:"none")},unbind:function(e,t,n,r,o){o||(e.style.display=e.__vOriginalDisplay)}}},Pa={name:String,appear:Boolean,css:Boolean,mode:String,type:String,enterClass:String,leaveClass:String,enterToClass:String,leaveToClass:String,enterActiveClass:String,leaveActiveClass:String,appearClass:String,appearActiveClass:String,appearToClass:String,duration:[Number,String,Object]};function Fa(e){var t=e&&e.componentOptions;return t&&t.Ctor.options.abstract?Fa(Nr(t.children)):e}function za(e){var t={},n=e.$options;for(var r in n.propsData)t[r]=e[r];var o=n._parentListeners;for(var i in o)t[it(i)]=o[i];return t}function Ma(e,t){if(/\d-keep-alive$/.test(t.tag))return e("keep-alive",{props:t.componentOptions.propsData})}var Ua=function(e){return e.tag||Or(e)},Va=function(e){return"show"===e.name},Wa={name:"transition",props:Pa,abstract:!0,render:function(e){var t=this,n=this.$slots.default;if(n&&(n=n.filter(Ua)).length){var r=this.mode,o=n[0];if(function(e){for(;e=e.parent;)if(e.data.transition)return!0}(this.$vnode))return o;var i=Fa(o);if(!i)return o;if(this._leaving)return Ma(e,o);var a="__transition-"+this._uid+"-";i.key=null==i.key?i.isComment?a+"comment":a+i.tag:Ve(i.key)?0===String(i.key).indexOf(a)?i.key:a+i.key:i.key;var s=(i.data||(i.data={})).transition=za(this),c=this._vnode,u=Fa(c);if(i.data.directives&&i.data.directives.some(Va)&&(i.data.show=!0),u&&u.data&&!function(e,t){return t.key===e.key&&t.tag===e.tag}(i,u)&&!Or(u)&&(!u.componentInstance||!u.componentInstance._vnode.isComment)){var l=u.data.transition=dt({},s);if("out-in"===r)return this._leaving=!0,qn(l,"afterLeave",(function(){t._leaving=!1,t.$forceUpdate()})),Ma(e,o);if("in-out"===r){if(Or(i))return c;var d,p=function(){d()};qn(s,"afterEnter",p),qn(s,"enterCancelled",p),qn(l,"delayLeave",(function(e){d=e}))}}return o}}},Ha=dt({tag:String,moveClass:String},Pa);function Ya(e){e.elm._moveCb&&e.elm._moveCb(),e.elm._enterCb&&e.elm._enterCb()}function qa(e){e.data.newPos=e.elm.getBoundingClientRect()}function Ka(e){var t=e.data.pos,n=e.data.newPos,r=t.left-n.left,o=t.top-n.top;if(r||o){e.data.moved=!0;var i=e.elm.style;i.transform=i.WebkitTransform="translate("+r+"px,"+o+"px)",i.transitionDuration="0s"}}delete Ha.mode;var Ja={Transition:Wa,TransitionGroup:{props:Ha,beforeMount:function(){var e=this,t=this._update;this._update=function(n,r){var o=Pr(e);e.__patch__(e._vnode,e.kept,!1,!0),e._vnode=e.kept,o(),t.call(e,n,r)}},render:function(e){for(var t=this.tag||this.$vnode.data.tag||"span",n=Object.create(null),r=this.prevChildren=this.children,o=this.$slots.default||[],i=this.children=[],a=za(this),s=0;s<o.length;s++){var c=o[s];c.tag&&null!=c.key&&0!==String(c.key).indexOf("__vlist")&&(i.push(c),n[c.key]=c,(c.data||(c.data={})).transition=a)}if(r){for(var u=[],l=[],d=0;d<r.length;d++){var p=r[d];p.data.transition=a,p.data.pos=p.elm.getBoundingClientRect(),n[p.key]?u.push(p):l.push(p)}this.kept=e(t,null,u),this.removed=l}return e(t,null,i)},updated:function(){var e=this.prevChildren,t=this.moveClass||(this.name||"v")+"-move";e.length&&this.hasMove(e[0].elm,t)&&(e.forEach(Ya),e.forEach(qa),e.forEach(Ka),this._reflow=document.body.offsetHeight,e.forEach((function(e){if(e.data.moved){var n=e.elm,r=n.style;va(n,t),r.transform=r.WebkitTransform=r.transitionDuration="",n.addEventListener(la,n._moveCb=function e(r){r&&r.target!==n||r&&!/transform$/.test(r.propertyName)||(n.removeEventListener(la,e),n._moveCb=null,ma(n,t))})}})))},methods:{hasMove:function(e,t){if(!aa)return!1;if(this._hasMove)return this._hasMove;var n=e.cloneNode();e._transitionClasses&&e._transitionClasses.forEach((function(e){ra(n,e)})),na(n,t),n.style.display="none",this.$el.appendChild(n);var r=ba(n);return this.$el.removeChild(n),this._hasMove=r.hasTransform}}}};lo.config.mustUseProp=Ao,lo.config.isReservedTag=Lo,lo.config.isReservedAttr=yo,lo.config.getTagNamespace=Do,lo.config.isUnknownElement=function(e){if(!Et)return!0;if(Lo(e))return!1;if(e=e.toLowerCase(),null!=jo[e])return jo[e];var t=document.createElement(e);return e.indexOf("-")>-1?jo[e]=t.constructor===window.HTMLUnknownElement||t.constructor===window.HTMLElement:jo[e]=/HTMLUnknownElement/.test(t.toString())},dt(lo.options.directives,Ra),dt(lo.options.components,Ja),lo.prototype.__patch__=Et?$a:ft,lo.prototype.$mount=function(e,t){return function(e,t,n){var r;return e.$el=t,e.$options.render||(e.$options.render=en),Ur(e,"beforeMount"),r=function(){e._update(e._render(),n)},new eo(e,r,ft,{before:function(){e._isMounted&&!e._isDestroyed&&Ur(e,"beforeUpdate")}},!0),n=!1,null==e.$vnode&&(e._isMounted=!0,Ur(e,"mounted")),e}(this,e=e&&Et?Po(e):void 0,t)},Et&&setTimeout((function(){Ct.devtools&&Ut&&Ut.emit("init",lo)}),0);var Za,Xa=/\{\{((?:.|\r?\n)+?)\}\}/g,Ga=/[-.*+?^${}()|[\]\/\\]/g,Qa=rt((function(e){var t=e[0].replace(Ga,"\\$&"),n=e[1].replace(Ga,"\\$&");return new RegExp(t+"((?:.|\\n)+?)"+n,"g")})),es={staticKeys:["staticClass"],transformNode:function(e,t){t.warn;var n=xi(e,"class");n&&(e.staticClass=JSON.stringify(n));var r=Ci(e,"class",!1);r&&(e.classBinding=r)},genData:function(e){var t="";return e.staticClass&&(t+="staticClass:"+e.staticClass+","),e.classBinding&&(t+="class:"+e.classBinding+","),t}},ts={staticKeys:["staticStyle"],transformNode:function(e,t){t.warn;var n=xi(e,"style");n&&(e.staticStyle=JSON.stringify(Wi(n)));var r=Ci(e,"style",!1);r&&(e.styleBinding=r)},genData:function(e){var t="";return e.staticStyle&&(t+="staticStyle:"+e.staticStyle+","),e.styleBinding&&(t+="style:("+e.styleBinding+"),"),t}},ns=Xe("area,base,br,col,embed,frame,hr,img,input,isindex,keygen,link,meta,param,source,track,wbr"),rs=Xe("colgroup,dd,dt,li,options,p,td,tfoot,th,thead,tr,source"),os=Xe("address,article,aside,base,blockquote,body,caption,col,colgroup,dd,details,dialog,div,dl,dt,fieldset,figcaption,figure,footer,form,h1,h2,h3,h4,h5,h6,head,header,hgroup,hr,html,legend,li,menuitem,meta,optgroup,option,param,rp,rt,source,style,summary,tbody,td,tfoot,th,thead,title,tr,track"),is=/^\s*([^\s"'<>\/=]+)(?:\s*(=)\s*(?:"([^"]*)"+|'([^']*)'+|([^\s"'=<>`]+)))?/,as=/^\s*((?:v-[\w-]+:|@|:|#)\[[^=]+\][^\s"'<>\/=]*)(?:\s*(=)\s*(?:"([^"]*)"+|'([^']*)'+|([^\s"'=<>`]+)))?/,ss="[a-zA-Z_][\\-\\.0-9_a-zA-Z"+xt.source+"]*",cs="((?:"+ss+"\\:)?"+ss+")",us=new RegExp("^<"+cs),ls=/^\s*(\/?)>/,ds=new RegExp("^<\\/"+cs+"[^>]*>"),ps=/^<!DOCTYPE [^>]+>/i,fs=/^<!\--/,hs=/^<!\[/,vs=Xe("script,style,textarea",!0),ms={},gs={"&lt;":"<","&gt;":">","&quot;":'"',"&amp;":"&","&#10;":"\n","&#9;":"\t","&#39;":"'"},ys=/&(?:lt|gt|quot|amp|#39);/g,bs=/&(?:lt|gt|quot|amp|#39|#10|#9);/g,As=Xe("pre,textarea",!0),ws=function(e,t){return e&&As(e)&&"\n"===t[0]};function Cs(e,t){var n=t?bs:ys;return e.replace(n,(function(e){return gs[e]}))}var xs,ks,Bs,_s,$s,Ss,Es,Is,Os=/^@|^v-on:/,Ns=/^v-|^@|^:|^#/,Ts=/([\s\S]*?)\s+(?:in|of)\s+([\s\S]*)/,Ls=/,([^,\}\]]*)(?:,([^,\}\]]*))?$/,Ds=/^\(|\)$/g,js=/^\[.*\]$/,Rs=/:(.*)$/,Ps=/^:|^\.|^v-bind:/,Fs=/\.[^.\]]+(?=[^\]]*$)/g,zs=/^v-slot(:|$)|^#/,Ms=/[\r\n]/,Us=/\s+/g,Vs=rt((function(e){return(Za=Za||document.createElement("div")).innerHTML=e,Za.textContent})),Ws="_empty_";function Hs(e,t,n){return{type:1,tag:e,attrsList:t,attrsMap:Xs(t),rawAttrsMap:{},parent:n,children:[]}}function Ys(e,t){var n;!function(e){var t=Ci(e,"key");t&&(e.key=t)}(e),e.plain=!e.key&&!e.scopedSlots&&!e.attrsList.length,function(e){var t=Ci(e,"ref");t&&(e.ref=t,e.refInFor=function(e){for(var t=e;t;){if(void 0!==t.for)return!0;t=t.parent}return!1}(e))}(e),function(e){var t;"template"===e.tag?(t=xi(e,"scope"),e.slotScope=t||xi(e,"slot-scope")):(t=xi(e,"slot-scope"))&&(e.slotScope=t);var n=Ci(e,"slot");if(n&&(e.slotTarget='""'===n?'"default"':n,e.slotTargetDynamic=!(!e.attrsMap[":slot"]&&!e.attrsMap["v-bind:slot"]),"template"===e.tag||e.slotScope||gi(e,"slot",n,function(e,t){return e.rawAttrsMap[":slot"]||e.rawAttrsMap["v-bind:slot"]||e.rawAttrsMap.slot}(e))),"template"===e.tag){var r=ki(e,zs);if(r){var o=Js(r),i=o.name,a=o.dynamic;e.slotTarget=i,e.slotTargetDynamic=a,e.slotScope=r.value||Ws}}else{var s=ki(e,zs);if(s){var c=e.scopedSlots||(e.scopedSlots={}),u=Js(s),l=u.name,d=u.dynamic,p=c[l]=Hs("template",[],e);p.slotTarget=l,p.slotTargetDynamic=d,p.children=e.children.filter((function(e){if(!e.slotScope)return e.parent=p,!0})),p.slotScope=s.value||Ws,e.children=[],e.plain=!1}}}(e),"slot"===(n=e).tag&&(n.slotName=Ci(n,"name")),function(e){var t;(t=Ci(e,"is"))&&(e.component=t),null!=xi(e,"inline-template")&&(e.inlineTemplate=!0)}(e);for(var r=0;r<Bs.length;r++)e=Bs[r](e,t)||e;return function(e){var t,n,r,o,i,a,s,c,u=e.attrsList;for(t=0,n=u.length;t<n;t++)if(r=o=u[t].name,i=u[t].value,Ns.test(r))if(e.hasBindings=!0,(a=Zs(r.replace(Ns,"")))&&(r=r.replace(Fs,"")),Ps.test(r))r=r.replace(Ps,""),i=pi(i),(c=js.test(r))&&(r=r.slice(1,-1)),a&&(a.prop&&!c&&"innerHtml"===(r=it(r))&&(r="innerHTML"),a.camel&&!c&&(r=it(r)),a.sync&&(s=$i(i,"$event"),c?wi(e,'"update:"+('+r+")",s,null,!1,0,u[t],!0):(wi(e,"update:"+it(r),s,null,!1,0,u[t]),ct(r)!==it(r)&&wi(e,"update:"+ct(r),s,null,!1,0,u[t])))),a&&a.prop||!e.component&&Es(e.tag,e.attrsMap.type,r)?mi(e,r,i,u[t],c):gi(e,r,i,u[t],c);else if(Os.test(r))r=r.replace(Os,""),(c=js.test(r))&&(r=r.slice(1,-1)),wi(e,r,i,a,!1,0,u[t],c);else{var l=(r=r.replace(Ns,"")).match(Rs),d=l&&l[1];c=!1,d&&(r=r.slice(0,-(d.length+1)),js.test(d)&&(d=d.slice(1,-1),c=!0)),bi(e,r,o,i,d,c,a,u[t])}else gi(e,r,JSON.stringify(i),u[t]),!e.component&&"muted"===r&&Es(e.tag,e.attrsMap.type,r)&&mi(e,r,"true",u[t])}(e),e}function qs(e){var t;if(t=xi(e,"v-for")){var n=function(e){var t=e.match(Ts);if(t){var n={};n.for=t[2].trim();var r=t[1].trim().replace(Ds,""),o=r.match(Ls);return o?(n.alias=r.replace(Ls,"").trim(),n.iterator1=o[1].trim(),o[2]&&(n.iterator2=o[2].trim())):n.alias=r,n}}(t);n&&dt(e,n)}}function Ks(e,t){e.ifConditions||(e.ifConditions=[]),e.ifConditions.push(t)}function Js(e){var t=e.name.replace(zs,"");return t||"#"!==e.name[0]&&(t="default"),js.test(t)?{name:t.slice(1,-1),dynamic:!0}:{name:'"'+t+'"',dynamic:!1}}function Zs(e){var t=e.match(Fs);if(t){var n={};return t.forEach((function(e){n[e.slice(1)]=!0})),n}}function Xs(e){for(var t={},n=0,r=e.length;n<r;n++)t[e[n].name]=e[n].value;return t}var Gs=/^xmlns:NS\d+/,Qs=/^NS\d+:/;function ec(e){return Hs(e.tag,e.attrsList.slice(),e.parent)}var tc,nc,rc,oc=[es,ts,{preTransformNode:function(e,t){if("input"===e.tag){var n,r=e.attrsMap;if(!r["v-model"])return;if((r[":type"]||r["v-bind:type"])&&(n=Ci(e,"type")),r.type||n||!r["v-bind"]||(n="("+r["v-bind"]+").type"),n){var o=xi(e,"v-if",!0),i=o?"&&("+o+")":"",a=null!=xi(e,"v-else",!0),s=xi(e,"v-else-if",!0),c=ec(e);qs(c),yi(c,"type","checkbox"),Ys(c,t),c.processed=!0,c.if="("+n+")==='checkbox'"+i,Ks(c,{exp:c.if,block:c});var u=ec(e);xi(u,"v-for",!0),yi(u,"type","radio"),Ys(u,t),Ks(c,{exp:"("+n+")==='radio'"+i,block:u});var l=ec(e);return xi(l,"v-for",!0),yi(l,":type",n),Ys(l,t),Ks(c,{exp:o,block:l}),a?c.else=!0:s&&(c.elseif=s),c}}}}],ic={expectHTML:!0,modules:oc,directives:{model:function(e,t,n){var r=t.value,o=t.modifiers,i=e.tag,a=e.attrsMap.type;if(e.component)return _i(e,r,o),!1;if("select"===i)!function(e,t,n){var r='var $$selectedVal = Array.prototype.filter.call($event.target.options,function(o){return o.selected}).map(function(o){var val = "_value" in o ? o._value : o.value;return '+(n&&n.number?"_n(val)":"val")+"});";wi(e,"change",r=r+" "+$i(t,"$event.target.multiple ? $$selectedVal : $$selectedVal[0]"),null,!0)}(e,r,o);else if("input"===i&&"checkbox"===a)!function(e,t,n){var r=n&&n.number,o=Ci(e,"value")||"null",i=Ci(e,"true-value")||"true",a=Ci(e,"false-value")||"false";mi(e,"checked","Array.isArray("+t+")?_i("+t+","+o+")>-1"+("true"===i?":("+t+")":":_q("+t+","+i+")")),wi(e,"change","var $$a="+t+",$$el=$event.target,$$c=$$el.checked?("+i+"):("+a+");if(Array.isArray($$a)){var $$v="+(r?"_n("+o+")":o)+",$$i=_i($$a,$$v);if($$el.checked){$$i<0&&("+$i(t,"$$a.concat([$$v])")+")}else{$$i>-1&&("+$i(t,"$$a.slice(0,$$i).concat($$a.slice($$i+1))")+")}}else{"+$i(t,"$$c")+"}",null,!0)}(e,r,o);else if("input"===i&&"radio"===a)!function(e,t,n){var r=n&&n.number,o=Ci(e,"value")||"null";mi(e,"checked","_q("+t+","+(o=r?"_n("+o+")":o)+")"),wi(e,"change",$i(t,o),null,!0)}(e,r,o);else if("input"===i||"textarea"===i)!function(e,t,n){var r=e.attrsMap.type,o=n||{},i=o.lazy,a=o.number,s=o.trim,c=!i&&"range"!==r,u=i?"change":"range"===r?"__r":"input",l="$event.target.value";s&&(l="$event.target.value.trim()"),a&&(l="_n("+l+")");var d=$i(t,l);c&&(d="if($event.target.composing)return;"+d),mi(e,"value","("+t+")"),wi(e,u,d,null,!0),(s||a)&&wi(e,"blur","$forceUpdate()")}(e,r,o);else if(!Ct.isReservedTag(i))return _i(e,r,o),!1;return!0},text:function(e,t){t.value&&mi(e,"textContent","_s("+t.value+")",t)},html:function(e,t){t.value&&mi(e,"innerHTML","_s("+t.value+")",t)}},isPreTag:function(e){return"pre"===e},isUnaryTag:ns,mustUseProp:Ao,canBeLeftOpenTag:rs,isReservedTag:Lo,getTagNamespace:Do,staticKeys:(rc=oc,rc.reduce((function(e,t){return e.concat(t.staticKeys||[])}),[]).join(","))},ac=rt((function(e){return Xe("type,tag,attrsList,attrsMap,plain,parent,children,attrs,start,end,rawAttrsMap"+(e?","+e:""))}));function sc(e,t){e&&(tc=ac(t.staticKeys||""),nc=t.isReservedTag||ht,cc(e),uc(e,!1))}function cc(e){if(e.static=function(e){return 2!==e.type&&(3===e.type||!(!e.pre&&(e.hasBindings||e.if||e.for||Ge(e.tag)||!nc(e.tag)||function(e){for(;e.parent;){if("template"!==(e=e.parent).tag)return!1;if(e.for)return!0}return!1}(e)||!Object.keys(e).every(tc))))}(e),1===e.type){if(!nc(e.tag)&&"slot"!==e.tag&&null==e.attrsMap["inline-template"])return;for(var t=0,n=e.children.length;t<n;t++){var r=e.children[t];cc(r),r.static||(e.static=!1)}if(e.ifConditions)for(var o=1,i=e.ifConditions.length;o<i;o++){var a=e.ifConditions[o].block;cc(a),a.static||(e.static=!1)}}}function uc(e,t){if(1===e.type){if((e.static||e.once)&&(e.staticInFor=t),e.static&&e.children.length&&(1!==e.children.length||3!==e.children[0].type))return void(e.staticRoot=!0);if(e.staticRoot=!1,e.children)for(var n=0,r=e.children.length;n<r;n++)uc(e.children[n],t||!!e.for);if(e.ifConditions)for(var o=1,i=e.ifConditions.length;o<i;o++)uc(e.ifConditions[o].block,t)}}var lc=/^([\w$_]+|\([^)]*?\))\s*=>|^function(?:\s+[\w$]+)?\s*\(/,dc=/\([^)]*?\);*$/,pc=/^[A-Za-z_$][\w$]*(?:\.[A-Za-z_$][\w$]*|\['[^']*?']|\["[^"]*?"]|\[\d+]|\[[A-Za-z_$][\w$]*])*$/,fc={esc:27,tab:9,enter:13,space:32,up:38,left:37,right:39,down:40,delete:[8,46]},hc={esc:["Esc","Escape"],tab:"Tab",enter:"Enter",space:[" ","Spacebar"],up:["Up","ArrowUp"],left:["Left","ArrowLeft"],right:["Right","ArrowRight"],down:["Down","ArrowDown"],delete:["Backspace","Delete","Del"]},vc=function(e){return"if("+e+")return null;"},mc={stop:"$event.stopPropagation();",prevent:"$event.preventDefault();",self:vc("$event.target !== $event.currentTarget"),ctrl:vc("!$event.ctrlKey"),shift:vc("!$event.shiftKey"),alt:vc("!$event.altKey"),meta:vc("!$event.metaKey"),left:vc("'button' in $event && $event.button !== 0"),middle:vc("'button' in $event && $event.button !== 1"),right:vc("'button' in $event && $event.button !== 2")};function gc(e,t){var n=t?"nativeOn:":"on:",r="",o="";for(var i in e){var a=yc(e[i]);e[i]&&e[i].dynamic?o+=i+","+a+",":r+='"'+i+'":'+a+","}return r="{"+r.slice(0,-1)+"}",o?n+"_d("+r+",["+o.slice(0,-1)+"])":n+r}function yc(e){if(!e)return"function(){}";if(Array.isArray(e))return"["+e.map((function(e){return yc(e)})).join(",")+"]";var t=pc.test(e.value),n=lc.test(e.value),r=pc.test(e.value.replace(dc,""));if(e.modifiers){var o="",i="",a=[];for(var s in e.modifiers)if(mc[s])i+=mc[s],fc[s]&&a.push(s);else if("exact"===s){var c=e.modifiers;i+=vc(["ctrl","shift","alt","meta"].filter((function(e){return!c[e]})).map((function(e){return"$event."+e+"Key"})).join("||"))}else a.push(s);return a.length&&(o+=function(e){return"if(!$event.type.indexOf('key')&&"+e.map(bc).join("&&")+")return null;"}(a)),i&&(o+=i),"function($event){"+o+(t?"return "+e.value+"($event)":n?"return ("+e.value+")($event)":r?"return "+e.value:e.value)+"}"}return t||n?e.value:"function($event){"+(r?"return "+e.value:e.value)+"}"}function bc(e){var t=parseInt(e,10);if(t)return"$event.keyCode!=="+t;var n=fc[e],r=hc[e];return"_k($event.keyCode,"+JSON.stringify(e)+","+JSON.stringify(n)+",$event.key,"+JSON.stringify(r)+")"}var Ac={on:function(e,t){e.wrapListeners=function(e){return"_g("+e+","+t.value+")"}},bind:function(e,t){e.wrapData=function(n){return"_b("+n+",'"+e.tag+"',"+t.value+","+(t.modifiers&&t.modifiers.prop?"true":"false")+(t.modifiers&&t.modifiers.sync?",true":"")+")"}},cloak:ft},wc=function(e){this.options=e,this.warn=e.warn||hi,this.transforms=vi(e.modules,"transformCode"),this.dataGenFns=vi(e.modules,"genData"),this.directives=dt(dt({},Ac),e.directives);var t=e.isReservedTag||ht;this.maybeComponent=function(e){return!!e.component||!t(e.tag)},this.onceId=0,this.staticRenderFns=[],this.pre=!1};function Cc(e,t){var n=new wc(t);return{render:"with(this){return "+(e?xc(e,n):'_c("div")')+"}",staticRenderFns:n.staticRenderFns}}function xc(e,t){if(e.parent&&(e.pre=e.pre||e.parent.pre),e.staticRoot&&!e.staticProcessed)return kc(e,t);if(e.once&&!e.onceProcessed)return Bc(e,t);if(e.for&&!e.forProcessed)return Sc(e,t);if(e.if&&!e.ifProcessed)return _c(e,t);if("template"!==e.tag||e.slotTarget||t.pre){if("slot"===e.tag)return function(e,t){var n=e.slotName||'"default"',r=Nc(e,t),o="_t("+n+(r?","+r:""),i=e.attrs||e.dynamicAttrs?Dc((e.attrs||[]).concat(e.dynamicAttrs||[]).map((function(e){return{name:it(e.name),value:e.value,dynamic:e.dynamic}}))):null,a=e.attrsMap["v-bind"];return!i&&!a||r||(o+=",null"),i&&(o+=","+i),a&&(o+=(i?"":",null")+","+a),o+")"}(e,t);var n;if(e.component)n=function(e,t,n){var r=t.inlineTemplate?null:Nc(t,n,!0);return"_c("+e+","+Ec(t,n)+(r?","+r:"")+")"}(e.component,e,t);else{var r;(!e.plain||e.pre&&t.maybeComponent(e))&&(r=Ec(e,t));var o=e.inlineTemplate?null:Nc(e,t,!0);n="_c('"+e.tag+"'"+(r?","+r:"")+(o?","+o:"")+")"}for(var i=0;i<t.transforms.length;i++)n=t.transforms[i](e,n);return n}return Nc(e,t)||"void 0"}function kc(e,t){e.staticProcessed=!0;var n=t.pre;return e.pre&&(t.pre=e.pre),t.staticRenderFns.push("with(this){return "+xc(e,t)+"}"),t.pre=n,"_m("+(t.staticRenderFns.length-1)+(e.staticInFor?",true":"")+")"}function Bc(e,t){if(e.onceProcessed=!0,e.if&&!e.ifProcessed)return _c(e,t);if(e.staticInFor){for(var n="",r=e.parent;r;){if(r.for){n=r.key;break}r=r.parent}return n?"_o("+xc(e,t)+","+t.onceId+++","+n+")":xc(e,t)}return kc(e,t)}function _c(e,t,n,r){return e.ifProcessed=!0,$c(e.ifConditions.slice(),t,n,r)}function $c(e,t,n,r){if(!e.length)return r||"_e()";var o=e.shift();return o.exp?"("+o.exp+")?"+i(o.block)+":"+$c(e,t,n,r):""+i(o.block);function i(e){return n?n(e,t):e.once?Bc(e,t):xc(e,t)}}function Sc(e,t,n,r){var o=e.for,i=e.alias,a=e.iterator1?","+e.iterator1:"",s=e.iterator2?","+e.iterator2:"";return e.forProcessed=!0,(r||"_l")+"(("+o+"),function("+i+a+s+"){return "+(n||xc)(e,t)+"})"}function Ec(e,t){var n="{",r=function(e,t){var n=e.directives;if(n){var r,o,i,a,s="directives:[",c=!1;for(r=0,o=n.length;r<o;r++){i=n[r],a=!0;var u=t.directives[i.name];u&&(a=!!u(e,i,t.warn)),a&&(c=!0,s+='{name:"'+i.name+'",rawName:"'+i.rawName+'"'+(i.value?",value:("+i.value+"),expression:"+JSON.stringify(i.value):"")+(i.arg?",arg:"+(i.isDynamicArg?i.arg:'"'+i.arg+'"'):"")+(i.modifiers?",modifiers:"+JSON.stringify(i.modifiers):"")+"},")}return c?s.slice(0,-1)+"]":void 0}}(e,t);r&&(n+=r+","),e.key&&(n+="key:"+e.key+","),e.ref&&(n+="ref:"+e.ref+","),e.refInFor&&(n+="refInFor:true,"),e.pre&&(n+="pre:true,"),e.component&&(n+='tag:"'+e.tag+'",');for(var o=0;o<t.dataGenFns.length;o++)n+=t.dataGenFns[o](e);if(e.attrs&&(n+="attrs:"+Dc(e.attrs)+","),e.props&&(n+="domProps:"+Dc(e.props)+","),e.events&&(n+=gc(e.events,!1)+","),e.nativeEvents&&(n+=gc(e.nativeEvents,!0)+","),e.slotTarget&&!e.slotScope&&(n+="slot:"+e.slotTarget+","),e.scopedSlots&&(n+=function(e,t,n){var r=e.for||Object.keys(t).some((function(e){var n=t[e];return n.slotTargetDynamic||n.if||n.for||Ic(n)})),o=!!e.if;if(!r)for(var i=e.parent;i;){if(i.slotScope&&i.slotScope!==Ws||i.for){r=!0;break}i.if&&(o=!0),i=i.parent}var a=Object.keys(t).map((function(e){return Oc(t[e],n)})).join(",");return"scopedSlots:_u(["+a+"]"+(r?",null,true":"")+(!r&&o?",null,false,"+function(e){for(var t=5381,n=e.length;n;)t=33*t^e.charCodeAt(--n);return t>>>0}(a):"")+")"}(e,e.scopedSlots,t)+","),e.model&&(n+="model:{value:"+e.model.value+",callback:"+e.model.callback+",expression:"+e.model.expression+"},"),e.inlineTemplate){var i=function(e,t){var n=e.children[0];if(n&&1===n.type){var r=Cc(n,t.options);return"inlineTemplate:{render:function(){"+r.render+"},staticRenderFns:["+r.staticRenderFns.map((function(e){return"function(){"+e+"}"})).join(",")+"]}"}}(e,t);i&&(n+=i+",")}return n=n.replace(/,$/,"")+"}",e.dynamicAttrs&&(n="_b("+n+',"'+e.tag+'",'+Dc(e.dynamicAttrs)+")"),e.wrapData&&(n=e.wrapData(n)),e.wrapListeners&&(n=e.wrapListeners(n)),n}function Ic(e){return 1===e.type&&("slot"===e.tag||e.children.some(Ic))}function Oc(e,t){var n=e.attrsMap["slot-scope"];if(e.if&&!e.ifProcessed&&!n)return _c(e,t,Oc,"null");if(e.for&&!e.forProcessed)return Sc(e,t,Oc);var r=e.slotScope===Ws?"":String(e.slotScope),o="function("+r+"){return "+("template"===e.tag?e.if&&n?"("+e.if+")?"+(Nc(e,t)||"undefined")+":undefined":Nc(e,t)||"undefined":xc(e,t))+"}",i=r?"":",proxy:true";return"{key:"+(e.slotTarget||'"default"')+",fn:"+o+i+"}"}function Nc(e,t,n,r,o){var i=e.children;if(i.length){var a=i[0];if(1===i.length&&a.for&&"template"!==a.tag&&"slot"!==a.tag){var s=n?t.maybeComponent(a)?",1":",0":"";return""+(r||xc)(a,t)+s}var c=n?function(e,t){for(var n=0,r=0;r<e.length;r++){var o=e[r];if(1===o.type){if(Tc(o)||o.ifConditions&&o.ifConditions.some((function(e){return Tc(e.block)}))){n=2;break}(t(o)||o.ifConditions&&o.ifConditions.some((function(e){return t(e.block)})))&&(n=1)}}return n}(i,t.maybeComponent):0,u=o||Lc;return"["+i.map((function(e){return u(e,t)})).join(",")+"]"+(c?","+c:"")}}function Tc(e){return void 0!==e.for||"template"===e.tag||"slot"===e.tag}function Lc(e,t){return 1===e.type?xc(e,t):3===e.type&&e.isComment?function(e){return"_e("+JSON.stringify(e.text)+")"}(e):"_v("+(2===(n=e).type?n.expression:jc(JSON.stringify(n.text)))+")";var n}function Dc(e){for(var t="",n="",r=0;r<e.length;r++){var o=e[r],i=jc(o.value);o.dynamic?n+=o.name+","+i+",":t+='"'+o.name+'":'+i+","}return t="{"+t.slice(0,-1)+"}",n?"_d("+t+",["+n.slice(0,-1)+"])":t}function jc(e){return e.replace(/\u2028/g,"\\u2028").replace(/\u2029/g,"\\u2029")}function Rc(e,t){try{return new Function(e)}catch(n){return t.push({err:n,code:e}),ft}}function Pc(e){var t=Object.create(null);return function(n,r,o){(r=dt({},r)).warn,delete r.warn;var i=r.delimiters?String(r.delimiters)+n:n;if(t[i])return t[i];var a=e(n,r),s={},c=[];return s.render=Rc(a.render,c),s.staticRenderFns=a.staticRenderFns.map((function(e){return Rc(e,c)})),t[i]=s}}new RegExp("\\b"+"do,if,for,let,new,try,var,case,else,with,await,break,catch,class,const,super,throw,while,yield,delete,export,import,return,switch,default,extends,finally,continue,debugger,function,arguments".split(",").join("\\b|\\b")+"\\b"),new RegExp("\\b"+"delete,typeof,void".split(",").join("\\s*\\([^\\)]*\\)|\\b")+"\\s*\\([^\\)]*\\)");var Fc,zc,Mc=(Fc=function(e,t){var n=function(e,t){xs=t.warn||hi,Ss=t.isPreTag||ht,Es=t.mustUseProp||ht,Is=t.getTagNamespace||ht,t.isReservedTag,Bs=vi(t.modules,"transformNode"),_s=vi(t.modules,"preTransformNode"),$s=vi(t.modules,"postTransformNode"),ks=t.delimiters;var n,r,o=[],i=!1!==t.preserveWhitespace,a=t.whitespace,s=!1,c=!1;function u(e){if(l(e),s||e.processed||(e=Ys(e,t)),o.length||e===n||n.if&&(e.elseif||e.else)&&Ks(n,{exp:e.elseif,block:e}),r&&!e.forbidden)if(e.elseif||e.else)a=e,(u=function(e){for(var t=e.length;t--;){if(1===e[t].type)return e[t];e.pop()}}(r.children))&&u.if&&Ks(u,{exp:a.elseif,block:a});else{if(e.slotScope){var i=e.slotTarget||'"default"';(r.scopedSlots||(r.scopedSlots={}))[i]=e}r.children.push(e),e.parent=r}var a,u;e.children=e.children.filter((function(e){return!e.slotScope})),l(e),e.pre&&(s=!1),Ss(e.tag)&&(c=!1);for(var d=0;d<$s.length;d++)$s[d](e,t)}function l(e){if(!c)for(var t;(t=e.children[e.children.length-1])&&3===t.type&&" "===t.text;)e.children.pop()}return function(e,t){for(var n,r,o=[],i=t.expectHTML,a=t.isUnaryTag||ht,s=t.canBeLeftOpenTag||ht,c=0;e;){if(n=e,r&&vs(r)){var u=0,l=r.toLowerCase(),d=ms[l]||(ms[l]=new RegExp("([\\s\\S]*?)(</"+l+"[^>]*>)","i")),p=e.replace(d,(function(e,n,r){return u=r.length,vs(l)||"noscript"===l||(n=n.replace(/<!\--([\s\S]*?)-->/g,"$1").replace(/<!\[CDATA\[([\s\S]*?)]]>/g,"$1")),ws(l,n)&&(n=n.slice(1)),t.chars&&t.chars(n),""}));c+=e.length-p.length,e=p,_(l,c-u,c)}else{var f=e.indexOf("<");if(0===f){if(fs.test(e)){var h=e.indexOf("--\x3e");if(h>=0){t.shouldKeepComment&&t.comment(e.substring(4,h),c,c+h+3),x(h+3);continue}}if(hs.test(e)){var v=e.indexOf("]>");if(v>=0){x(v+2);continue}}var m=e.match(ps);if(m){x(m[0].length);continue}var g=e.match(ds);if(g){var y=c;x(g[0].length),_(g[1],y,c);continue}var b=k();if(b){B(b),ws(b.tagName,e)&&x(1);continue}}var A=void 0,w=void 0,C=void 0;if(f>=0){for(w=e.slice(f);!(ds.test(w)||us.test(w)||fs.test(w)||hs.test(w)||(C=w.indexOf("<",1))<0);)f+=C,w=e.slice(f);A=e.substring(0,f)}f<0&&(A=e),A&&x(A.length),t.chars&&A&&t.chars(A,c-A.length,c)}if(e===n){t.chars&&t.chars(e);break}}function x(t){c+=t,e=e.substring(t)}function k(){var t=e.match(us);if(t){var n,r,o={tagName:t[1],attrs:[],start:c};for(x(t[0].length);!(n=e.match(ls))&&(r=e.match(as)||e.match(is));)r.start=c,x(r[0].length),r.end=c,o.attrs.push(r);if(n)return o.unarySlash=n[1],x(n[0].length),o.end=c,o}}function B(e){var n=e.tagName,c=e.unarySlash;i&&("p"===r&&os(n)&&_(r),s(n)&&r===n&&_(n));for(var u=a(n)||!!c,l=e.attrs.length,d=new Array(l),p=0;p<l;p++){var f=e.attrs[p],h=f[3]||f[4]||f[5]||"",v="a"===n&&"href"===f[1]?t.shouldDecodeNewlinesForHref:t.shouldDecodeNewlines;d[p]={name:f[1],value:Cs(h,v)}}u||(o.push({tag:n,lowerCasedTag:n.toLowerCase(),attrs:d,start:e.start,end:e.end}),r=n),t.start&&t.start(n,d,u,e.start,e.end)}function _(e,n,i){var a,s;if(null==n&&(n=c),null==i&&(i=c),e)for(s=e.toLowerCase(),a=o.length-1;a>=0&&o[a].lowerCasedTag!==s;a--);else a=0;if(a>=0){for(var u=o.length-1;u>=a;u--)t.end&&t.end(o[u].tag,n,i);o.length=a,r=a&&o[a-1].tag}else"br"===s?t.start&&t.start(e,[],!0,n,i):"p"===s&&(t.start&&t.start(e,[],!1,n,i),t.end&&t.end(e,n,i))}_()}(e,{warn:xs,expectHTML:t.expectHTML,isUnaryTag:t.isUnaryTag,canBeLeftOpenTag:t.canBeLeftOpenTag,shouldDecodeNewlines:t.shouldDecodeNewlines,shouldDecodeNewlinesForHref:t.shouldDecodeNewlinesForHref,shouldKeepComment:t.comments,outputSourceRange:t.outputSourceRange,start:function(e,i,a,l,d){var p=r&&r.ns||Is(e);Tt&&"svg"===p&&(i=function(e){for(var t=[],n=0;n<e.length;n++){var r=e[n];Gs.test(r.name)||(r.name=r.name.replace(Qs,""),t.push(r))}return t}(i));var f,h=Hs(e,i,r);p&&(h.ns=p),"style"!==(f=h).tag&&("script"!==f.tag||f.attrsMap.type&&"text/javascript"!==f.attrsMap.type)||Mt()||(h.forbidden=!0);for(var v=0;v<_s.length;v++)h=_s[v](h,t)||h;s||(function(e){null!=xi(e,"v-pre")&&(e.pre=!0)}(h),h.pre&&(s=!0)),Ss(h.tag)&&(c=!0),s?function(e){var t=e.attrsList,n=t.length;if(n)for(var r=e.attrs=new Array(n),o=0;o<n;o++)r[o]={name:t[o].name,value:JSON.stringify(t[o].value)},null!=t[o].start&&(r[o].start=t[o].start,r[o].end=t[o].end);else e.pre||(e.plain=!0)}(h):h.processed||(qs(h),function(e){var t=xi(e,"v-if");if(t)e.if=t,Ks(e,{exp:t,block:e});else{null!=xi(e,"v-else")&&(e.else=!0);var n=xi(e,"v-else-if");n&&(e.elseif=n)}}(h),function(e){null!=xi(e,"v-once")&&(e.once=!0)}(h)),n||(n=h),a?u(h):(r=h,o.push(h))},end:function(e,t,n){var i=o[o.length-1];o.length-=1,r=o[o.length-1],u(i)},chars:function(e,t,n){if(r&&(!Tt||"textarea"!==r.tag||r.attrsMap.placeholder!==e)){var o,u,l,d=r.children;(e=c||e.trim()?"script"===(o=r).tag||"style"===o.tag?e:Vs(e):d.length?a?"condense"===a&&Ms.test(e)?"":" ":i?" ":"":"")&&(c||"condense"!==a||(e=e.replace(Us," ")),!s&&" "!==e&&(u=function(e,t){var n=t?Qa(t):Xa;if(n.test(e)){for(var r,o,i,a=[],s=[],c=n.lastIndex=0;r=n.exec(e);){(o=r.index)>c&&(s.push(i=e.slice(c,o)),a.push(JSON.stringify(i)));var u=pi(r[1].trim());a.push("_s("+u+")"),s.push({"@binding":u}),c=o+r[0].length}return c<e.length&&(s.push(i=e.slice(c)),a.push(JSON.stringify(i))),{expression:a.join("+"),tokens:s}}}(e,ks))?l={type:2,expression:u.expression,tokens:u.tokens,text:e}:" "===e&&d.length&&" "===d[d.length-1].text||(l={type:3,text:e}),l&&d.push(l))}},comment:function(e,t,n){if(r){var o={type:3,text:e,isComment:!0};r.children.push(o)}}}),n}(e.trim(),t);!1!==t.optimize&&sc(n,t);var r=Cc(n,t);return{ast:n,render:r.render,staticRenderFns:r.staticRenderFns}},function(e){function t(t,n){var r=Object.create(e),o=[],i=[];if(n)for(var a in n.modules&&(r.modules=(e.modules||[]).concat(n.modules)),n.directives&&(r.directives=dt(Object.create(e.directives||null),n.directives)),n)"modules"!==a&&"directives"!==a&&(r[a]=n[a]);r.warn=function(e,t,n){(n?i:o).push(e)};var s=Fc(t.trim(),r);return s.errors=o,s.tips=i,s}return{compile:t,compileToFunctions:Pc(t)}})(ic),Uc=(Mc.compile,Mc.compileToFunctions);function Vc(e){return(zc=zc||document.createElement("div")).innerHTML=e?'<a href="\n"/>':'<div a="\n"/>',zc.innerHTML.indexOf("&#10;")>0}var Wc=!!Et&&Vc(!1),Hc=!!Et&&Vc(!0),Yc=rt((function(e){var t=Po(e);return t&&t.innerHTML})),qc=lo.prototype.$mount;lo.prototype.$mount=function(e,t){if((e=e&&Po(e))===document.body||e===document.documentElement)return this;var n=this.$options;if(!n.render){var r=n.template;if(r)if("string"==typeof r)"#"===r.charAt(0)&&(r=Yc(r));else{if(!r.nodeType)return this;r=r.innerHTML}else e&&(r=function(e){if(e.outerHTML)return e.outerHTML;var t=document.createElement("div");return t.appendChild(e.cloneNode(!0)),t.innerHTML}(e));if(r){var o=Uc(r,{outputSourceRange:!1,shouldDecodeNewlines:Wc,shouldDecodeNewlinesForHref:Hc,delimiters:n.delimiters,comments:n.comments},this),i=o.render,a=o.staticRenderFns;n.render=i,n.staticRenderFns=a}}return qc.call(this,e,t)},lo.compile=Uc;var Kc=lo;function Jc(e){return(Jc="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function Zc(e,t,n,r,o,i,a){try{var s=e[i](a),c=s.value}catch(e){return void n(e)}s.done?t(c):Promise.resolve(c).then(r,o)}function Xc(e){return function(){var t=this,n=arguments;return new Promise((function(r,o){var i=e.apply(t,n);function a(e){Zc(i,r,o,a,s,"next",e)}function s(e){Zc(i,r,o,a,s,"throw",e)}a(void 0)}))}}function Gc(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function Qc(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function eu(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function tu(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){eu(e,t,n[t])}))}return e}function nu(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&ou(e,t)}function ru(e){return(ru=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)})(e)}function ou(e,t){return(ou=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e})(e,t)}function iu(e,t){if(null==e)return{};var n,r,o=function(e,t){if(null==e)return{};var n,r,o={},i=Object.keys(e);for(r=0;r<i.length;r++)n=i[r],t.indexOf(n)>=0||(o[n]=e[n]);return o}(e,t);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);for(r=0;r<i.length;r++)n=i[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(o[n]=e[n])}return o}function au(e,t){return!t||"object"!=typeof t&&"function"!=typeof t?function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}(e):t}function su(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=[],r=!0,o=!1,i=void 0;try{for(var a,s=e[Symbol.iterator]();!(r=(a=s.next()).done)&&(n.push(a.value),!t||n.length!==t);r=!0);}catch(e){o=!0,i=e}finally{try{r||null==s.return||s.return()}finally{if(o)throw i}}return n}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance")}()}function cu(e){return function(e){if(Array.isArray(e)){for(var t=0,n=new Array(e.length);t<e.length;t++)n[t]=e[t];return n}}(e)||function(e){if(Symbol.iterator in Object(e)||"[object Arguments]"===Object.prototype.toString.call(e))return Array.from(e)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance")}()}function uu(e){return JSON.parse(JSON.stringify(e))}function lu(e,t){return du.apply(this,arguments)}function du(){return(du=Xc(regeneratorRuntime.mark((function e(t,n){var r,o,i,a,s,c,u,l,d;return regeneratorRuntime.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:return r=n.data,o=void 0===r?{}:r,i=n.meta,a=void 0===i?{}:i,s=n.x,c=void 0===s?0:s,u=n.y,l=void 0===u?0:u,e.next=3,t.createNode(uu(o));case 3:return(d=e.sent).meta=Object.assign(uu(a),d.meta),d.position[0]=c,d.position[1]=l,e.abrupt("return",d);case 8:case"end":return e.stop()}}),e,this)})))).apply(this,arguments)}function pu(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:[];"object"===Jc(e)&&Object.keys(e).map((function(r){"function"==typeof e[r]?t(r,e[r],n):pu(e[r],t,[].concat(cu(n),[r]))}))}var fu=function(e){return{props:{delay:{type:Number,required:!0}},data:function(){return{timeoutHide:function(){}}},methods:{cancelHide:function(){var e=this.timeoutHide;e&&e.cancel&&this.timeoutHide.cancel()}},mounted:function(){this.timeoutHide=function(e,t,n){var r,o,i,a,s,c,u=0,l=!1,d=!1,p=!0;if("function"!=typeof e)throw new TypeError("Expected a function");function f(t){var n=r,i=o;return r=o=void 0,u=t,a=e.apply(i,n)}function h(e){return u=e,s=setTimeout(m,t),l?f(e):a}function v(e){var n=e-c;return void 0===c||n>=t||n<0||d&&e-u>=i}function m(){var e=Ce();if(v(e))return g(e);s=setTimeout(m,function(e){var n=t-(e-c);return d?Pe(n,i-(e-u)):n}(e))}function g(e){return s=void 0,p&&r?f(e):(r=o=void 0,a)}function y(){var e=Ce(),n=v(e);if(r=arguments,o=this,c=e,n){if(void 0===s)return h(c);if(d)return clearTimeout(s),s=setTimeout(m,t),f(c)}return void 0===s&&(s=setTimeout(m,t)),a}return t=je(t)||0,ye(n)&&(l=!!n.leading,i=(d="maxWait"in n)?Re(je(n.maxWait)||0,t):i,p="trailing"in n?!!n.trailing:p),y.cancel=function(){void 0!==s&&clearTimeout(s),u=0,r=c=o=s=void 0},y.flush=function(){return void 0===s?a:g(Ce())},y}(this[e],this.delay)}}};const hu={name:"Item",mixins:[fu("hideSubitems")],props:{item:Object,args:Object},data:function(){return{visibleSubitems:!1}},computed:{hasSubitems:function(){return this.item.subitems}},methods:{showSubitems:function(){this.visibleSubitems=!0,this.cancelHide()},hideSubitems:function(){this.visibleSubitems=!1},onClick:function(e){e.stopPropagation(),this.item.onClick&&this.item.onClick(this.args),this.$root.$emit("hide")}}};var vu=function(){var e=this,t=e.$createElement,n=e._self._c||t;return n("div",{staticClass:"item",class:{hasSubitems:e.hasSubitems},on:{click:function(t){e.onClick(t)},mouseover:function(t){e.showSubitems()},mouseleave:function(t){e.timeoutHide()}}},[e._v(e._s(e.item.title)),n("div",{directives:[{name:"show",rawName:"v-show",value:e.hasSubitems&&this.visibleSubitems,expression:"hasSubitems && this.visibleSubitems"}],staticClass:"subitems"},e._l(e.item.subitems,(function(t){return n("Item",{key:t.title,attrs:{item:t,args:e.args,delay:e.delay}})})))])};vu._withStripped=!0;var mu=function(e,t,n,r,o,i,a,s){const c=("function"==typeof n?n.options:n)||{};c.__file="/home/travis/build/retejs/context-menu-plugin/src/menu/Item.vue",c.render||(c.render=e.render,c.staticRenderFns=e.staticRenderFns,c._compiled=!0),c._scopeId="data-v-99007bda";{let e;if(t&&(e=function(e){t.call(this,a())}),void 0!==e)if(c.functional){const t=c.render;c.render=function(n,r){return e.call(r),t(n,r)}}else{const t=c.beforeCreate;c.beforeCreate=t?[].concat(t,e):[e]}}return c}({render:vu,staticRenderFns:[]},(function(e){e&&e("data-v-99007bda_0",{source:"\n@charset \"UTF-8\";\n.item[data-v-99007bda], .item .subitems .subitem[data-v-99007bda] {\n  color: #fff;\n  padding: 4px;\n  border-bottom: 1px solid rgba(69, 103, 255, 0.8);\n  background-color: rgba(110, 136, 255, 0.8);\n  cursor: pointer;\n  width: 100%;\n  position: relative;\n}\n.item[data-v-99007bda]:first-child, .item .subitems .subitem[data-v-99007bda]:first-child {\n    border-top-left-radius: 5px;\n    border-top-right-radius: 5px;\n}\n.item[data-v-99007bda]:last-child, .item .subitems .subitem[data-v-99007bda]:last-child {\n    border-bottom-left-radius: 5px;\n    border-bottom-right-radius: 5px;\n}\n.item[data-v-99007bda]:hover, .item .subitems .subitem[data-v-99007bda]:hover {\n    background-color: rgba(130, 153, 255, 0.8);\n}\n.hasSubitems.item[data-v-99007bda]:after, .item .subitems .hasSubitems.subitem[data-v-99007bda]:after {\n  content: '►';\n  position: absolute;\n  opacity: 0.6;\n  right: 5px;\n  top: 5px;\n}\n.item .subitems[data-v-99007bda], .item .subitems .subitem .subitems[data-v-99007bda] {\n  position: absolute;\n  top: 0;\n  left: 100%;\n  width: 120px;\n}\n\n/*# sourceMappingURL=Item.vue.map */",map:{version:3,sources:["Item.vue","/home/travis/build/retejs/context-menu-plugin/src/menu/Item.vue"],names:[],mappings:";AAAA,iBAAiB;ACyDjB;EDvDE,YAAY;EACZ,aAAa;EACb,iDAAiD;EACjD,2CAA2C;EAC3C,gBAAgB;EAChB,YAAY;EACZ,mBAAmB;CAAE;ACiDvB;ID/CI,4BAA4B;IAC5B,6BAA6B;CAAE;AC8CnC;ID5CI,+BAA+B;IAC/B,gCAAgC;CAAE;AC2CtC;IDzCI,2CAA2C;CAAE;AC2CjD;EACA,aAAA;EACA,mBAAA;EACA,aAAA;EACA,WAAA;EACA,SAAA;CAAA;AAPA;EASA,mBAAA;EACA,OAAA;EACA,WAAA;EACA,aAAA;CAEA;;ADxCA,oCAAoC",file:"Item.vue",sourcesContent:["@charset \"UTF-8\";\n.item, .item .subitems .subitem {\n  color: #fff;\n  padding: 4px;\n  border-bottom: 1px solid rgba(69, 103, 255, 0.8);\n  background-color: rgba(110, 136, 255, 0.8);\n  cursor: pointer;\n  width: 100%;\n  position: relative; }\n  .item:first-child, .item .subitems .subitem:first-child {\n    border-top-left-radius: 5px;\n    border-top-right-radius: 5px; }\n  .item:last-child, .item .subitems .subitem:last-child {\n    border-bottom-left-radius: 5px;\n    border-bottom-right-radius: 5px; }\n  .item:hover, .item .subitems .subitem:hover {\n    background-color: rgba(130, 153, 255, 0.8); }\n\n.hasSubitems.item:after, .item .subitems .hasSubitems.subitem:after {\n  content: '►';\n  position: absolute;\n  opacity: 0.6;\n  right: 5px;\n  top: 5px; }\n\n.item .subitems, .item .subitems .subitem .subitems {\n  position: absolute;\n  top: 0;\n  left: 100%;\n  width: 120px; }\n\n/*# sourceMappingURL=Item.vue.map */",null]},media:void 0})}),hu,0,0,0,(function e(){const t=document.head||document.getElementsByTagName("head")[0],n=e.styles||(e.styles={}),r="undefined"!=typeof navigator&&/msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());return function(e,o){if(document.querySelector('style[data-vue-ssr-id~="'+e+'"]'))return;const i=r?o.media||"default":e,a=n[i]||(n[i]={ids:[],parts:[],element:void 0});if(!a.ids.includes(e)){let n=o.source,s=a.ids.length;if(a.ids.push(e),r&&(a.element=a.element||document.querySelector("style[data-group="+i+"]")),!a.element){const e=a.element=document.createElement("style");e.type="text/css",o.media&&e.setAttribute("media",o.media),r&&(e.setAttribute("data-group",i),e.setAttribute("data-next-index","0")),t.appendChild(e)}if(r&&(s=parseInt(a.element.getAttribute("data-next-index")),a.element.setAttribute("data-next-index",s+1)),a.element.styleSheet)a.parts.push(n),a.element.styleSheet.cssText=a.parts.filter(Boolean).join("\n");else{const e=document.createTextNode(n),t=a.element.childNodes;t[s]&&a.element.removeChild(t[s]),t.length?a.element.insertBefore(e,t[s]):a.element.appendChild(e)}}}}));var gu=function(){var e=this,t=e.$createElement,n=e._self._c||t;return n("div",{staticClass:"search"},[n("input",{directives:[{name:"model",rawName:"v-model",value:e.value,expression:"value"}],domProps:{value:e.value},on:{input:function(t){t.target.composing||(e.value=t.target.value)}}})])};gu._withStripped=!0;var yu=function(e,t,n,r,o,i,a,s){const c=("function"==typeof n?n.options:n)||{};c.__file="/home/travis/build/retejs/context-menu-plugin/src/menu/Search.vue",c.render||(c.render=e.render,c.staticRenderFns=e.staticRenderFns,c._compiled=!0),c._scopeId="data-v-5cbfea22";{let e;if(t&&(e=function(e){t.call(this,a())}),void 0!==e)if(c.functional){const t=c.render;c.render=function(n,r){return e.call(r),t(n,r)}}else{const t=c.beforeCreate;c.beforeCreate=t?[].concat(t,e):[e]}}return c}({render:gu,staticRenderFns:[]},(function(e){e&&e("data-v-5cbfea22_0",{source:"\n.search input[data-v-5cbfea22] {\n  color: white;\n  padding: 1px 8px;\n  border: 1px solid white;\n  border-radius: 10px;\n  font-size: 16px;\n  font-family: serif;\n  width: 100%;\n  box-sizing: border-box;\n  background: transparent;\n}\n\n/*# sourceMappingURL=Search.vue.map */",map:{version:3,sources:["/home/travis/build/retejs/context-menu-plugin/src/menu/Search.vue","Search.vue"],names:[],mappings:";AAkBA;EAEA,aAAA;EACA,iBAAA;EACA,wBAAA;EACA,oBAAA;EACA,gBAAA;EACA,mBAAA;EACA,YAAA;EACA,uBAAA;EACA,wBAAA;CAAA;;ACjBA,sCAAsC",file:"Search.vue",sourcesContent:[null,".search input {\n  color: white;\n  padding: 1px 8px;\n  border: 1px solid white;\n  border-radius: 10px;\n  font-size: 16px;\n  font-family: serif;\n  width: 100%;\n  box-sizing: border-box;\n  background: transparent; }\n\n/*# sourceMappingURL=Search.vue.map */"]},media:void 0})}),{props:["value","search"],watch:{value:function(){this.$emit("search",this.value)}}},0,0,0,(function e(){const t=document.head||document.getElementsByTagName("head")[0],n=e.styles||(e.styles={}),r="undefined"!=typeof navigator&&/msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());return function(e,o){if(document.querySelector('style[data-vue-ssr-id~="'+e+'"]'))return;const i=r?o.media||"default":e,a=n[i]||(n[i]={ids:[],parts:[],element:void 0});if(!a.ids.includes(e)){let n=o.source,s=a.ids.length;if(a.ids.push(e),r&&(a.element=a.element||document.querySelector("style[data-group="+i+"]")),!a.element){const e=a.element=document.createElement("style");e.type="text/css",o.media&&e.setAttribute("media",o.media),r&&(e.setAttribute("data-group",i),e.setAttribute("data-next-index","0")),t.appendChild(e)}if(r&&(s=parseInt(a.element.getAttribute("data-next-index")),a.element.setAttribute("data-next-index",s+1)),a.element.styleSheet)a.parts.push(n),a.element.styleSheet.cssText=a.parts.filter(Boolean).join("\n");else{const e=document.createTextNode(n),t=a.element.childNodes;t[s]&&a.element.removeChild(t[s]),t.length?a.element.insertBefore(e,t[s]):a.element.appendChild(e)}}}}));const bu={props:{searchBar:Boolean,searchKeep:Function},mixins:[fu("hide")],data:function(){return{x:0,y:0,visible:!1,args:{},filter:"",items:[]}},computed:{style:function(){return{top:this.y+"px",left:this.x+"px"}},filtered:function(){var e=this;if(!this.filter)return this.items;var t=new RegExp(this.filter,"i");return this.extractLeafs(this.items).filter((function(n){var r=n.title;return e.searchKeep(r)||r.match(t)}))}},methods:{extractLeafs:function(e){var t=this;if(!e)return[];var n=[];return e.map((function(e){e.subitems||n.push(e),n.push.apply(n,cu(t.extractLeafs(e.subitems)))})),n},onSearch:function(e){this.filter=e},show:function(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};this.visible=!0,this.x=e,this.y=t,this.args=n,this.cancelHide()},hide:function(){this.visible=!1},additem:function(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:[],r=this.items,o=!0,i=!1,a=void 0;try{for(var s,c=function(){var e=s.value,t=r.find((function(t){return t.title===e}));t||(t={title:e,subitems:[]},r.push(t)),r=t.subitems||(t.subitems=[])},u=n[Symbol.iterator]();!(o=(s=u.next()).done);o=!0)c()}catch(e){i=!0,a=e}finally{try{o||null==u.return||u.return()}finally{if(i)throw a}}r.push({title:e,onClick:t})}},updated:function(){if(this.$refs.menu){var e=(n=[this.x,this.y],r=this.$refs.menu,i=(o=su(n,2))[0],a=o[1],[Math.min(i,window.innerWidth-r.clientWidth),Math.min(a,window.innerHeight-r.clientHeight)]),t=su(e,2);this.x=t[0],this.y=t[1]}var n,r,o,i,a},mounted:function(){this.$root.$on("show",this.show),this.$root.$on("hide",this.hide),this.$root.$on("additem",this.additem)},components:{Item:mu,Search:yu}};var Au=function(){var e=this,t=e.$createElement,n=e._self._c||t;return e.visible?n("div",{ref:"menu",staticClass:"context-menu",style:e.style,on:{mouseleave:function(t){e.timeoutHide()},mouseover:function(t){e.cancelHide()},contextmenu:function(e){e.preventDefault()}}},[e.searchBar?n("Search",{on:{search:e.onSearch},model:{value:e.filter,callback:function(t){e.filter=t},expression:"filter"}}):e._e(),e._l(e.filtered,(function(t){return n("Item",{key:t.title,attrs:{item:t,args:e.args,delay:e.delay/2}})}))],2):e._e()};Au._withStripped=!0;var wu=function(e,t,n,r,o,i,a,s){const c=("function"==typeof n?n.options:n)||{};c.__file="/home/travis/build/retejs/context-menu-plugin/src/menu/Menu.vue",c.render||(c.render=e.render,c.staticRenderFns=e.staticRenderFns,c._compiled=!0),c._scopeId="data-v-189764d4";{let e;if(t&&(e=function(e){t.call(this,a())}),void 0!==e)if(c.functional){const t=c.render;c.render=function(n,r){return e.call(r),t(n,r)}}else{const t=c.beforeCreate;c.beforeCreate=t?[].concat(t,e):[e]}}return c}({render:Au,staticRenderFns:[]},(function(e){e&&e("data-v-189764d4_0",{source:"\n.item[data-v-189764d4], .context-menu .search[data-v-189764d4] {\n  color: #fff;\n  padding: 4px;\n  border-bottom: 1px solid rgba(69, 103, 255, 0.8);\n  background-color: rgba(110, 136, 255, 0.8);\n  cursor: pointer;\n  width: 100%;\n  position: relative;\n}\n.item[data-v-189764d4]:first-child, .context-menu .search[data-v-189764d4]:first-child {\n    border-top-left-radius: 5px;\n    border-top-right-radius: 5px;\n}\n.item[data-v-189764d4]:last-child, .context-menu .search[data-v-189764d4]:last-child {\n    border-bottom-left-radius: 5px;\n    border-bottom-right-radius: 5px;\n}\n.item[data-v-189764d4]:hover, .context-menu .search[data-v-189764d4]:hover {\n    background-color: rgba(130, 153, 255, 0.8);\n}\n.context-menu[data-v-189764d4] {\n  left: 0;\n  top: 0;\n  position: fixed;\n  padding: 10px;\n  width: 120px;\n  margin-top: -20px;\n  margin-left: -60px;\n}\n\n/*# sourceMappingURL=Menu.vue.map */",map:{version:3,sources:["Menu.vue","/home/travis/build/retejs/context-menu-plugin/src/menu/Menu.vue"],names:[],mappings:";AAAA;EACE,YAAY;EACZ,aAAa;EACb,iDAAiD;EACjD,2CAA2C;EAC3C,gBAAgB;EAChB,YAAY;EACZ,mBAAmB;CAAE;AACrB;IACE,4BAA4B;IAC5B,6BAA6B;CAAE;AACjC;IACE,+BAA+B;IAC/B,gCAAgC;CAAE;AACpC;IACE,2CAA2C;CAAE;ACuGjD;EACA,QAAA;EACA,OAAA;EACA,gBAAA;EACA,cAAA;EACA,aAAA;EACA,kBAAA;EACA,mBAAA;CAEA;;ADrGA,oCAAoC",file:"Menu.vue",sourcesContent:[".item, .context-menu .search {\n  color: #fff;\n  padding: 4px;\n  border-bottom: 1px solid rgba(69, 103, 255, 0.8);\n  background-color: rgba(110, 136, 255, 0.8);\n  cursor: pointer;\n  width: 100%;\n  position: relative; }\n  .item:first-child, .context-menu .search:first-child {\n    border-top-left-radius: 5px;\n    border-top-right-radius: 5px; }\n  .item:last-child, .context-menu .search:last-child {\n    border-bottom-left-radius: 5px;\n    border-bottom-right-radius: 5px; }\n  .item:hover, .context-menu .search:hover {\n    background-color: rgba(130, 153, 255, 0.8); }\n\n.context-menu {\n  left: 0;\n  top: 0;\n  position: fixed;\n  padding: 10px;\n  width: 120px;\n  margin-top: -20px;\n  margin-left: -60px; }\n\n/*# sourceMappingURL=Menu.vue.map */",null]},media:void 0})}),bu,0,0,0,(function e(){const t=document.head||document.getElementsByTagName("head")[0],n=e.styles||(e.styles={}),r="undefined"!=typeof navigator&&/msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());return function(e,o){if(document.querySelector('style[data-vue-ssr-id~="'+e+'"]'))return;const i=r?o.media||"default":e,a=n[i]||(n[i]={ids:[],parts:[],element:void 0});if(!a.ids.includes(e)){let n=o.source,s=a.ids.length;if(a.ids.push(e),r&&(a.element=a.element||document.querySelector("style[data-group="+i+"]")),!a.element){const e=a.element=document.createElement("style");e.type="text/css",o.media&&e.setAttribute("media",o.media),r&&(e.setAttribute("data-group",i),e.setAttribute("data-next-index","0")),t.appendChild(e)}if(r&&(s=parseInt(a.element.getAttribute("data-next-index")),a.element.setAttribute("data-next-index",s+1)),a.element.styleSheet)a.parts.push(n),a.element.styleSheet.cssText=a.parts.filter(Boolean).join("\n");else{const e=document.createTextNode(n),t=a.element.childNodes;t[s]&&a.element.removeChild(t[s]),t.length?a.element.insertBefore(e,t[s]):a.element.appendChild(e)}}}})),Cu=function(){function e(t,n,r){Gc(this,e);var o=document.createElement("div");t.view.container.appendChild(o),this.menu=new Kc({render:function(e){return e(r||wu,{props:n})}}).$mount(o)}var t,n;return t=e,(n=[{key:"addItem",value:function(){for(var e,t=arguments.length,n=new Array(t),r=0;r<t;r++)n[r]=arguments[r];(e=this.menu).$emit.apply(e,["additem"].concat(n))}},{key:"show",value:function(){for(var e,t=arguments.length,n=new Array(t),r=0;r<t;r++)n[r]=arguments[r];(e=this.menu).$emit.apply(e,["show"].concat(n))}},{key:"hide",value:function(){this.menu.$emit("hide")}}])&&Qc(t.prototype,n),e}(),xu=function(e){function t(e,n,r,o){var i,a=o.items,s=o.allocate,c=o.rename;Gc(this,t),i=au(this,ru(t).call(this,e,n,r));var u={x:0,y:0};e.on("mousemove",(function(e){var t=e.x,n=e.y;u.x=t,u.y=n}));var l=!0,d=!1,p=void 0;try{for(var f,h=function(){var t=f.value,n=s(t);Array.isArray(n)&&i.addItem(c(t),Xc(regeneratorRuntime.mark((function n(){return regeneratorRuntime.wrap((function(n){for(;;)switch(n.prev=n.next){case 0:return n.t0=e,n.next=3,lu(t,u);case 3:n.t1=n.sent,n.t0.addNode.call(n.t0,n.t1);case 5:case"end":return n.stop()}}),n,this)}))),n)},v=e.components.values()[Symbol.iterator]();!(l=(f=v.next()).done);l=!0)h()}catch(e){d=!0,p=e}finally{try{l||null==v.return||v.return()}finally{if(d)throw p}}return pu(a,(function(e,t,n){return i.addItem(e,t,n)})),i}return nu(t,e),t}(Cu),ku=function(e){function t(e,n,r,o){var i;return Gc(this,t),i=au(this,ru(t).call(this,e,n,r)),!1!==o.Delete&&i.addItem("Delete",(function(t){var n=t.node;return e.removeNode(n)})),!1!==o.Clone&&i.addItem("Clone",function(){var t=Xc(regeneratorRuntime.mark((function t(n){var r,o,i,a,s,c,u,l;return regeneratorRuntime.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:return r=n.node,o=r.name,i=su(r.position,2),a=i[0],s=i[1],c=iu(r,["name","position"]),u=e.components.get(o),t.next=4,lu(u,tu({},c,{x:a+10,y:s+10}));case 4:l=t.sent,e.addNode(l);case 6:case"end":return t.stop()}}),t,this)})));return function(e){return t.apply(this,arguments)}}()),pu(o,(function(e,t,n){return i.addItem(e,t,n)})),i}return nu(t,e),t}(Cu),Bu=wu,_u=mu,$u=yu,Su={name:"context-menu",install:function(e,t){var n=t.searchBar,r=void 0===n||n,o=t.searchKeep,i=void 0===o?function(){return!1}:o,a=t.delay,s=void 0===a?1e3:a,c=t.items,u=void 0===c?{}:c,l=t.nodeItems,d=void 0===l?{}:l,p=t.allocate,f=void 0===p?function(){return[]}:p,h=t.rename,v=void 0===h?function(e){return e.name}:h,m=t.vueComponent,g=void 0===m?null:m;e.bind("hidecontextmenu"),e.bind("showcontextmenu");var y=null;e.on("hidecontextmenu",(function(){y&&y.hide()})),e.on("click contextmenu",(function(){e.trigger("hidecontextmenu")})),e.on("contextmenu",(function(t){var n=t.e,o=t.node;if(n.preventDefault(),n.stopPropagation(),e.trigger("showcontextmenu",{e:n,node:o})){var a=[n.clientX,n.clientY],c=a[0],l=a[1];o?(y=new ku(e,{searchBar:!1,delay:s},g,function(e){if(!ye(e))return!1;var t=Ie(e);return"[object Function]"==t||"[object GeneratorFunction]"==t||"[object AsyncFunction]"==t||"[object Proxy]"==t}(d)?d(o):d)).show(c,l,{node:o}):(y=new xu(e,{searchBar:r,searchKeep:i,delay:s},g,{items:u,allocate:f,rename:v})).show(c,l)}}))}};function Eu(e,t,n,r,o,i,a){try{var s=e[i](a),c=s.value}catch(e){return void n(e)}s.done?t(c):Promise.resolve(c).then(r,o)}function Iu(e){return function(){var t=this,n=arguments;return new Promise((function(r,o){var i=e.apply(t,n);function a(e){Eu(i,r,o,a,s,"next",e)}function s(e){Eu(i,r,o,a,s,"throw",e)}a(void 0)}))}}function Ou(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function Nu(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter((function(e){return Object.getOwnPropertyDescriptor(n,e).enumerable})))),r.forEach((function(t){Ou(e,t,n[t])}))}return e}Kc.filter("kebab",(function(e){var t=function(e){return e.toLowerCase().replace(/ /g,"-")};return Array.isArray(e)?e.map(t):t(e)}));var Tu={props:["node","editor","bindSocket","bindControl"],methods:{inputs:function(){return Array.from(this.node.inputs.values())},outputs:function(){return Array.from(this.node.outputs.values())},controls:function(){return Array.from(this.node.controls.values())},selected:function(){return this.editor.selected.contains(this.node)?"selected":""}},directives:{socket:{bind:function(e,t,n){n.context.bindSocket(e,t.arg,t.value)},update:function(e,t,n){n.context.bindSocket(e,t.arg,t.value)}},control:{bind:function(e,t,n){t.value&&n.context.bindControl(e,t.value)}}}},Lu=function(e,t,n,r,o,i,a,s,c,u){"boolean"!=typeof a&&(c=s,s=a,a=!1);var l,d="function"==typeof n?n.options:n;if(e&&e.render&&(d.render=e.render,d.staticRenderFns=e.staticRenderFns,d._compiled=!0,o&&(d.functional=!0)),r&&(d._scopeId=r),i?(l=function(e){(e=e||this.$vnode&&this.$vnode.ssrContext||this.parent&&this.parent.$vnode&&this.parent.$vnode.ssrContext)||"undefined"==typeof __VUE_SSR_CONTEXT__||(e=__VUE_SSR_CONTEXT__),t&&t.call(this,c(e)),e&&e._registeredComponents&&e._registeredComponents.add(i)},d._ssrRegister=l):t&&(l=a?function(){t.call(this,u(this.$root.$options.shadowRoot))}:function(e){t.call(this,s(e))}),l)if(d.functional){var p=d.render;d.render=function(e,t){return l.call(t),p(e,t)}}else{var f=d.beforeCreate;d.beforeCreate=f?[].concat(f,l):[l]}return n},Du="undefined"!=typeof navigator&&/msie [6-9]\\b/.test(navigator.userAgent.toLowerCase()),ju=document.head||document.getElementsByTagName("head")[0],Ru={},Pu=function(e){return function(e,t){return function(e,t){var n=Du?t.media||"default":e,r=Ru[n]||(Ru[n]={ids:new Set,styles:[]});if(!r.ids.has(e)){r.ids.add(e);var o=t.source;if(t.map&&(o+="\n/*# sourceURL="+t.map.sources[0]+" */",o+="\n/*# sourceMappingURL=data:application/json;base64,"+btoa(unescape(encodeURIComponent(JSON.stringify(t.map))))+" */"),r.element||(r.element=document.createElement("style"),r.element.type="text/css",t.media&&r.element.setAttribute("media",t.media),ju.appendChild(r.element)),"styleSheet"in r.element)r.styles.push(o),r.element.styleSheet.cssText=r.styles.filter(Boolean).join("\n");else{var i=r.ids.size-1,a=document.createTextNode(o),s=r.element.childNodes;s[i]&&r.element.removeChild(s[i]),s.length?r.element.insertBefore(a,s[i]):r.element.appendChild(a)}}}(e,t)}};var Fu=function(){var e=this,t=e.$createElement;return(e._self._c||t)("div",{staticClass:"socket",class:e._f("kebab")([e.type,e.socket.name]),attrs:{title:e.socket.name}})};Fu._withStripped=!0;var zu=Lu({render:Fu,staticRenderFns:[]},(function(e){e&&e("data-v-212b9c54_0",{source:".socket[data-v-212b9c54] {\n  display: inline-block;\n  cursor: pointer;\n  border: 1px solid white;\n  border-radius: 12px;\n  width: 24px;\n  height: 24px;\n  margin: 6px;\n  vertical-align: middle;\n  background: #96b38a;\n  z-index: 2;\n  box-sizing: border-box;\n}\n.socket[data-v-212b9c54]:hover {\n    border-width: 4px;\n}\n.socket.multiple[data-v-212b9c54] {\n    border-color: yellow;\n}\n.socket.output[data-v-212b9c54] {\n    margin-right: -12px;\n}\n.socket.input[data-v-212b9c54] {\n    margin-left: -12px;\n}\n\n/*# sourceMappingURL=Socket.vue.map */",map:{version:3,sources:["/home/travis/build/retejs/vue-render-plugin/src/Socket.vue","Socket.vue"],names:[],mappings:"AAgBA;EACA,qBAAA;EACA,eAAA;EACA,uBAAA;EACA,mBAAA;EACA,WAAA;EACA,YAAA;EACA,WAAA;EACA,sBAAA;EACA,mBAAA;EACA,UAAA;EACA,sBAAA;AAAA;AAXA;IAaA,iBAAA;AAAA;AAbA;IAeA,oBAAA;AAAA;AAfA;IAiBA,mBAAA;AAAA;AAjBA;IAmBA,kBAAA;AAAA;;ACdA,qCAAqC",file:"Socket.vue",sourcesContent:['<template lang="pug">\n.socket(\n  :class="[type, socket.name] | kebab",\n  :title="socket.name"\n)\n</template>\n\n<script>\nexport default {\n  props: [\'type\', \'socket\']\n}\n<\/script>\n\n<style lang="sass" scoped>\n@import "./vars"\n\n.socket\n  display: inline-block\n  cursor: pointer\n  border: 1px solid white\n  border-radius: $socket-size/2.0\n  width: $socket-size\n  height: $socket-size\n  margin: $socket-margin\n  vertical-align: middle\n  background: $socket-color\n  z-index: 2\n  box-sizing: border-box\n  &:hover\n    border-width: 4px\n  &.multiple\n    border-color: yellow\n  &.output\n    margin-right: - $socket-size / 2\n  &.input\n    margin-left: - $socket-size / 2\n</style>\n',".socket {\n  display: inline-block;\n  cursor: pointer;\n  border: 1px solid white;\n  border-radius: 12px;\n  width: 24px;\n  height: 24px;\n  margin: 6px;\n  vertical-align: middle;\n  background: #96b38a;\n  z-index: 2;\n  box-sizing: border-box; }\n  .socket:hover {\n    border-width: 4px; }\n  .socket.multiple {\n    border-color: yellow; }\n  .socket.output {\n    margin-right: -12px; }\n  .socket.input {\n    margin-left: -12px; }\n\n/*# sourceMappingURL=Socket.vue.map */"]},media:void 0})}),{props:["type","socket"]},"data-v-212b9c54",!1,void 0,Pu,void 0);const Mu={mixins:[Tu],components:{Socket:zu}};var Uu=function(){var e=this,t=e.$createElement,n=e._self._c||t;return n("div",{staticClass:"node",class:e._f("kebab")([e.selected(),e.node.name])},[n("div",{staticClass:"title"},[e._v(e._s(e.node.name))]),e._l(e.outputs(),(function(t){return n("div",{key:t.key,staticClass:"output"},[n("div",{staticClass:"output-title"},[e._v(e._s(t.name))]),n("Socket",{directives:[{name:"socket",rawName:"v-socket:output",value:t,expression:"output",arg:"output"}],attrs:{type:"output",socket:t.socket}})],1)})),e._l(e.controls(),(function(e){return n("div",{directives:[{name:"control",rawName:"v-control",value:e,expression:"control"}],staticClass:"control"})})),e._l(e.inputs(),(function(t){return n("div",{key:t.key,staticClass:"input"},[n("Socket",{directives:[{name:"socket",rawName:"v-socket:input",value:t,expression:"input",arg:"input"}],attrs:{type:"input",socket:t.socket}}),n("div",{directives:[{name:"show",rawName:"v-show",value:!t.showControl(),expression:"!input.showControl()"}],staticClass:"input-title"},[e._v(e._s(t.name))]),n("div",{directives:[{name:"show",rawName:"v-show",value:t.showControl(),expression:"input.showControl()"},{name:"control",rawName:"v-control",value:t.control,expression:"input.control"}],staticClass:"input-control"})],1)}))],2)};Uu._withStripped=!0;var Vu=Lu({render:Uu,staticRenderFns:[]},(function(e){e&&e("data-v-61cff9dc_0",{source:".node[data-v-61cff9dc] {\n  background: rgba(110, 136, 255, 0.8);\n  border: 2px solid #4e58bf;\n  border-radius: 10px;\n  cursor: pointer;\n  min-width: 180px;\n  height: auto;\n  padding-bottom: 6px;\n  box-sizing: content-box;\n  position: relative;\n  user-select: none;\n}\n.node[data-v-61cff9dc]:hover {\n    background: rgba(130, 153, 255, 0.8);\n}\n.node.selected[data-v-61cff9dc] {\n    background: #ffd92c;\n    border-color: #e3c000;\n}\n.node .title[data-v-61cff9dc] {\n    color: white;\n    font-family: sans-serif;\n    font-size: 18px;\n    padding: 8px;\n}\n.node .output[data-v-61cff9dc] {\n    text-align: right;\n}\n.node .input[data-v-61cff9dc] {\n    text-align: left;\n}\n.node .input-title[data-v-61cff9dc], .node .output-title[data-v-61cff9dc] {\n    vertical-align: middle;\n    color: white;\n    display: inline-block;\n    font-family: sans-serif;\n    font-size: 14px;\n    margin: 6px;\n    line-height: 24px;\n}\n.node .input-control[data-v-61cff9dc] {\n    z-index: 1;\n    width: calc(100% - 36px);\n    vertical-align: middle;\n    display: inline-block;\n}\n.node .control[data-v-61cff9dc] {\n    padding: 6px 18px;\n}\n\n/*# sourceMappingURL=Node.vue.map */",map:{version:3,sources:["/home/travis/build/retejs/vue-render-plugin/src/Node.vue","Node.vue"],names:[],mappings:"AAwCA;EACA,oCAAA;EACA,yBAAA;EACA,mBAAA;EACA,eAAA;EACA,gBAAA;EACA,YAAA;EACA,mBAAA;EACA,uBAAA;EACA,kBAAA;EACA,iBAAA;AAAA;AAVA;IAYA,oCAAA;AAAA;AAZA;IAcA,mBAAA;IACA,qBAAA;AAAA;AAfA;IAiBA,YAAA;IACA,uBAAA;IACA,eAAA;IACA,YAAA;AAAA;AApBA;IAsBA,iBAAA;AAAA;AAtBA;IAwBA,gBAAA;AAAA;AAxBA;IA0BA,sBAAA;IACA,YAAA;IACA,qBAAA;IACA,uBAAA;IACA,eAAA;IACA,WAAA;IACA,iBAAA;AAAA;AAhCA;IAkCA,UAAA;IACA,wBAAA;IACA,sBAAA;IACA,qBAAA;AAAA;AArCA;IAuCA,iBAAA;AAAA;;ACtCA,mCAAmC",file:"Node.vue",sourcesContent:['<template lang="pug">\n.node(:class="[selected(), node.name] | kebab")\n  .title {{node.name}}\n\n  // Outputs\n  .output(v-for=\'output in outputs()\' :key="output.key")\n    .output-title {{output.name}}\n    Socket(v-socket:output="output", type="output", :socket="output.socket")\n\n  // Controls\n  .control(\n    v-for=\'control in controls()\',\n    v-control="control"\n  )\n\n  // Inputs\n  .input(v-for=\'input in inputs()\' :key="input.key")\n    Socket(v-socket:input="input", type="input", :socket="input.socket")\n    .input-title(v-show=\'!input.showControl()\') {{input.name}}\n    .input-control(\n      v-show=\'input.showControl()\'\n      v-control="input.control"\n    )\n</template>\n\n<script>\nimport mixin from \'./mixin\';\nimport Socket from \'./Socket.vue\';\n\nexport default {\n  mixins: [mixin],\n  components: {\n    Socket\n  }\n}\n<\/script>\n\n<style lang="sass" scoped>\n@import "./vars"\n\n.node\n  background: $node-color\n  border: 2px solid #4e58bf\n  border-radius: 10px\n  cursor: pointer\n  min-width: $node-width\n  height: auto\n  padding-bottom: 6px\n  box-sizing: content-box\n  position: relative\n  user-select: none\n  &:hover\n    background: lighten($node-color,4%)\n  &.selected\n    background: $node-color-selected\n    border-color: #e3c000\n  .title\n    color: white\n    font-family: sans-serif\n    font-size: 18px\n    padding: 8px\n  .output\n    text-align: right\n  .input\n    text-align: left\n  .input-title,.output-title\n    vertical-align: middle\n    color: white\n    display: inline-block\n    font-family: sans-serif\n    font-size: 14px\n    margin: $socket-margin\n    line-height: $socket-size\n  .input-control\n    z-index: 1\n    width: calc(100% - #{$socket-size + 2*$socket-margin})\n    vertical-align: middle\n    display: inline-block\n  .control\n    padding: $socket-margin $socket-size/2 + $socket-margin\n</style>',".node {\n  background: rgba(110, 136, 255, 0.8);\n  border: 2px solid #4e58bf;\n  border-radius: 10px;\n  cursor: pointer;\n  min-width: 180px;\n  height: auto;\n  padding-bottom: 6px;\n  box-sizing: content-box;\n  position: relative;\n  user-select: none; }\n  .node:hover {\n    background: rgba(130, 153, 255, 0.8); }\n  .node.selected {\n    background: #ffd92c;\n    border-color: #e3c000; }\n  .node .title {\n    color: white;\n    font-family: sans-serif;\n    font-size: 18px;\n    padding: 8px; }\n  .node .output {\n    text-align: right; }\n  .node .input {\n    text-align: left; }\n  .node .input-title, .node .output-title {\n    vertical-align: middle;\n    color: white;\n    display: inline-block;\n    font-family: sans-serif;\n    font-size: 14px;\n    margin: 6px;\n    line-height: 24px; }\n  .node .input-control {\n    z-index: 1;\n    width: calc(100% - 36px);\n    vertical-align: middle;\n    display: inline-block; }\n  .node .control {\n    padding: 6px 18px; }\n\n/*# sourceMappingURL=Node.vue.map */"]},media:void 0})}),Mu,"data-v-61cff9dc",!1,void 0,Pu,void 0);function Wu(e,t,n){var r=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},o=new Kc(Nu({render:function(e){return e(t,{props:n})}},r)),i=document.createElement("div");return e.appendChild(i),o.$mount(i),o}var Hu,Yu=function(e){return new Promise((function(t){if(!e.vueContext)return t();e.vueContext.$forceUpdate(),e.vueContext.$nextTick(t)}))},qu={name:"vue-render",install:function(e,t){var n=t.component,r=t.options;e.on("rendernode",(function(t){var o=t.el,i=t.node,a=t.component,s=t.bindSocket,c=t.bindControl;a.render&&"vue"!==a.render||(i._vue=function(e,t,n,r){var o=n.node,i=n.component,a=n.bindSocket,s=n.bindControl,c=Wu(n.el,i.component||t||Vu,Nu({},i.props,{node:o,editor:e,bindSocket:a,bindControl:s}),r);return o.vueContext=c.$children[0],c}(e,n,{el:o,node:i,component:a,bindSocket:s,bindControl:c},r),i.update=Iu(regeneratorRuntime.mark((function e(){return regeneratorRuntime.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:return e.next=2,Yu(i);case 2:return e.abrupt("return",e.sent);case 3:case"end":return e.stop()}}),e)}))))})),e.on("rendercontrol",(function(e){var t=e.el,n=e.control;n.render&&"vue"!==n.render||(n._vue=function(e,t,n){var r=t.control,o=Wu(t.el,r.component,Nu({},r.props,{getData:r.getData.bind(r),putData:r.putData.bind(r)}),n);return r.vueContext=o.$children[0],o}(0,{el:t,control:n},r),n.update=Iu(regeneratorRuntime.mark((function e(){return regeneratorRuntime.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:return e.next=2,Yu(n);case 2:return e.abrupt("return",e.sent);case 3:case"end":return e.stop()}}),e)}))))})),e.on("connectioncreated connectionremoved",(function(e){Yu(e.output.node),Yu(e.input.node)})),e.on("nodeselected",(function(){e.nodes.map(Yu)}))},mixin:Tu,Node:Vu,Socket:zu},Ku=new Uint8Array(16);function Ju(){if(!Hu&&!(Hu="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto)||"undefined"!=typeof msCrypto&&"function"==typeof msCrypto.getRandomValues&&msCrypto.getRandomValues.bind(msCrypto)))throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return Hu(Ku)}for(var Zu=/^(?:[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|00000000-0000-0000-0000-000000000000)$/i,Xu=function(e){return"string"==typeof e&&Zu.test(e)},Gu=[],Qu=0;Qu<256;++Qu)Gu.push((Qu+256).toString(16).substr(1));var el=function(e,t,n){var r=(e=e||{}).random||(e.rng||Ju)();if(r[6]=15&r[6]|64,r[8]=63&r[8]|128,t){n=n||0;for(var o=0;o<16;++o)t[n+o]=r[o];return t}return function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,n=(Gu[e[t+0]]+Gu[e[t+1]]+Gu[e[t+2]]+Gu[e[t+3]]+"-"+Gu[e[t+4]]+Gu[e[t+5]]+"-"+Gu[e[t+6]]+Gu[e[t+7]]+"-"+Gu[e[t+8]]+Gu[e[t+9]]+"-"+Gu[e[t+10]]+Gu[e[t+11]]+Gu[e[t+12]]+Gu[e[t+13]]+Gu[e[t+14]]+Gu[e[t+15]]).toLowerCase();if(!Xu(n))throw TypeError("Stringified UUID is invalid");return n}(r)},tl=function(){var e=this,t=e.$createElement,n=e._self._c||t;return n("div",{staticClass:"node",class:[e.selected(),e.node.type]},["source"!==e.node.type?n("div",{staticClass:"mx-3 mb-3 text-center"},[n("strong",[e._v(e._s(e.node.name))])]):e._e(),e._v(" "),n("div",{staticClass:"content"},[e.node.inputs.size>0?n("div",{staticClass:"column"},e._l(e.inputs(),(function(t){return n("div",{key:t.key,staticClass:"input"},[n("socket",{directives:[{name:"socket",rawName:"v-socket:input",value:t,expression:"input",arg:"input"}],attrs:{type:"input",socket:t.socket,used:t.connections.length>0}}),e._v("\n        "+e._s(t.name)+" "),t.param&&t.param.required?n("strong",[e._v("*")]):e._e()],1)})),0):e._e(),e._v(" "),e.node.controls.size>0?n("div",{staticClass:"column"},e._l(e.controls(),(function(e){return n("div",{directives:[{name:"control",rawName:"v-control",value:e,expression:"control"}],key:e.key,staticClass:"control"})})),0):e._e(),e._v(" "),e.node.outputs.size>0?n("div",{staticClass:"column"},e._l(e.outputs(),(function(t){return n("div",{key:t.key,staticClass:"output"},[e._v("\n        "+e._s(t.name)+"\n        "),n("socket",{directives:[{name:"socket",rawName:"v-socket:output",value:t,expression:"output",arg:"output"}],attrs:{type:"output",socket:t.socket,used:t.connections.length>0}})],1)})),0):e._e()])])};tl._withStripped=!0;var nl=function(){var e=this,t=e.$createElement;return(e._self._c||t)("div",{staticClass:"socket",class:e._f("kebab")([e.type,e.socket.name,e.used?"used":""])})};nl._withStripped=!0;var rl={extends:qu.Socket,props:{used:Boolean}};function ol(e,t,n,r,o,i,a,s){var c,u="function"==typeof e?e.options:e;if(t&&(u.render=t,u.staticRenderFns=n,u._compiled=!0),r&&(u.functional=!0),i&&(u._scopeId="data-v-"+i),a?(c=function(e){(e=e||this.$vnode&&this.$vnode.ssrContext||this.parent&&this.parent.$vnode&&this.parent.$vnode.ssrContext)||"undefined"==typeof __VUE_SSR_CONTEXT__||(e=__VUE_SSR_CONTEXT__),o&&o.call(this,e),e&&e._registeredComponents&&e._registeredComponents.add(a)},u._ssrRegister=c):o&&(c=s?function(){o.call(this,(u.functional?this.parent:this).$root.$options.shadowRoot)}:o),c)if(u.functional){u._injectStyles=c;var l=u.render;u.render=function(e,t){return c.call(t),l(e,t)}}else{var d=u.beforeCreate;u.beforeCreate=d?[].concat(d,c):[c]}return{exports:e,options:u}}n(4540);var il=ol(rl,nl,[],!1,null,"1d1d3241",null);il.options.__file="kadi/assets/scripts/lib/workflows/core/Socket.vue";var al=il.exports,sl={mixins:[qu.mixin],components:{Socket:al},mounted(){for(const e of this.controls()){e.vueContext.$on("change-value",(()=>this.editor.trigger("controlchanged",e)));for(const[t,n]of Object.entries(e.events))this.editor.on(t,n)}}},cl=(n(6139),ol(sl,tl,[],!1,null,"36a5d6d0",null));cl.options.__file="kadi/assets/scripts/lib/workflows/core/Node.vue";var ul=cl.exports;const ll={str:new re.Socket("str"),int:new re.Socket("int"),float:new re.Socket("float"),bool:new re.Socket("bool"),dep:new re.Socket("dep"),env:new re.Socket("env"),stdio:new re.Socket("stdio")},dl={dep:{key:"dependency",title:"Dependencies",socket:ll.dep,multi:!0},env:{key:"env",title:"env",socket:ll.env},stdio:{key:"pipe",title:"stdin",socket:ll.stdio}},pl={dep:{key:"dependency",title:"Dependents",socket:ll.dep,multi:!0},env:{key:"env",title:"env",socket:ll.env},stdio:{key:"pipe",title:"stdout",socket:ll.stdio}},fl=[dl.dep,dl.env,dl.stdio],hl=fl.map((e=>e.key)),vl=[pl.dep,pl.env,pl.stdio];function ml(e){return new re.Input(e.key,e.title,e.socket,e.multi||!1)}function gl(e){return new re.Output(e.key,e.title,e.socket,e.multi||!1)}function yl(e,t,n,r){return e.param?{name:e.param.name,type:e.param.type,required:e.param.required,shortName:e.param.char,port_direction:t,port_index:r,position:n}:{name:e.name,type:e.key,required:!1,shortName:"",port_direction:t,port_index:r,position:0}}class bl extends re.Component{constructor(e,t){super(e),this.type=t,this.data.component=ul}builder(e){return"number"==typeof e.id&&(e.id=`{${el()}}`),e}fromFlow(e){return{id:e.id,name:e.model.name,data:{},inputs:new Map,outputs:new Map,position:[e.position.x,e.position.y]}}toFlow(e){return{id:e.id,model:{name:e.name},position:{x:e.position[0],y:e.position[1]}}}}class Al extends bl{constructor(e,t,n,r=[],o=[]){super(e,t),this.menu=n,this.inputs=r,this.outputs=o}builder(e){const t=super.builder(e);t.type=this.type;for(const e of this.inputs)t.addInput(ml(e));for(const e of this.outputs)t.addOutput(gl(e));return t}fromFlow(e){const t=super.fromFlow(e);for(const e of this.inputs)t.inputs.set(e.key,{connections:[]});for(const e of this.outputs)t.outputs.set(e.key,{connections:[]});return t}}class wl extends bl{constructor(e){super(wl.nameFromTool(e),"tool"),this.tool=e}static nameFromTool(e){return null!==e.version?`${e.name} ${e.version}`:e.name}static toolFromFlow(e){const t=e.model.tool,n={name:t.name,path:t.name,version:t.version,param:[]};for(const t of e.model.tool.ports)if(!hl.includes(t.type)){const e={name:t.name,char:t.shortName,type:t.type,required:t.required};n.param.push(e)}return n}builder(e){const t=super.builder(e);t.type=this.type;for(const e of vl)t.addOutput(gl(e));t.addInput(ml(fl[0]));for(let e=0;e<this.tool.param.length;e++){const n=this.tool.param[e],r=n.name||`arg${e}`;let o=null;switch(n.type){case"string":o=new re.Input(`in${e}`,`String: ${r}`,ll.str);break;case"int":case"long":o=new re.Input(`in${e}`,`Integer: ${r}`,ll.int);break;case"float":case"real":o=new re.Input(`in${e}`,`Float: ${r}`,ll.float);break;case"bool":case"flag":o=new re.Input(`in${e}`,`Boolean: ${r}`,ll.bool);break;default:o=new re.Input(`in${e}`,`${kadi.utils.capitalize(n.type)}: ${r}`,ll.str)}o.param={name:n.name,char:n.char,type:n.type,required:n.required||!1},t.addInput(o)}for(const e of fl.slice(1))t.addInput(ml(e));return t}fromFlow(e){const t=super.fromFlow(e);t.name=wl.nameFromTool(e.model.tool);let n=0;for(const r of e.model.tool.ports)"in"===r.port_direction?hl.includes(r.type)?t.inputs.set(r.type,{connections:[]}):t.inputs.set("in"+n++,{connections:[]}):t.outputs.set(r.type,{connections:[]});return t}toFlow(e){const t=super.toFlow(e);t.model={name:"ToolNode",tool:{name:this.tool.name,path:this.tool.name,version:this.tool.version,ports:[]}};let n=e.inputs.values(),r=1;for(let o=0;o<e.inputs.size;o++){const e=yl(n.next().value,"in",r++,o);t.model.tool.ports.push(e)}n=e.outputs.values(),r=1;for(let o=0;o<e.outputs.size;o++){const e=yl(n.next().value,"out",r++,o);t.model.tool.ports.push(e)}return t}}function Cl(e,t){let n=t;for(const t of e)if(--n<0)return t;return null}class xl extends re.NodeEditor{fromFlow(e){const t={id:e.id||this.id,nodes:{}};let n=null;for(const r of e.nodes){if("ToolNode"===r.model.name){const e=wl.nameFromTool(r.model.tool);if(!this.components.has(e)){const e=wl.toolFromFlow(r);this.register(new wl(e))}n=this.components.get(e).fromFlow(r)}else{const e=this.components.get(r.model.name);if(!e)continue;n=e.fromFlow(r)}t.nodes[r.id]=n}for(const n of e.connections){const e=t.nodes[n.out_id],r=t.nodes[n.in_id];if(e&&r){const t=Cl(e.outputs.keys(),n.out_index),o=Cl(r.inputs.keys(),n.in_index),i=e.outputs.get(t),a=r.inputs.get(o);i&&a&&(i.connections.push({node:r.id,input:o,data:{}}),a.connections.push({node:e.id,output:t,data:{}}))}}for(const e in t.nodes)t.nodes[e].outputs=Object.fromEntries(t.nodes[e].outputs),t.nodes[e].inputs=Object.fromEntries(t.nodes[e].inputs);return this.fromJSON(t)}toFlow(){const e={id:this.id,connections:[],nodes:[]};for(const t of this.nodes){const n=this.components.get(t.name).toFlow(t),r=t.outputs.values();for(let n=0;n<t.outputs.size;n++){const o=r.next().value;for(const r of o.connections){const o=[...r.input.node.inputs.keys()],i={in_id:r.input.node.id,in_index:o.findIndex((e=>e===r.input.key)),out_id:t.id,out_index:n};e.connections.push(i)}}e.nodes.push(n)}return e}}var kl=function(){var e=this,t=e.$createElement,n=e._self._c||t;return e.visible?n("div",{ref:"menu",staticClass:"context-menu",style:e.style,on:{mouseleave:function(e){e.preventDefault()},mouseover:function(e){e.preventDefault()},contextmenu:function(e){e.preventDefault()},wheel:function(e){e.stopPropagation()}}},[e.searchBar?n("search",{on:{search:e.onSearch},model:{value:e.filter,callback:function(t){e.filter=t},expression:"filter"}}):e._e(),e._v(" "),e._l(e.filtered,(function(t){return n("item",{key:t.title,attrs:{item:t,args:e.args,delay:e.delay/2}})}))],2):e._e()};kl._withStripped=!0;var Bl={extends:_u,name:"Item",methods:{onClick(e){e.stopPropagation(),this.item.onClick&&this.item.onClick(this.args),this.item.keepOpen||this.$root.$emit("hide")}}},_l=(n(4771),ol(Bl,void 0,void 0,!1,null,"39e4b361",null));_l.options.__file="kadi/assets/scripts/lib/workflows/core/Item.vue";var $l=_l.exports,Sl=function(){var e=this,t=e.$createElement,n=e._self._c||t;return n("div",{staticClass:"search"},[n("input",{directives:[{name:"model",rawName:"v-model",value:e.value_,expression:"value_"}],attrs:{placeholder:"Filter"},domProps:{value:e.value_},on:{pointerdown:function(e){e.stopPropagation()},input:function(t){t.target.composing||(e.value_=t.target.value)}}})])};Sl._withStripped=!0;var El={extends:$u,data:()=>({value_:""}),watch:{value(){this.value_=this.value},value_(){this.$emit("search",this.value_)}}},Il=(n(7980),ol(El,Sl,[],!1,null,"1e315414",null));Il.options.__file="kadi/assets/scripts/lib/workflows/core/Search.vue";var Ol={extends:Bu,components:{Item:$l,Search:Il.exports},data:()=>({maxItems:5}),watch:{filter(){this.maxItems=5}},computed:{filtered(){if(!this.filter)return this.items;const e=new RegExp(this.filter,"i"),t=[];for(const n of this.extractLeafs(this.items))if(this.searchKeep(n.title)||n.title.match(e)){if(t.length===this.maxItems){t.push({title:"...",onClick:()=>this.maxItems+=5,keepOpen:!0});break}t.push(n)}return t}}},Nl=(n(1835),ol(Ol,kl,[],!1,null,"608f70a6",null));Nl.options.__file="kadi/assets/scripts/lib/workflows/core/Menu.vue";var Tl=Nl.exports;class Ll extends re.Control{constructor(e,t,n){super(e),this.component=t,this.props={ikey:e,defaultValue:n},this.events={}}}const Dl={props:{getData:Function,putData:Function,ikey:String},data:()=>({value:null}),watch:{value(){this.validateValue(),this.ikey&&this.putData(this.ikey,this.value),this.$emit("change-value")}},methods:{validateValue(){}},mounted(){this.value=this.getData(this.ikey),void 0===this.value&&(void 0!==this.defaultValue?this.value=this.defaultValue:this.value=null)}};var jl=function(){var e=this,t=e.$createElement,n=e._self._c||t;return n("div",[n("span",{staticClass:"mr-2"},[e._v(e._s(e.title))]),e._v(" "),n("input",{directives:[{name:"model",rawName:"v-model.number",value:e.value,expression:"value",modifiers:{number:!0}}],staticClass:"input",attrs:{type:"number"},domProps:{value:e.value},on:{pointerdown:function(e){e.stopPropagation()},input:function(t){t.target.composing||(e.value=e._n(t.target.value))},blur:function(t){return e.$forceUpdate()}}})])};jl._withStripped=!0;var Rl={mixins:[Dl],props:{title:String,defaultValue:Number},methods:{validateValue(){isNaN(this.value)?this.value=this.defaultValue:this.value>99?this.value=99:this.value<0?this.value=0:this.value=Math.floor(this.value)}}},Pl=(n(8962),ol(Rl,jl,[],!1,null,"64888255",null));Pl.options.__file="kadi/assets/scripts/lib/workflows/controls/PortControl.vue";var Fl=Pl.exports;class zl extends Ll{constructor(e,t){super(e,Fl,3),this.props.title=t}}const Ml="control",Ul="Control";var Vl=[new Al("Variable",Ml,Ul,[dl.dep,{key:"name",title:"Name",socket:ll.str},{key:"value",title:"Value",socket:ll.str}],[pl.dep]),new Al("IfBranch",Ml,Ul,[dl.dep,{key:"condition",title:"Condition",socket:ll.bool}],[pl.dep,{key:"true",title:"True",socket:ll.dep},{key:"false",title:"False",socket:ll.dep}]),new Al("Loop",Ml,Ul,[dl.dep,{key:"condition",title:"Condition",socket:ll.bool},{key:"startIndex",title:"Start Index [0]",socket:ll.int},{key:"endIndex",title:"End Index",socket:ll.int},{key:"indexVarName",title:"Index Variable Name",socket:ll.str}],[pl.dep,{key:"loop",title:"Loop",socket:ll.dep},{key:"index",title:"Index",socket:ll.int}]),new class extends Al{constructor(){super("BranchSelect",Ml,Ul,[dl.dep,{key:"selected",title:"Selected",socket:ll.int}],[pl.dep])}builder(e){const t=super.builder(e);return t.prevBranches=0,t.addControl(new zl("branches","Branches")),this.editor.on("controlchanged",(e=>{e.parent===t&&this.setBranches(t)})),t}fromFlow(e){const t=super.fromFlow(e);t.data.branches=e.model.nBranches;for(let e=0;e<t.data.branches;e++)t.outputs.set(`branch${e}`,{connections:[]});return t}toFlow(e){const t=super.toFlow(e);return t.model.nBranches=e.data.branches,t}setBranches(e){const t=e.data.branches;if(t>e.prevBranches)for(let n=e.prevBranches;n<t;n++)e.addOutput(new re.Output(`branch${n}`,`Branch ${n+1}`,ll.dep));else for(let n=t;n<e.prevBranches;n++){const t=e.outputs.get(`branch${n}`);for(const e of t.connections)this.editor.removeConnection(e);e.removeOutput(t)}e.vueContext.$forceUpdate(),e.prevBranches=t}}],Wl=function(){var e=this,t=e.$createElement,n=e._self._c||t;return n("div",{staticClass:"form-check form-check-inline"},[n("input",{directives:[{name:"model",rawName:"v-model",value:e.value,expression:"value"}],staticClass:"form-check-input",attrs:{type:"checkbox",id:e.id},domProps:{checked:Array.isArray(e.value)?e._i(e.value,null)>-1:e.value},on:{pointerdown:function(e){e.stopPropagation()},change:function(t){var n=e.value,r=t.target,o=!!r.checked;if(Array.isArray(n)){var i=e._i(n,null);r.checked?i<0&&(e.value=n.concat([null])):i>-1&&(e.value=n.slice(0,i).concat(n.slice(i+1)))}else e.value=o}}}),e._v(" "),n("label",{staticClass:"form-check-label",attrs:{for:e.id}},[e._v("Shortcut")])])};Wl._withStripped=!0;var Hl=ol({mixins:[Dl],data:()=>({id:kadi.utils.randomAlnum()}),props:{defaultValue:Boolean}},Wl,[],!1,null,null,null);Hl.options.__file="kadi/assets/scripts/lib/workflows/controls/ShortcutControl.vue";var Yl=Hl.exports;class ql extends Ll{constructor(e){super(e,Yl,!1)}}const Kl="File I/O";var Jl=[new Al("FileInput","io",Kl,[dl.dep,{key:"path",title:"File Path",socket:ll.str}],[pl.dep,pl.stdio]),new class extends Al{constructor(){super("FileOutput","io",Kl,[dl.dep,{key:"path",title:"File Path",socket:ll.str},{key:"append",title:"Append",socket:ll.bool},dl.stdio],[pl.dep])}builder(e){const t=super.builder(e);return t.addControl(new ql("shortcut")),t}fromFlow(e){const t=super.fromFlow(e);return t.data.shortcut=e.model.createShortcut,t}toFlow(e){const t=super.toFlow(e);return t.model.createShortcut=e.data.shortcut,t}}],Zl=function(){var e=this,t=e.$createElement;return(e._self._c||t)("input",{directives:[{name:"model",rawName:"v-model",value:e.value,expression:"value"}],staticClass:"align-middle",attrs:{type:"checkbox"},domProps:{checked:Array.isArray(e.value)?e._i(e.value,null)>-1:e.value},on:{pointerdown:function(e){e.stopPropagation()},change:function(t){var n=e.value,r=t.target,o=!!r.checked;if(Array.isArray(n)){var i=e._i(n,null);r.checked?i<0&&(e.value=n.concat([null])):i>-1&&(e.value=n.slice(0,i).concat(n.slice(i+1)))}else e.value=o}}})};Zl._withStripped=!0;var Xl=ol({mixins:[Dl],props:{defaultValue:Boolean}},Zl,[],!1,null,null,null);Xl.options.__file="kadi/assets/scripts/lib/workflows/controls/CheckboxControl.vue";var Gl=Xl.exports,Ql=function(){var e=this,t=e.$createElement;return(e._self._c||t)("input",{directives:[{name:"model",rawName:"v-model.number",value:e.value,expression:"value",modifiers:{number:!0}}],staticClass:"form-control d-inline",domProps:{value:e.value},on:{pointerdown:function(e){e.stopPropagation()},input:function(t){t.target.composing||(e.value=e._n(t.target.value))},blur:function(t){return e.$forceUpdate()}}})};Ql._withStripped=!0;var ed=ol({mixins:[Dl],props:{defaultValue:Number},methods:{validateValue(){isNaN(this.value)&&(this.value=this.defaultValue)}}},Ql,[],!1,null,null,null);ed.options.__file="kadi/assets/scripts/lib/workflows/controls/FloatControl.vue";var td=ed.exports,nd=function(){var e=this,t=e.$createElement;return(e._self._c||t)("input",{directives:[{name:"model",rawName:"v-model.number",value:e.value,expression:"value",modifiers:{number:!0}}],staticClass:"form-control d-inline",domProps:{value:e.value},on:{pointerdown:function(e){e.stopPropagation()},input:function(t){t.target.composing||(e.value=e._n(t.target.value))},blur:function(t){return e.$forceUpdate()}}})};nd._withStripped=!0;var rd=ol({mixins:[Dl],props:{defaultValue:Number},methods:{validateValue(){isNaN(this.value)?this.value=this.defaultValue:this.value=Math.floor(this.value)}}},nd,[],!1,null,null,null);rd.options.__file="kadi/assets/scripts/lib/workflows/controls/IntControl.vue";var od=rd.exports,id=function(){var e=this,t=e.$createElement;return(e._self._c||t)("input",{directives:[{name:"model",rawName:"v-model",value:e.value,expression:"value"}],staticClass:"form-control d-inline",domProps:{value:e.value},on:{pointerdown:function(e){e.stopPropagation()},input:function(t){t.target.composing||(e.value=t.target.value)}}})};id._withStripped=!0;var ad=ol({mixins:[Dl],props:{defaultValue:String}},id,[],!1,null,null,null);ad.options.__file="kadi/assets/scripts/lib/workflows/controls/TextControl.vue";var sd=ad.exports;class cd extends Al{constructor(e,t,n){super(e,"source","Source",[],[{key:"out",title:e,socket:t,multi:!0}]),this.widget=n}builder(e){const t=super.builder(e);return t.addControl(new this.widget("value")),t}fromFlow(e){const t=super.fromFlow(e);return t.data.value=e.model.value,t}toFlow(e){const t=super.toFlow(e);return t.model.value=String(e.data.value),t}}var ud=[new cd("String",ll.str,class extends Ll{constructor(e){super(e,sd,"")}}),new cd("Integer",ll.int,class extends Ll{constructor(e){super(e,od,0)}}),new cd("Float",ll.float,class extends Ll{constructor(e){super(e,td,0)}}),new cd("Boolean",ll.bool,class extends Ll{constructor(e){super(e,Gl,!1)}})];const ld="user-input",dd="User Input",pd=[dl.dep,{key:"prompt",title:"Prompt",socket:ll.str}],fd={key:"value",title:"Value"};var hd=[new Al("UserInputText",ld,dd,pd,[pl.dep,{...fd,socket:ll.str}]),new Al("UserInputInteger",ld,dd,pd,[pl.dep,{...fd,socket:ll.int}]),new Al("UserInputFloat",ld,dd,pd,[pl.dep,{...fd,socket:ll.float}]),new Al("UserInputBool",ld,dd,pd,[pl.dep,{...fd,socket:ll.bool}]),new Al("UserInputFile",ld,dd,pd,[pl.dep,{...fd,socket:ll.str}]),new Al("UserInputCropImages",ld,dd,pd.concat([{key:"imagePath",title:"Image Path",socket:ll.str}]),[pl.dep,{key:"cropInfo",title:"Crop Info",socket:ll.str}]),new class extends Al{constructor(){super("UserInputChoose",ld,dd,pd,[pl.dep,{key:"selected",title:"Selected",socket:ll.int}])}builder(e){const t=super.builder(e);return t.addControl(new zl("options","Options")),t.prevOptions=0,this.editor.on("controlchanged",(e=>{e.parent===t&&this.setOptions(t)})),t}fromFlow(e){const t=super.fromFlow(e);t.data.options=e.model.nOptions;for(let e=0;e<t.data.options;e++)t.inputs.set(`option${e}`,{connections:[]});return t}toFlow(e){const t=super.toFlow(e);return t.model.nOptions=e.data.options,t}setOptions(e){const t=e.data.options;if(t>e.prevOptions)for(let n=e.prevOptions;n<t;n++)e.addInput(new re.Input(`option${n}`,`Option ${n+1}`,ll.str));else for(let n=t;n<e.prevOptions;n++){const t=e.inputs.get(`option${n}`);for(const e of t.connections)this.editor.removeConnection(e);e.removeInput(t)}e.vueContext.$forceUpdate(),e.prevOptions=t}}],vd=[new Al("UserOutputText","user-output","User Output",[dl.dep,{key:"file",title:"Text File",socket:ll.str}],[pl.dep])],md=(n(3227),{data:()=>({version:"kadi@0.1.0",editor:null,area:null,unsavedChanges_:!1,toolDialogActive:!1,menuItems:{},currX:0,currY:0,resizeHandler:null,beforeunloadHandler:null}),props:{editable:{type:Boolean,default:!0},workflowUrl:{type:String,default:null},toolsEndpoint:{type:String,default:null},unsavedChanges:{type:Boolean,default:!1},isRendered:{type:Boolean,default:!0},enableDebugMenu:{type:Boolean,default:!1}},watch:{workflowUrl(){this.loadWorkflow()},unsavedChanges(){this.unsavedChanges_=this.unsavedChanges},unsavedChanges_(){this.$emit("unsaved-changes",this.unsavedChanges_)},isRendered(){this.resizeView(!1)}},methods:{isFullscreen:()=>document.fullScreen||document.mozFullScreen||document.webkitIsFullScreen,resetView(){this.area.zoomAt(this.editor)},toggleFullscreen(){this.isFullscreen()?document.exitFullscreen():this.$refs.container.requestFullscreen()},resetEditor(){confirm("Are you sure you want to reset the editor?")&&(this.editor.clear(),this.unsavedChanges_=!1)},resizeView(e=!0){if(!this.isRendered)return;const t=this.$refs.editorContainer.getBoundingClientRect().width;this.isFullscreen()?(this.$refs.editorContainer.style.height="100vh",this.$refs.editorContainer.style.borderRadius="0"):(this.$refs.editorContainer.style.height=`${Math.round(window.innerHeight/window.innerWidth*t)}px`,this.$refs.editorContainer.style.borderRadius="0.25rem"),this.editor.view.resize(),e&&this.resetView()},loadWorkflow(){this.workflowUrl&&axios.get(this.workflowUrl).then((e=>{try{this.editor.fromFlow(e.data).then((e=>{e||kadi.alert("Could not fully reconstruct workflow.",{type:"warning"})})).catch((e=>{console.error(e),kadi.alert("Error parsing workflow data.")})).finally((()=>this.resetView()))}catch(e){console.error(e),kadi.alert("Error parsing workflow data.")}}))},addTool(e){const t=wl.nameFromTool(e);this.editor.components.has(t)||this.editor.register(new wl(e)),this.addNode(this.editor.components.get(t))},async addNode(e){const t=await e.createNode();t.position[0]=this.currX,t.position[1]=this.currY,this.editor.addNode(t)}},mounted(){if(this.editor=new xl(this.version,this.$refs.editor),this.area=f,!this.editable){let e=e=>{Array.from(this.$refs.editorToolbar.getElementsByTagName("*")).includes(e.target)||(e.preventDefault(),e.stopPropagation())};this.$refs.editorContainer.addEventListener("click",e,{capture:!0}),e=e=>{e.target!==this.$refs.editor&&(e.preventDefault(),e.stopPropagation())},this.$refs.editorContainer.addEventListener("pointerdown",e,{capture:!0}),this.$refs.editorContainer.addEventListener("pointerup",e,{capture:!0}),e=e=>{e.preventDefault(),e.stopPropagation()},this.$refs.editorContainer.addEventListener("dblclick",e,{capture:!0}),this.$refs.editorContainer.addEventListener("contextmenu",e,{capture:!0})}this.editor.use(f),this.editor.use(ge),this.editor.use(qu),this.editor.use(Su,{vueComponent:Tl,searchBar:!0,delay:0,items:this.menuItems,allocate:()=>null}),[...ud,...Vl,...Jl,...hd,...vd].forEach((e=>this.editor.register(e))),this.toolsEndpoint&&(this.menuItems["Select Tools..."]=()=>{this.toolDialogActive=!0,$(this.$refs.toolDialog).modal({backdrop:!1})},$(this.$refs.toolDialog).on("hidden.bs.modal",(()=>{this.toolDialogActive=!1})));for(const e of this.editor.components.values())this.menuItems[e.menu]||(this.menuItems[e.menu]={}),this.menuItems[e.menu][e.name]=()=>this.addNode(e);this.enableDebugMenu&&(this.menuItems.Debug={"Dump Flow":()=>console.info(this.editor.toFlow()),"Dump JSON":()=>console.info(this.editor.toJSON())}),this.editor.on("click",(()=>{this.editor.selected.clear(),this.editor.nodes.map((e=>e.update()))})),this.editor.on("zoom",(({source:e})=>"dblclick"!==e)),this.editor.bind("controlchanged"),this.editor.on("controlchanged nodecreated noderemoved nodetranslated connectioncreated connectionremoved",(()=>{this.editor.silent||(this.unsavedChanges_=!0)})),this.editor.on("showcontextmenu",(({e:e})=>{const t=this.editor.view.area,n=t.el.getBoundingClientRect();this.currX=(e.clientX-n.left)/t.transform.k,this.currY=(e.clientY-n.top)/t.transform.k})),this.resizeView(),this.loadWorkflow(),this.resizeHandler=window.addEventListener("resize",this.resizeView),this.beforeunloadHandler=window.addEventListener("beforeunload",(e=>{if(this.unsavedChanges_)return e.preventDefault(),(e||window.event).returnValue="",""}))},beforeDestroy(){this.resizeHandler&&window.removeEventListener("resize",this.resizeHandler),this.beforeunloadHandler&&window.removeEventListener("beforeunload",this.beforeunloadHandler)}}),gd=(n(7658),ol(md,e,[],!1,null,"aed02304",null));gd.options.__file="kadi/assets/scripts/lib/components/WorkflowEditor.vue";var yd=gd.exports;new Vue({el:"#vm",components:{WorkflowEditor:yd},data:{previewData:null,initialized:!1},mounted(){axios.get(kadi.js_resources.get_file_preview_endpoint).then((e=>{this.previewData=e.data,this.initialized=!0})).catch((e=>{404!==e.request.status?kadi.alert(i18n.t("error.loadFilePreview"),{xhr:e.request}):this.initialized=!0}))}})}()}();
//# sourceMappingURL=view-file.js.map